#include "SYSTEM_.h"

#ifndef DEFINITION_rSystem
#include "rSystem.h"
#endif

#ifndef DEFINITION_rMemory
#include "rMemory.h"
#endif

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_Sets
#include "Sets.h"
#endif

#ifndef DEFINITION_Errors
#include "Errors.h"
#endif

#ifndef DEFINITION_Scanner
#include "Scanner.h"
#endif

#ifndef DEFINITION_Parser
#include "Parser.h"
#endif

#ifndef DEFINITION_Tree
#include "Tree.h"
#endif

#ifndef DEFINITION_Semantics
#include "Semantics.h"
#endif

#ifndef DEFINITION_Order
#include "Order.h"
#endif

#ifndef DEFINITION_Dialog
#include "Dialog.h"
#endif

#ifndef DEFINITION_GramMod
#include "GramMod.h"
#endif

#ifndef DEFINITION_GramC
#include "GramC.h"
#endif

#ifndef DEFINITION_GramYacc
#include "GramYacc.h"
#endif

static Strings_tString CgLib, DefFile, TreeFile, EvalFile, String, PathS;
static struct S_1 {
    CHAR A[255 + 1];
} Argument, PathA;
static SHORTCARD j;
static CHAR ch;
static Sets_tSet AllOptions;
static BOOLEAN HasArgs;
static IO_tFile SmartOpen ARGS((Strings_tString FileName));
static void SmartClose ARGS((Strings_tString FileName, IO_tFile f));


static IO_tFile SmartOpen
# ifdef __STDC__
(Strings_tString FileName)
# else
(FileName)
Strings_tString FileName;
# endif
{
  Strings_tString PathS;

  if (Sets_IsElement(ORD('7'), &Tree_Options)) {
    Strings_ArrayToString((STRING)"yy", 2L, &PathS);
    Strings_Concatenate(&PathS, &FileName);
    Strings_Append(&PathS, '\0');
    Strings_StringToArray(&PathS, PathA.A, 256L);
  } else {
    Strings_Append(&FileName, '\0');
    Strings_StringToArray(&FileName, PathA.A, 256L);
  }
  return IO_WriteOpen(PathA.A, 256L);
}

static void SmartClose
# ifdef __STDC__
(Strings_tString FileName, IO_tFile f)
# else
(FileName, f)
Strings_tString FileName;
IO_tFile f;
# endif
{
  Strings_tString PathS;

  IO_WriteClose(f);
  if (Sets_IsElement(ORD('7'), &Tree_Options)) {
    Strings_ArrayToString((STRING)"gmdupd ", 7L, &PathS);
    Strings_Concatenate(&PathS, &FileName);
    Strings_ArrayToString((STRING)" yy", 3L, &String);
    Strings_Concatenate(&PathS, &String);
    Strings_Concatenate(&PathS, &FileName);
    Strings_Append(&PathS, '\0');
    Strings_StringToArray(&PathS, PathA.A, 256L);
    j = rSystem(PathA.A, 256L);
  }
}

void BEGIN_MODULE()
{
  BEGIN_rSystem();
  BEGIN_rMemory();
  BEGIN_IO();
  BEGIN_Strings();
  BEGIN_Idents();
  BEGIN_Sets();
  BEGIN_Errors();
  BEGIN_Scanner();
  BEGIN_Parser();
  BEGIN_Tree();
  BEGIN_Semantics();
  BEGIN_Order();
  BEGIN_Dialog();
  BEGIN_GramMod();
  BEGIN_GramC();
  BEGIN_GramYacc();

  Strings_AssignEmpty(&CgLib);
  Tree_SourceFile.A[0] = '\0';
  Scanner_ArgCount = GetArgCount() - 1;
  HasArgs = FALSE;
  Scanner_CurArg = 0;
  for (;;) {
    INC(Scanner_CurArg);
    if (Scanner_CurArg > Scanner_ArgCount) {
      goto EXIT_1;
    }
    GetArgument(Scanner_CurArg, Argument.A, 256L);
    if (Argument.A[0] == '-') {
      if (Argument.A[1] == 'l') {
        Strings_AssignEmpty(&CgLib);
        j = 2;
        for (;;) {
          ch = Argument.A[j];
          if (ch == '\0') {
            goto EXIT_2;
          }
          Strings_Append(&CgLib, ch);
          INC(j);
        } EXIT_2:;
        Strings_Append(&CgLib, '/');
      } else {
        j = 0;
        for (;;) {
          INC(j);
          ch = Argument.A[j];
          if (ch == '\0') {
            goto EXIT_3;
          } else if (ch == '?') {
            Sets_Include(&Tree_Options, ORD('h'));
          } else {
            Sets_Include(&Tree_Options, ORD(ch));
          }
        } EXIT_3:;
        HasArgs = TRUE;
      }
    } else if (Argument.A[0] == '?') {
      Sets_Include(&Tree_Options, ORD('h'));
      HasArgs = TRUE;
    } else {
      j = 0;
      do {
        ch = Argument.A[j];
        Tree_SourceFile.A[j] = ch;
        INC(j);
      } while (!(ch == '\0'));
      goto EXIT_1;
    }
  } EXIT_1:;
  if (!HasArgs) {
    Sets_Include(&Tree_Options, ORD('x'));
    Sets_Include(&Tree_Options, ORD('z'));
  }
  if (Sets_IsElement(ORD('x'), &Tree_Options) || Sets_IsElement(ORD('z'), &Tree_Options) || Sets_IsElement(ORD('u'), &Tree_Options)) {
    Sets_Include(&Tree_Options, ORD('.'));
    Sets_Include(&Tree_Options, ORD('B'));
  }
  if (Sets_IsElement(ORD('h'), &Tree_Options)) {
    Sets_Exclude(&Tree_Options, ORD('h'));
    Tree_f = IO_StdOutput;
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)"usage: lpp [-options] [files]", 29L);
    IO_WriteNl(Tree_f);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" x generate scanner specification", 33L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" z generate parser  specification for lalr", 42L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" u generate parser  specification for yacc", 42L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" v omit actions in the generated parser specifications", 54L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" j allow undefined node types; define implicitly as terminals", 61L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" c generate C code (default: Modula-2)", 38L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" h print help information for tree/graph module", 47L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" 1 print inserted copy rules", 28L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" 2 print inherited attribute computation rules", 46L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" 6 generate # line directives", 29L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" 7 touch output files only if necessary", 39L);
    IO_WriteNl(Tree_f);
    IO_WriteS(Tree_f, (STRING)" 8 report storage consumption", 29L);
    IO_WriteNl(Tree_f);
  }
  if (!Sets_IsEmpty(Tree_Options)) {
    if (Sets_IsElement(ORD('c'), &Tree_Options)) {
      Strings_ArrayToString((STRING)"int", 3L, &String);
    } else {
      Strings_ArrayToString((STRING)"INTEGER", 7L, &String);
    }
    Tree_iInteger = Idents_MakeIdent(&String);
    if (Tree_SourceFile.A[0] != '\0') {
      Scanner_BeginFile(Tree_SourceFile.A, 256L);
      Strings_ArrayToString(Tree_SourceFile.A, 256L, &String);
      Scanner_Attribute.Position.File = Idents_MakeIdent(&String);
    }
    Errors_StoreMessages(TRUE);
    Tree_ErrorCount = Parser_Parser();
    Tree_BeginTree2();
    Semantics_Semantics(Tree_TreeRoot);
    if (Tree_ErrorCount > 0) {
      Errors_WriteMessages((rSystem_tFile)IO_StdError);
      IO_CloseIO();
      rExit(1L);
    }
  }
  if (Sets_IsElement(ORD('x'), &Tree_Options)) {
    if (Tree_TreeRoot->U_1.V_26.Ag.ScannerName == Idents_NoIdent) {
      Strings_ArrayToString((STRING)"Scanner", 7L, &PathS);
    } else {
      Idents_GetString(Tree_TreeRoot->U_1.V_26.Ag.ScannerName, &PathS);
    }
    Strings_ArrayToString((STRING)".rpp", 4L, &String);
    Strings_Concatenate(&PathS, &String);
    Tree_f = SmartOpen(PathS);
    if (Sets_IsElement(ORD('c'), &Tree_Options)) {
      GramC_ScanSpec(Tree_TreeRoot);
    } else {
      GramMod_ScanSpec(Tree_TreeRoot);
    }
    SmartClose(PathS, Tree_f);
  }
  if (Sets_IsElement(ORD('z'), &Tree_Options)) {
    Idents_GetString(Tree_TreeRoot->U_1.V_26.Ag.ParserName, &Tree_ModuleName);
    Strings_Assign(&PathS, &Tree_ModuleName);
    Strings_ArrayToString((STRING)".lalr", 5L, &String);
    Strings_Concatenate(&PathS, &String);
    Tree_f = SmartOpen(PathS);
    if (Sets_IsElement(ORD('c'), &Tree_Options)) {
      GramC_ParsSpec(Tree_TreeRoot);
    } else {
      GramMod_ParsSpec(Tree_TreeRoot);
    }
    SmartClose(PathS, Tree_f);
  } else if (Sets_IsElement(ORD('u'), &Tree_Options)) {
    Idents_GetString(Tree_TreeRoot->U_1.V_26.Ag.ParserName, &Tree_ModuleName);
    Strings_Assign(&PathS, &Tree_ModuleName);
    Strings_ArrayToString((STRING)".y", 2L, &String);
    Strings_Concatenate(&PathS, &String);
    Tree_f = SmartOpen(PathS);
    GramYacc_ParsSpec(Tree_TreeRoot);
    SmartClose(PathS, Tree_f);
  }
  if (Sets_IsElement(ORD('.'), &Tree_Options)) {
    Order_Order(Tree_TreeRoot);
  }
  Errors_WriteMessages((rSystem_tFile)IO_StdError);
  if (Sets_IsElement(ORD('Q'), &Tree_Options)) {
    Tree_QueryTree(Tree_TreeRoot);
  }
  if (Sets_IsElement(ORD('J'), &Tree_Options)) {
    Dialog_Dialog(Tree_TreeRoot);
  }
  if (Tree_ErrorCount > 0) {
    IO_CloseIO();
    rExit(1L);
  }
  if (Sets_IsElement(ORD('8'), &Tree_Options)) {
    IO_WriteNl((rSystem_tFile)IO_StdError);
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)"Memory", 6L);
    IO_WriteI((rSystem_tFile)IO_StdError, (LONGINT)rMemory_MemoryUsed, 8L);
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)"  Heap", 6L);
    IO_WriteI((rSystem_tFile)IO_StdError, (LONGINT)Tree_HeapUsed, 8L);
    IO_WriteNl((rSystem_tFile)IO_StdError);
  }
  IO_CloseIO();
  rExit(0L);
}
