#include "SYSTEM_.h"

#ifndef DEFINITION_Convert
#include "Convert.h"
#endif

#ifndef DEFINITION_Derivable
#include "Derivable.h"
#endif

#ifndef DEFINITION_DynArray
#include "DynArray.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_Scanner
#include "Scanner.h"
#endif

#ifndef DEFINITION_Sets
#include "Sets.h"
#endif

#ifndef DEFINITION_Stack
#include "Stack.h"
#endif

#ifndef DEFINITION_Table
#include "Table.h"
#endif

#ifndef DEFINITION_Types
#include "Types.h"
#endif

#ifndef DEFINITION_Tree
#include "Tree.h"
#endif

#ifndef DEFINITION_First
#include "First.h"
#endif


static Sets_tSet vLeftRec;
static void LocalFirst ARGS((Tree_tTree t, Sets_tSet *first));
static void LocalFirsts ARGS(());
struct S_1_GlobalFirsts;
static void GlobalFirsts ARGS(());
struct S_1 {
    INTEGER A[1000 + 1];
};
static void Traverse ARGS((struct S_1_GlobalFirsts *link, Idents_tIdent x));
struct S_1_GlobalFirsts {
  Stack_tStack *S;
  struct S_1 **N;
  Sets_tSet *X;
  Sets_tSet *Terms;
  Sets_tSet *Nonterms;
  INTEGER *infinite;
};
static void TreeFirst ARGS((Tree_tTree t));
static void TreeFirsts ARGS(());

static void LocalFirst
# ifdef __STDC__
(Tree_tTree t, Sets_tSet *first)
# else
(t, first)
Tree_tTree t;
Sets_tSet *first;
# endif
{
  Sets_tSet set;

  switch (t->U_1.V_1.Kind) {
  case Tree_Option:;
    LocalFirst(t->U_1.V_33.Option.expr, first);
    Sets_Include(first, (LONGCARD)Scanner_Epsilon);
    break;
  case Tree_Times:;
    LocalFirst(t->U_1.V_34.Times.expr, first);
    Sets_Include(first, (LONGCARD)Scanner_Epsilon);
    break;
  case Tree_Plus:;
    LocalFirst(t->U_1.V_35.Plus.expr, first);
    break;
  case Tree_List:;
    LocalFirst(t->U_1.V_36.List.body, first);
    if (Sets_IsElement((LONGCARD)Scanner_Epsilon, first)) {
      Sets_Exclude(first, (LONGCARD)Scanner_Epsilon);
      Sets_MakeSet(&set, (LONGCARD)Idents_MaxIdent());
      LocalFirst(t->U_1.V_36.List.sep, &set);
      Sets_Union(first, set);
      Sets_ReleaseSet(&set);
    }
    break;
  case Tree_Action:;
    Sets_AssignElmt(first, (LONGCARD)Scanner_Epsilon);
    break;
  case Tree_Leaf:;
    Sets_AssignElmt(first, (LONGCARD)t->U_1.V_38.Leaf.id->U_1.V_23.Id.ident);
    if (Derivable_IsNullable(t->U_1.V_38.Leaf.id->U_1.V_23.Id.ident)) {
      Sets_Include(first, (LONGCARD)Scanner_Epsilon);
    }
    break;
  case Tree_Alternative0:;
    Sets_AssignEmpty(first);
    break;
  case Tree_Alternative:;
    LocalFirst(t->U_1.V_41.Alternative.expr, first);
    Sets_MakeSet(&set, (LONGCARD)Idents_MaxIdent());
    LocalFirst(t->U_1.V_41.Alternative.alternative, &set);
    Sets_Union(first, set);
    Sets_ReleaseSet(&set);
    break;
  case Tree_Sequence0:;
    Sets_AssignElmt(first, (LONGCARD)Scanner_Epsilon);
    break;
  case Tree_Sequence:;
    LocalFirst(t->U_1.V_44.Sequence.expr, first);
    if (Sets_IsElement((LONGCARD)Scanner_Epsilon, first)) {
      Sets_Exclude(first, (LONGCARD)Scanner_Epsilon);
      Sets_MakeSet(&set, (LONGCARD)Idents_MaxIdent());
      LocalFirst(t->U_1.V_44.Sequence.sequence, &set);
      Sets_Union(first, set);
      Sets_ReleaseSet(&set);
    }
    break;
  }
}

static void LocalFirsts
# ifdef __STDC__
()
# else
()
# endif
{
  Sets_tSet N, F;
  Idents_tIdent n;

  Sets_MakeSet(&N, (LONGCARD)Idents_MaxIdent());
  Sets_MakeSet(&F, (LONGCARD)Idents_MaxIdent());
  Types_Nonterminals(&N);
  while (!Sets_IsEmpty(N)) {
    n = Sets_Extract(&N);
    LocalFirst(Table_Expr(n), &F);
    Table_SetFirst(n, F);
  }
  Sets_ReleaseSet(&F);
  Sets_ReleaseSet(&N);
}

static void Traverse
# ifdef __STDC__
(struct S_1_GlobalFirsts *link, Idents_tIdent x)
# else
(link, x)
struct S_1_GlobalFirsts *link;
Idents_tIdent x;
# endif
{
  INTEGER d;
  Sets_tSet Y;
  Idents_tIdent y;
  Sets_tSet Fx, Fy;

  Sets_MakeSet(&Fx, (LONGCARD)Idents_MaxIdent());
  Sets_MakeSet(&Fy, (LONGCARD)Idents_MaxIdent());
  Sets_MakeSet(&Y, (LONGCARD)Idents_MaxIdent());
  Stack_Push(link->S, Convert_IdToAdr(x));
  d = Stack_Depth(*link->S);
  (*link->N)->A[x] = d;
  Table_First(x, &Fx);
  Sets_Intersection(&Fx, *link->Terms);
  Table_First(x, &Y);
  Sets_Intersection(&Y, *link->Nonterms);
  while (!Sets_IsEmpty(Y)) {
    y = Sets_Extract(&Y);
    if (y == x) {
      Sets_Include(&vLeftRec, (LONGCARD)y);
    } else if (Sets_IsElement((LONGCARD)y, link->X)) {
      Sets_Exclude(link->X, (LONGCARD)y);
      Traverse(link, y);
    }
    if ((*link->N)->A[y] < (*link->N)->A[x]) {
      (*link->N)->A[x] = (*link->N)->A[y];
    }
    Table_First(y, &Fy);
    Sets_Intersection(&Fy, *link->Terms);
    Sets_Exclude(&Fy, (LONGCARD)Scanner_Epsilon);
    Sets_Union(&Fx, Fy);
  }
  Table_SetFirst(x, Fx);
  if ((*link->N)->A[x] == d) {
    if (Convert_AdrToId(Stack_Top(link->S)) == x) {
      y = Convert_AdrToId(Stack_Pop(link->S));
      (*link->N)->A[y] = *link->infinite;
    } else {
      do {
        y = Convert_AdrToId(Stack_Pop(link->S));
        (*link->N)->A[y] = *link->infinite;
        Table_SetFirst(y, Fx);
        Sets_Include(&vLeftRec, (LONGCARD)y);
      } while (!(y == x));
    }
  }
  Sets_ReleaseSet(&Y);
  Sets_ReleaseSet(&Fx);
  Sets_ReleaseSet(&Fy);
}

static void GlobalFirsts
# ifdef __STDC__
()
# else
()
# endif
{
  Stack_tStack S;
  struct S_1 *N;
  Sets_tSet X;
  Sets_tSet Terms;
  Sets_tSet Nonterms;
  INTEGER infinite;
  LONGINT s;
  Idents_tIdent x;
  struct S_1_GlobalFirsts frame;

  frame.S = &S;
  frame.N = &N;
  frame.X = &X;
  frame.Terms = &Terms;
  frame.Nonterms = &Nonterms;
  frame.infinite = &infinite;
  Sets_MakeSet(&vLeftRec, (LONGCARD)Idents_MaxIdent());
  infinite = Idents_MaxIdent() + 1;
  Stack_MakeStack(&S);
  s = Idents_MaxIdent() + 1;
  DynArray_MakeArray((ADDRESS *)&N, &s, (LONGINT)sizeof(INTEGER));
  {
    SHORTCARD B_1 = 0, B_2 = Idents_MaxIdent();

    if (B_1 <= B_2)
      for (x = B_1;; x += 1) {
        N->A[x] = 0;
        if (x >= B_2) break;
      }
  }
  Sets_MakeSet(&Terms, (LONGCARD)Idents_MaxIdent());
  Types_Terminals(&Terms);
  Sets_MakeSet(&Nonterms, (LONGCARD)Idents_MaxIdent());
  Types_Nonterminals(&Nonterms);
  Sets_MakeSet(&X, (LONGCARD)Idents_MaxIdent());
  Types_Nonterminals(&X);
  while (!Sets_IsEmpty(X)) {
    x = Sets_Extract(&X);
    Traverse(&frame, x);
  }
  Sets_ReleaseSet(&Terms);
  Sets_ReleaseSet(&Nonterms);
  Sets_ReleaseSet(&X);
  DynArray_ReleaseArray((ADDRESS *)&N, &s, (LONGINT)sizeof(INTEGER));
  Stack_ReleaseStack(&S);
}

BOOLEAN First_IsLeftRec
# ifdef __STDC__
(Idents_tIdent nt)
# else
(nt)
Idents_tIdent nt;
# endif
{
  return Sets_IsElement((LONGCARD)nt, &vLeftRec);
}

static void TreeFirst
# ifdef __STDC__
(Tree_tTree t)
# else
(t)
Tree_tTree t;
# endif
{
  Sets_tSet set;

  Sets_MakeSet(&t->U_1.V_32.expr.first, (LONGCARD)Idents_MaxIdent());
  switch (t->U_1.V_1.Kind) {
  case Tree_Option:;
    {
      register Tree_yOption *W_1 = &t->U_1.V_33.Option;

      TreeFirst(W_1->expr);
      Sets_Assign(&W_1->first, W_1->expr->U_1.V_32.expr.first);
      Sets_Include(&W_1->first, (LONGCARD)Scanner_Epsilon);
    }
    break;
  case Tree_Times:;
    {
      register Tree_yTimes *W_2 = &t->U_1.V_34.Times;

      TreeFirst(W_2->expr);
      Sets_Assign(&W_2->first, W_2->expr->U_1.V_32.expr.first);
      Sets_Include(&W_2->first, (LONGCARD)Scanner_Epsilon);
    }
    break;
  case Tree_Plus:;
    {
      register Tree_yPlus *W_3 = &t->U_1.V_35.Plus;

      TreeFirst(W_3->expr);
      Sets_Assign(&W_3->first, W_3->expr->U_1.V_32.expr.first);
    }
    break;
  case Tree_List:;
    {
      register Tree_yList *W_4 = &t->U_1.V_36.List;

      TreeFirst(W_4->body);
      Sets_Assign(&W_4->first, W_4->body->U_1.V_32.expr.first);
      TreeFirst(W_4->sep);
      if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &W_4->first)) {
        Sets_Exclude(&W_4->first, (LONGCARD)Scanner_Epsilon);
        Sets_Union(&W_4->first, W_4->sep->U_1.V_32.expr.first);
      }
    }
    break;
  case Tree_Action:;
    {
      register Tree_yAction *W_5 = &t->U_1.V_37.Action;

      Sets_AssignElmt(&W_5->first, (LONGCARD)Scanner_Epsilon);
    }
    break;
  case Tree_Leaf:;
    {
      register Tree_yLeaf *W_6 = &t->U_1.V_38.Leaf;

      Table_First(W_6->id->U_1.V_23.Id.ident, &W_6->first);
    }
    break;
  case Tree_Alternative0:;
    {
      register Tree_yAlternative0 *W_7 = &t->U_1.V_40.Alternative0;

      Sets_AssignEmpty(&W_7->first);
    }
    break;
  case Tree_Alternative:;
    {
      register Tree_yAlternative *W_8 = &t->U_1.V_41.Alternative;

      TreeFirst(W_8->expr);
      Sets_Assign(&W_8->first, W_8->expr->U_1.V_32.expr.first);
      TreeFirst(W_8->alternative);
      Sets_Union(&W_8->first, W_8->alternative->U_1.V_32.expr.first);
    }
    break;
  case Tree_Sequence0:;
    {
      register Tree_ySequence0 *W_9 = &t->U_1.V_43.Sequence0;

      Sets_AssignElmt(&W_9->first, (LONGCARD)Scanner_Epsilon);
    }
    break;
  case Tree_Sequence:;
    {
      register Tree_ySequence *W_10 = &t->U_1.V_44.Sequence;

      TreeFirst(W_10->expr);
      Sets_Assign(&W_10->first, W_10->expr->U_1.V_32.expr.first);
      TreeFirst(W_10->sequence);
      if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &W_10->first)) {
        Sets_Exclude(&W_10->first, (LONGCARD)Scanner_Epsilon);
        Sets_Union(&W_10->first, W_10->sequence->U_1.V_32.expr.first);
      }
    }
    break;
  }
}

static void TreeFirsts
# ifdef __STDC__
()
# else
()
# endif
{
  Sets_tSet N;
  Idents_tIdent n;

  Sets_MakeSet(&N, (LONGCARD)Idents_MaxIdent());
  Types_Nonterminals(&N);
  while (!Sets_IsEmpty(N)) {
    n = Sets_Extract(&N);
    TreeFirst(Table_Expr(n));
  }
  Sets_ReleaseSet(&N);
}

void First_Firsts
# ifdef __STDC__
()
# else
()
# endif
{
  LocalFirsts();
  GlobalFirsts();
  TreeFirsts();
}

void BEGIN_First()
{
  static BOOLEAN has_been_called = FALSE;
  if (has_been_called) return;
  has_been_called = TRUE;
    BEGIN_Idents();
    BEGIN_Convert();
    BEGIN_Derivable();
    BEGIN_DynArray();
    BEGIN_Idents();
    BEGIN_Scanner();
    BEGIN_Sets();
    BEGIN_Stack();
    BEGIN_Table();
    BEGIN_Types();
    BEGIN_Tree();

}
