#include "SYSTEM_.h"

#ifndef DEFINITION_Convert
#include "Convert.h"
#endif

#ifndef DEFINITION_DynArray
#include "DynArray.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_Scanner
#include "Scanner.h"
#endif

#ifndef DEFINITION_Sets
#include "Sets.h"
#endif

#ifndef DEFINITION_Stack
#include "Stack.h"
#endif

#ifndef DEFINITION_Table
#include "Table.h"
#endif

#ifndef DEFINITION_Tree
#include "Tree.h"
#endif

#ifndef DEFINITION_Types
#include "Types.h"
#endif

#ifndef DEFINITION_Follow
#include "Follow.h"
#endif


static void Start ARGS((Idents_tIdent start));
static void LocalFollow ARGS((Tree_tTree t, Sets_tSet follow));
static void LocalFollows ARGS(());
struct S_1_GlobalFollows;
static void GlobalFollows ARGS(());
struct S_1 {
    INTEGER A[1000 + 1];
};
static void Traverse ARGS((struct S_1_GlobalFollows *link, Idents_tIdent x));
struct S_1_GlobalFollows {
  Stack_tStack *S;
  struct S_1 **N;
  Sets_tSet *X;
  Sets_tSet *Terms;
  Sets_tSet *Nonterms;
  INTEGER *infinite;
};
static void TreeFollow ARGS((Tree_tTree t, Sets_tSet follow));
static void TreeFollows ARGS(());

static void Start
# ifdef __STDC__
(Idents_tIdent start)
# else
(start)
Idents_tIdent start;
# endif
{
  Sets_tSet F;

  Sets_MakeSet(&F, (LONGCARD)Idents_MaxIdent());
  Sets_AssignElmt(&F, (LONGCARD)Scanner_EndOfToken);
  Table_ExtendFollow(start, F);
  Sets_ReleaseSet(&F);
}

static void LocalFollow
# ifdef __STDC__
(Tree_tTree t, Sets_tSet follow)
# else
(t, follow)
Tree_tTree t;
Sets_tSet follow;
# endif
{
  Sets_tSet s;

  switch (t->U_1.V_1.Kind) {
  case Tree_Option:;
    LocalFollow(t->U_1.V_33.Option.expr, follow);
    break;
  case Tree_Times:;
    Sets_MakeSet(&s, (LONGCARD)Idents_MaxIdent());
    Sets_Assign(&s, follow);
    Sets_Union(&s, t->U_1.V_34.Times.first);
    Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
    LocalFollow(t->U_1.V_34.Times.expr, s);
    Sets_ReleaseSet(&s);
    break;
  case Tree_Plus:;
    Sets_MakeSet(&s, (LONGCARD)Idents_MaxIdent());
    Sets_Assign(&s, follow);
    Sets_Union(&s, t->U_1.V_35.Plus.first);
    Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
    LocalFollow(t->U_1.V_35.Plus.expr, s);
    Sets_ReleaseSet(&s);
    break;
  case Tree_List:;
    Sets_MakeSet(&s, (LONGCARD)Idents_MaxIdent());
    Sets_Assign(&s, t->U_1.V_36.List.sep->U_1.V_32.expr.first);
    if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &s)) {
      Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
      Sets_Union(&s, t->U_1.V_36.List.body->U_1.V_32.expr.first);
      if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &s)) {
        Sets_Union(&s, t->U_1.V_36.List.sep->U_1.V_32.expr.first);
        Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
      }
    }
    Sets_Union(&s, follow);
    LocalFollow(t->U_1.V_36.List.body, s);
    Sets_Assign(&s, t->U_1.V_36.List.body->U_1.V_32.expr.first);
    if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &s)) {
      Sets_Union(&s, t->U_1.V_36.List.sep->U_1.V_32.expr.first);
      Sets_Union(&s, follow);
      Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
    }
    LocalFollow(t->U_1.V_36.List.sep, s);
    Sets_ReleaseSet(&s);
    break;
  case Tree_Action:;
    break;
  case Tree_Leaf:;
    {
      register Tree_yId *W_1 = &t->U_1.V_38.Leaf.id->U_1.V_23.Id;

      if (Types_IsNonterm(W_1->ident)) {
        Table_ExtendFollow(W_1->ident, follow);
      }
    }
    break;
  case Tree_Alternative0:;
    break;
  case Tree_Alternative:;
    LocalFollow(t->U_1.V_41.Alternative.expr, follow);
    LocalFollow(t->U_1.V_41.Alternative.alternative, follow);
    break;
  case Tree_Sequence0:;
    break;
  case Tree_Sequence:;
    Sets_MakeSet(&s, (LONGCARD)Idents_MaxIdent());
    Sets_Assign(&s, t->U_1.V_44.Sequence.sequence->U_1.V_32.expr.first);
    if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &s)) {
      Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
      Sets_Union(&s, follow);
    }
    LocalFollow(t->U_1.V_44.Sequence.expr, s);
    Sets_ReleaseSet(&s);
    LocalFollow(t->U_1.V_44.Sequence.sequence, follow);
    break;
  }
}

static void LocalFollows
# ifdef __STDC__
()
# else
()
# endif
{
  Sets_tSet N;
  Sets_tSet F;
  Idents_tIdent n;

  Sets_MakeSet(&N, (LONGCARD)Idents_MaxIdent());
  Sets_MakeSet(&F, (LONGCARD)Idents_MaxIdent());
  Types_Nonterminals(&N);
  while (!Sets_IsEmpty(N)) {
    n = Sets_Extract(&N);
    Sets_AssignElmt(&F, (LONGCARD)n);
    LocalFollow(Table_Expr(n), F);
  }
  Sets_ReleaseSet(&N);
  Sets_ReleaseSet(&F);
}

static void Traverse
# ifdef __STDC__
(struct S_1_GlobalFollows *link, Idents_tIdent x)
# else
(link, x)
struct S_1_GlobalFollows *link;
Idents_tIdent x;
# endif
{
  INTEGER d;
  Sets_tSet Y;
  Idents_tIdent y;
  Sets_tSet Fx, Fy;

  Sets_MakeSet(&Fx, (LONGCARD)Idents_MaxIdent());
  Sets_MakeSet(&Fy, (LONGCARD)Idents_MaxIdent());
  Sets_MakeSet(&Y, (LONGCARD)Idents_MaxIdent());
  Stack_Push(link->S, Convert_IdToAdr(x));
  d = Stack_Depth(*link->S);
  (*link->N)->A[x] = d;
  Table_Follow(x, &Fx);
  Sets_Intersection(&Fx, *link->Terms);
  Table_Follow(x, &Y);
  Sets_Intersection(&Y, *link->Nonterms);
  while (!Sets_IsEmpty(Y)) {
    y = Sets_Extract(&Y);
    if (Sets_IsElement((LONGCARD)y, link->X)) {
      Sets_Exclude(link->X, (LONGCARD)y);
      Traverse(link, y);
    }
    if ((*link->N)->A[y] < (*link->N)->A[x]) {
      (*link->N)->A[x] = (*link->N)->A[y];
    }
    Table_Follow(y, &Fy);
    Sets_Intersection(&Fy, *link->Terms);
    Sets_Union(&Fx, Fy);
  }
  Table_SetFollow(x, Fx);
  if ((*link->N)->A[x] == d) {
    do {
      y = Convert_AdrToId(Stack_Pop(link->S));
      (*link->N)->A[y] = *link->infinite;
      Table_SetFollow(y, Fx);
    } while (!(y == x));
  }
  Sets_ReleaseSet(&Fx);
  Sets_ReleaseSet(&Fy);
  Sets_ReleaseSet(&Y);
}

static void GlobalFollows
# ifdef __STDC__
()
# else
()
# endif
{
  Stack_tStack S;
  struct S_1 *N;
  Sets_tSet X;
  Sets_tSet Terms, Nonterms;
  INTEGER infinite;
  LONGINT s;
  Idents_tIdent x;
  struct S_1_GlobalFollows frame;

  frame.S = &S;
  frame.N = &N;
  frame.X = &X;
  frame.Terms = &Terms;
  frame.Nonterms = &Nonterms;
  frame.infinite = &infinite;
  infinite = Idents_MaxIdent() + 1;
  Stack_MakeStack(&S);
  s = Idents_MaxIdent() + 1;
  DynArray_MakeArray((ADDRESS *)&N, &s, (LONGINT)sizeof(INTEGER));
  {
    SHORTCARD B_1 = 0, B_2 = Idents_MaxIdent();

    if (B_1 <= B_2)
      for (x = B_1;; x += 1) {
        N->A[x] = 0;
        if (x >= B_2) break;
      }
  }
  Sets_MakeSet(&Terms, (LONGCARD)Idents_MaxIdent());
  Types_Terminals(&Terms);
  Sets_MakeSet(&Nonterms, (LONGCARD)Idents_MaxIdent());
  Types_Nonterminals(&Nonterms);
  Sets_MakeSet(&X, (LONGCARD)Idents_MaxIdent());
  Types_Nonterminals(&X);
  while (!Sets_IsEmpty(X)) {
    x = Sets_Extract(&X);
    Traverse(&frame, x);
  }
  Sets_ReleaseSet(&Terms);
  Sets_ReleaseSet(&Nonterms);
  Sets_ReleaseSet(&X);
  DynArray_ReleaseArray((ADDRESS *)&N, &s, (LONGINT)sizeof(INTEGER));
  Stack_ReleaseStack(&S);
}

static void TreeFollow
# ifdef __STDC__
(Tree_tTree t, Sets_tSet follow)
# else
(t, follow)
Tree_tTree t;
Sets_tSet follow;
# endif
{
  Sets_tSet s;

  Sets_MakeSet(&t->U_1.V_32.expr.follow, (LONGCARD)Idents_MaxIdent());
  Sets_Assign(&t->U_1.V_32.expr.follow, follow);
  Sets_MakeSet(&t->U_1.V_32.expr.fifo, (LONGCARD)Idents_MaxIdent());
  Sets_Assign(&t->U_1.V_32.expr.fifo, t->U_1.V_32.expr.first);
  if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &t->U_1.V_32.expr.fifo)) {
    Sets_Exclude(&t->U_1.V_32.expr.fifo, (LONGCARD)Scanner_Epsilon);
    Sets_Union(&t->U_1.V_32.expr.fifo, t->U_1.V_32.expr.follow);
  }
  switch (t->U_1.V_1.Kind) {
  case Tree_Option:;
    TreeFollow(t->U_1.V_33.Option.expr, follow);
    break;
  case Tree_Times:;
    Sets_MakeSet(&s, (LONGCARD)Idents_MaxIdent());
    Sets_Assign(&s, follow);
    Sets_Union(&s, t->U_1.V_34.Times.first);
    Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
    TreeFollow(t->U_1.V_34.Times.expr, s);
    Sets_ReleaseSet(&s);
    break;
  case Tree_Plus:;
    Sets_MakeSet(&s, (LONGCARD)Idents_MaxIdent());
    Sets_Assign(&s, follow);
    Sets_Union(&s, t->U_1.V_34.Times.first);
    Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
    TreeFollow(t->U_1.V_35.Plus.expr, s);
    Sets_ReleaseSet(&s);
    break;
  case Tree_List:;
    Sets_MakeSet(&s, (LONGCARD)Idents_MaxIdent());
    Sets_Assign(&s, t->U_1.V_36.List.sep->U_1.V_32.expr.first);
    if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &s)) {
      Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
      Sets_Union(&s, t->U_1.V_36.List.body->U_1.V_32.expr.first);
      if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &s)) {
        Sets_Union(&s, t->U_1.V_36.List.sep->U_1.V_32.expr.first);
        Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
      }
    }
    Sets_Union(&s, follow);
    TreeFollow(t->U_1.V_36.List.body, s);
    Sets_Assign(&s, t->U_1.V_36.List.body->U_1.V_32.expr.first);
    if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &s)) {
      Sets_Union(&s, t->U_1.V_36.List.sep->U_1.V_32.expr.first);
      Sets_Union(&s, follow);
      Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
    }
    TreeFollow(t->U_1.V_36.List.sep, s);
    Sets_ReleaseSet(&s);
    break;
  case Tree_Action:;
    break;
  case Tree_Leaf:;
    break;
  case Tree_Alternative0:;
    break;
  case Tree_Alternative:;
    TreeFollow(t->U_1.V_41.Alternative.expr, follow);
    TreeFollow(t->U_1.V_41.Alternative.alternative, follow);
    break;
  case Tree_Sequence0:;
    break;
  case Tree_Sequence:;
    Sets_MakeSet(&s, (LONGCARD)Idents_MaxIdent());
    Sets_Assign(&s, t->U_1.V_44.Sequence.sequence->U_1.V_32.expr.first);
    if (Sets_IsElement((LONGCARD)Scanner_Epsilon, &s)) {
      Sets_Exclude(&s, (LONGCARD)Scanner_Epsilon);
      Sets_Union(&s, follow);
    }
    TreeFollow(t->U_1.V_44.Sequence.expr, s);
    Sets_ReleaseSet(&s);
    TreeFollow(t->U_1.V_44.Sequence.sequence, follow);
    break;
  }
}

static void TreeFollows
# ifdef __STDC__
()
# else
()
# endif
{
  Sets_tSet N;
  Sets_tSet F;
  Idents_tIdent n;

  Sets_MakeSet(&N, (LONGCARD)Idents_MaxIdent());
  Sets_MakeSet(&F, (LONGCARD)Idents_MaxIdent());
  Types_Nonterminals(&N);
  while (!Sets_IsEmpty(N)) {
    n = Sets_Extract(&N);
    Table_Follow(n, &F);
    TreeFollow(Table_Expr(n), F);
  }
  Sets_ReleaseSet(&N);
  Sets_ReleaseSet(&F);
}

void Follow_Follows
# ifdef __STDC__
(Idents_tIdent start)
# else
(start)
Idents_tIdent start;
# endif
{
  Start(start);
  LocalFollows();
  GlobalFollows();
  TreeFollows();
}

void BEGIN_Follow()
{
  static BOOLEAN has_been_called = FALSE;
  if (has_been_called) return;
  has_been_called = TRUE;
    BEGIN_Idents();
    BEGIN_Convert();
    BEGIN_DynArray();
    BEGIN_Idents();
    BEGIN_Scanner();
    BEGIN_Sets();
    BEGIN_Stack();
    BEGIN_Table();
    BEGIN_Tree();
    BEGIN_Types();

}
