#include "SYSTEM_.h"

#ifndef DEFINITION_Checks
#include "Checks.h"
#endif

#ifndef DEFINITION_rSystem
#include "rSystem.h"
#endif

#ifndef DEFINITION_General
#include "General.h"
#endif

#ifndef DEFINITION_Pack
#include "Pack.h"
#endif

#ifndef DEFINITION_Positions
#include "Positions.h"
#endif

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_DynArray
#include "DynArray.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Source
#include "Source.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_StringMem
#include "StringMem.h"
#endif

#ifndef DEFINITION_Errors
#include "Errors.h"
#endif

#ifndef DEFINITION_ArgCheck
#include "ArgCheck.h"
#endif

#ifndef DEFINITION_Scanner
#include "Scanner.h"
#endif

Idents_tIdent Scanner_Epsilon;
Idents_tIdent Scanner_EndOfToken;
Idents_tIdent Scanner_NoIdent;
StringMem_tStringRef Scanner_NoString;
INTEGER Scanner_TokenLength;
Scanner_tScanAttribute Scanner_Attribute;
PROC Scanner_Exit;

#define SymEqual	1
#define SymColon	2
#define SymPoint	3
#define SymOr	4
#define SymStar	5
#define SymPlus	6
#define SymList	7
#define SymLBrace	8
#define SymRBrace	9
#define SymLBracket	10
#define SymRBracket	11
#define SymEXPORT	12
#define SymGLOBAL	13
#define SymLOCAL	14
#define SymBEGIN	15
#define SymCLOSE	16
#define SymTOKEN	17
#define SymOPER	18
#define SymNONE	19
#define SymLEFT	20
#define SymRIGHT	21
#define SymRULE	22
#define SymPREC	23
#define SymNumber	24
#define SymAction	25
#define SymActionEnd	26
#define SymIdent	27
#define SymString	28
#define SymSCANNER	29
#define SymPARSER	30
#define eStringExceedsInput	20
#define eCommentNotClosed	21
#define eActionNotClosed	22
#define eStringExceedsLine	23
#define eBackSlashInAct	24
#define eIllegalChar	25
#define eError	3
static INTEGER Level;
static Strings_tString TargetCode, s;
#define yyTabSpace	8
#define yyDNoState	0
#define yyFileStackSize	16
#define yyInitBufferSize	(1024 * 8 + 256)
#define yyFirstCh	'\0'
#define yyLastCh	((CHAR)'\177')
#define yyEolCh	'\n'
#define yyEobCh	((CHAR)'\177')
#define yyDStateCount	153
#define yyTableSize	1650
#define yyEobState	41
#define yyDefaultState	42
#define STD	1
#define Action	3
#define Str1	5
#define Str2	7
#define CStr1	9
#define CStr2	11
#define Comment1	13
#define Comment2	15
typedef SHORTCARD yyTableElmt;
typedef yyTableElmt yyStateRange;
typedef yyTableElmt yyTableRange;
typedef struct S_1 {
    yyStateRange Check, Next;
} yyCombType;
typedef yyCombType *yyCombTypePtr;
typedef struct S_11 {
    CHAR A[1000000 + 1];
} *yytChBufferPtr;
typedef CHAR yyChRange;
static struct S_2 {
    LONGCARD A[yyDStateCount + 1];
} yyBasePtr;
static struct S_3 {
    yyStateRange A[yyDStateCount + 1];
} yyDefault;
static struct S_4 {
    yyCombType A[yyTableSize + 1];
} yyComb;
static struct S_5 {
    yyStateRange A[yyDStateCount + 1];
} yyEobTrans;
static struct S_6 {
    CHAR A[yyLastCh + 1];
} yyToLower, yyToUpper;
static struct S_7 {
    yyStateRange A[1000000 + 1];
} *yyStateStack;
static LONGINT yyStateStackSize;
static yyStateRange yyStartState;
static yyStateRange yyPreviousStart;
static CHAR yyCh;
static BOOLEAN yyIsFirstCall;
static rSystem_tFile yySourceFile;
static BOOLEAN yyEof;
static yytChBufferPtr yyChBufferPtr;
static INTEGER yyChBufferStart;
static LONGINT yyChBufferSize;
static INTEGER yyChBufferIndex;
static INTEGER yyBytesRead;
static CARDINAL yyLineCount;
static INTEGER yyLineStart;
static SHORTCARD yyFileStackPtr;
static struct S_8 {
    struct S_9 {
        rSystem_tFile SourceFile;
        BOOLEAN Eof;
        yytChBufferPtr ChBufferPtr;
        INTEGER ChBufferStart;
        LONGINT ChBufferSize;
        INTEGER ChBufferIndex;
        INTEGER BytesRead;
        CARDINAL LineCount;
        INTEGER LineStart;
    } A[yyFileStackSize - 1 + 1];
} yyFileStack;
static void yyInitialize ARGS(());
static void yyStart ARGS((yyStateRange State));
static void yyPrevious ARGS(());
static void yyEcho ARGS(());
static void yyLess ARGS((INTEGER n));
static void yyTab ARGS(());
static void yyTab1 ARGS((INTEGER a));
static void yyTab2 ARGS((INTEGER a, INTEGER b));
static void yyEol ARGS((INTEGER Column));
static void output ARGS((CHAR c));
static void unput ARGS((CHAR c));
static CHAR input ARGS(());
static CARDINAL yyunpackindex;
static void UnpackBaseHandler ARGS((LONGCARD value));
static void UnpackDefaultHandler ARGS((LONGCARD value));
static void UnpackEobTransHandler ARGS((LONGCARD value));
static void UnpackCombHandler ARGS((LONGCARD value));
static void yyInitTables ARGS(());
static void yyErrorMessage ARGS((SHORTCARD ErrorCode));
static void yyExit ARGS(());

void Scanner_ErrorAttribute
# ifdef __STDC__
(INTEGER Token, Scanner_tScanAttribute *Attribute)
# else
(Token, Attribute)
INTEGER Token;
Scanner_tScanAttribute *Attribute;
# endif
{
  switch (Token) {
  case SymNumber:;
    Attribute->U_1.V_1.value = Scanner_NoValue;
    break;
  case SymAction:;
  case SymActionEnd:;
    Attribute->U_1.V_3.ref = Scanner_NoString;
    break;
  case SymIdent:;
  case SymString:;
    Attribute->U_1.V_2.ident = Scanner_NoIdent;
    break;
  default :
    break;
  }
}

INTEGER Scanner_GetToken
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange yyState;
  yyCombTypePtr yyTablePtr;
  BOOLEAN yyRestart;
  INTEGER yyi, yySource, yyTarget, yyChBufferFree;
  Strings_tString String, Word;

  for (;;) {
    yyState = yyStartState;
    Scanner_TokenLength = 0;
    for (;;) {
      for (;;) {
        yyTablePtr = (yyCombTypePtr)(yyBasePtr.A[yyState] + ORD(yyChBufferPtr->A[yyChBufferIndex]) * sizeof(yyCombType));
        if (yyTablePtr->Check != yyState) {
          yyState = yyDefault.A[yyState];
          if (yyState == yyDNoState) {
            goto EXIT_3;
          }
        } else {
          yyState = yyTablePtr->Next;
          INC(Scanner_TokenLength);
          yyStateStack->A[Scanner_TokenLength] = yyState;
          INC(yyChBufferIndex);
        }
      } EXIT_3:;
      for (;;) {
        switch (yyStateStack->A[Scanner_TokenLength]) {
        case 153:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 152:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymColon;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 151:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymPoint;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 147:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymOr;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 150:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymStar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 149:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymPlus;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 148:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymList;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 74:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymLBrace;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 146:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymRBrace;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 145:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymLBracket;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 144:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymRBracket;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 143:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymBEGIN;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 138:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymCLOSE;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 133:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymEXPORT;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 127:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymGLOBAL;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 121:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymLEFT;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 118:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymLOCAL;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 113:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymNONE;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 109:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymOPER;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 105:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymPARSER;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 100:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymPREC;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 96:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymRIGHT;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 92:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymRULE;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 88:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymSCANNER;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 81:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymTOKEN;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 27:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_1.value = Strings_StringToInt(&Word);
          return SymNumber;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 30:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Strings_SubString(&Word, 2, (Strings_tStringIndex)Strings_Length(&Word), &String);
          Scanner_Attribute.U_1.V_2.ident = Idents_MakeIdent(&String);
          return SymIdent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 28:;
        case 77:;
        case 78:;
        case 79:;
        case 80:;
        case 82:;
        case 83:;
        case 84:;
        case 85:;
        case 86:;
        case 87:;
        case 89:;
        case 90:;
        case 91:;
        case 93:;
        case 94:;
        case 95:;
        case 97:;
        case 98:;
        case 99:;
        case 101:;
        case 102:;
        case 103:;
        case 104:;
        case 106:;
        case 107:;
        case 108:;
        case 110:;
        case 111:;
        case 112:;
        case 114:;
        case 115:;
        case 116:;
        case 117:;
        case 119:;
        case 120:;
        case 122:;
        case 123:;
        case 124:;
        case 125:;
        case 126:;
        case 128:;
        case 129:;
        case 130:;
        case 131:;
        case 132:;
        case 134:;
        case 135:;
        case 136:;
        case 137:;
        case 139:;
        case 140:;
        case 141:;
        case 142:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_2.ident = Idents_MakeIdent(&Word);
          return SymIdent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 29:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 76:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Level = 0;
          yyStart(Action);
          Strings_AssignEmpty(&TargetCode);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 75:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Level = 0;
          yyStart(Comment1);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 73:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          yyStart(Comment2);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 26:;
        case 36:;
        case 72:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Errors_ErrorMessage((LONGCARD)eIllegalChar, (LONGCARD)eError, Scanner_Attribute.Position);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 71:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&String);
          if (ArgCheck_LANGUAGE == ArgCheck_C) {
            yyStart(CStr1);
          } else {
            yyStart(Str1);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 70:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&String);
          if (ArgCheck_LANGUAGE == ArgCheck_C) {
            yyStart(CStr2);
          } else {
            yyStart(Str2);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 23:;
        case 35:;
        case 47:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 21:;
        case 33:;
        case 48:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 20:;
        case 32:;
        case 38:;
        case 49:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 19:;
        case 31:;
        case 37:;
        case 50:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 69:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyEol(0L);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 68:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyEol(0L);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 66:;
        case 67:;
          Strings_Append(&String, Strings_Char(&String, 1));
          yyPrevious();
          if (yyStartState == Action) {
            Strings_Concatenate(&TargetCode, &String);
          } else {
            Scanner_Attribute.U_1.V_2.ident = Idents_MakeIdent(&String);
            return SymString;
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 34:;
        case 65:;
          Strings_Append(&String, Strings_Char(&String, 1));
          yyPrevious();
          if (yyStartState == Action) {
            Strings_Concatenate(&TargetCode, &String);
          } else {
            Scanner_Attribute.U_1.V_2.ident = Idents_MakeIdent(&String);
            return SymString;
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 64:;
          Strings_Append(&String, '\t');
          yyTab();
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 63:;
          Errors_ErrorMessage((LONGCARD)eStringExceedsLine, (LONGCARD)eError, Scanner_Attribute.Position);
          Strings_Append(&String, Strings_Char(&String, 1));
          yyEol(0L);
          yyPrevious();
          if (yyStartState == Action) {
            Strings_Concatenate(&TargetCode, &String);
          } else {
            Scanner_Attribute.U_1.V_2.ident = Idents_MakeIdent(&String);
            return SymString;
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 24:;
        case 46:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&TargetCode, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 62:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&TargetCode, &Word);
          Scanner_Attribute.U_1.V_3.ref = StringMem_PutString(&TargetCode);
          Strings_AssignEmpty(&TargetCode);
          yyEol(0L);
          return SymAction;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 61:;
          yyTab();
          Scanner_GetWord(&Word);
          Strings_Concatenate(&TargetCode, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 25:;
          Scanner_GetWord(&Word);
          Strings_Append(&TargetCode, Strings_Char(&Word, 2));
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 22:;
          Errors_ErrorMessage((LONGCARD)eBackSlashInAct, (LONGCARD)eError, Scanner_Attribute.Position);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 60:;
          INC(Level);
          Scanner_GetWord(&Word);
          Strings_Concatenate(&TargetCode, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 59:;
          if (Level == 0) {
            Scanner_Attribute.U_1.V_3.ref = StringMem_PutString(&TargetCode);
            yyStart(STD);
            return SymActionEnd;
          } else {
            DEC(Level);
            Scanner_GetWord(&Word);
            Strings_Concatenate(&TargetCode, &Word);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 18:;
        case 51:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 57:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 55:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 58:;
          INC(Level);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 56:;
          if (Level == 0) {
            yyStart(STD);
          } else {
            DEC(Level);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 17:;
        case 52:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 53:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 54:;
          yyStart(STD);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 45:;
          while (yyChBufferPtr->A[yyChBufferIndex] == ' ') {
            INC(yyChBufferIndex);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 44:;
          DEC1(yyLineStart, 7 - (yyChBufferIndex - yyLineStart - 2) % 8);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 43:;
          INC(yyLineCount);
          yyLineStart = yyChBufferIndex - 1;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 1:;
        case 2:;
        case 3:;
        case 4:;
        case 5:;
        case 6:;
        case 7:;
        case 8:;
        case 9:;
        case 10:;
        case 11:;
        case 12:;
        case 13:;
        case 14:;
        case 15:;
        case 16:;
        case 39:;
        case 40:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          break;
        case 42:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
          INC(yyChBufferIndex);
          Scanner_TokenLength = 1;
          IO_WriteC((rSystem_tFile)IO_StdOutput, yyChBufferPtr->A[yyChBufferIndex - 1]);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case yyDNoState:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 41:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          if (Scanner_TokenLength == 0) {
            yyState = yyStartState;
          } else {
            yyState = yyStateStack->A[Scanner_TokenLength];
          }
          if (yyChBufferIndex != yyChBufferStart + yyBytesRead) {
            yyState = yyEobTrans.A[yyState];
            if (yyState != yyDNoState) {
              INC(yyChBufferIndex);
              INC(Scanner_TokenLength);
              yyStateStack->A[Scanner_TokenLength] = yyState;
              yyRestart = TRUE;
              goto EXIT_4;
            }
          } else {
            yySource = yyChBufferIndex - Scanner_TokenLength - 1;
            yyTarget = General_MaxAlign - Scanner_TokenLength % General_MaxAlign - 1;
            if (yySource != yyTarget) {
              {
                LONGINT B_1 = 1, B_2 = Scanner_TokenLength;

                if (B_1 <= B_2)
                  for (yyi = B_1;; yyi += 1) {
                    yyChBufferPtr->A[yyTarget + yyi] = yyChBufferPtr->A[yySource + yyi];
                    if (yyi >= B_2) break;
                  }
              }
              DEC1(yyLineStart, yySource - yyTarget);
              yyChBufferStart = yyTarget + Scanner_TokenLength + 1;
            } else {
              yyChBufferStart = yyChBufferIndex;
            }
            if (!yyEof) {
              yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
              if (yyChBufferFree < yyChBufferSize / 8) {
                DynArray_ExtendArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
                if (yyChBufferPtr == NIL) {
                  yyErrorMessage(1);
                }
                yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
                if (yyStateStackSize < yyChBufferSize) {
                  DynArray_ExtendArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
                  if (yyStateStack == NIL) {
                    yyErrorMessage(1);
                  }
                }
              }
              yyChBufferIndex = yyChBufferStart;
              yyBytesRead = Source_GetLine(yySourceFile, ADR(yyChBufferPtr->A[yyChBufferIndex]), (LONGCARD)yyChBufferFree);
              if (yyBytesRead <= 0) {
                yyBytesRead = 0;
                yyEof = TRUE;
              }
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead] = yyEobCh;
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead + 1] = '\0';
              yyRestart = TRUE;
              goto EXIT_4;
            }
            if (Scanner_TokenLength == 0) {
              Scanner_Attribute.Position.Line = yyLineCount;
              Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
              Scanner_CloseFile();
              if (yyFileStackPtr == 0) {
                switch (yyStartState) {
                case CStr1:;
                case CStr2:;
                case Str1:;
                case Str2:;
                  Errors_ErrorMessage((LONGCARD)eStringExceedsInput, (LONGCARD)eError, Scanner_Attribute.Position);
                  Strings_Append(&String, Strings_Char(&String, 1));
                  Scanner_Attribute.U_1.V_2.ident = Idents_MakeIdent(&String);
                  yyStart(STD);
                  yyEol(0L);
                  return SymString;
                  break;
                case Comment1:;
                case Comment2:;
                  Errors_ErrorMessage((LONGCARD)eCommentNotClosed, (LONGCARD)eError, Scanner_Attribute.Position);
                  break;
                case Action:;
                  Errors_ErrorMessage((LONGCARD)eActionNotClosed, (LONGCARD)eError, Scanner_Attribute.Position);
                  Scanner_Attribute.U_1.V_3.ref = StringMem_PutString(&TargetCode);
                  yyStart(STD);
                  return SymActionEnd;
                  break;
                default :
                  break;
                }
              }
              if (yyFileStackPtr == 0) {
                return Scanner_EofToken;
              }
              yyRestart = FALSE;
              goto EXIT_4;
            }
          }
          break;
        default :
          yyErrorMessage(0);
          break;
        }
      } EXIT_4:;
      if (yyRestart) {
      } else {
        goto EXIT_2;
      }
    } EXIT_2:;
  } EXIT_1:;
}

void Scanner_BeginFile
# ifdef __STDC__
(CHAR FileName[], LONGCARD O_1)
# else
(FileName, O_1)
CHAR FileName[];
LONGCARD O_1;
# endif
{
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_1 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(FileName, O_1, CHAR)
  if (yyIsFirstCall) {
    yyFileStackPtr = 0;
    yyIsFirstCall = FALSE;
  }
  yyInitialize();
  yySourceFile = Source_BeginSource(FileName, O_1);
  if (yySourceFile < 0) {
    yyErrorMessage(5);
  }
  FREE_OPEN_ARRAYS
}

static void yyInitialize
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr >= yyFileStackSize) {
    yyErrorMessage(3);
  }
  INC(yyFileStackPtr);
  {
    register struct S_9 *W_1 = &yyFileStack.A[yyFileStackPtr - 1];

    W_1->SourceFile = yySourceFile;
    W_1->Eof = yyEof;
    W_1->ChBufferPtr = yyChBufferPtr;
    W_1->ChBufferStart = yyChBufferStart;
    W_1->ChBufferSize = yyChBufferSize;
    W_1->ChBufferIndex = yyChBufferIndex;
    W_1->BytesRead = yyBytesRead;
    W_1->LineCount = yyLineCount;
    W_1->LineStart = yyLineStart;
  }
  yyChBufferSize = yyInitBufferSize;
  DynArray_MakeArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  if (yyChBufferPtr == NIL) {
    yyErrorMessage(1);
  }
  yyChBufferStart = General_MaxAlign;
  yyChBufferPtr->A[yyChBufferStart - 1] = yyEolCh;
  yyChBufferPtr->A[yyChBufferStart] = yyEobCh;
  yyChBufferPtr->A[yyChBufferStart + 1] = '\0';
  yyChBufferIndex = yyChBufferStart;
  yyEof = FALSE;
  yyBytesRead = 0;
  yyLineCount = 1;
  yyLineStart = yyChBufferStart - 1;
}

void Scanner_CloseFile
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr == 0) {
    yyErrorMessage(4);
  }
  Source_CloseSource(yySourceFile);
  DynArray_ReleaseArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  {
    register struct S_9 *W_2 = &yyFileStack.A[yyFileStackPtr - 1];

    yySourceFile = W_2->SourceFile;
    yyEof = W_2->Eof;
    yyChBufferPtr = W_2->ChBufferPtr;
    yyChBufferStart = W_2->ChBufferStart;
    yyChBufferSize = W_2->ChBufferSize;
    yyChBufferIndex = W_2->ChBufferIndex;
    yyBytesRead = W_2->BytesRead;
    yyLineCount = W_2->LineCount;
    yyLineStart = W_2->LineStart;
  }
  DEC(yyFileStackPtr);
}

void Scanner_GetWord
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_3 = 1, B_4 = Scanner_TokenLength;

    if (B_3 <= B_4)
      for (i = B_3;; i += 1) {
        Word->Chars.A[i] = yyChBufferPtr->A[WordStart + i];
        if (i >= B_4) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetLower
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_5 = 1, B_6 = Scanner_TokenLength;

    if (B_5 <= B_6)
      for (i = B_5;; i += 1) {
        Word->Chars.A[i] = yyToLower.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_6) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetUpper
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_7 = 1, B_8 = Scanner_TokenLength;

    if (B_7 <= B_8)
      for (i = B_7;; i += 1) {
        Word->Chars.A[i] = yyToUpper.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_8) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

static void yyStart
# ifdef __STDC__
(yyStateRange State)
# else
(State)
yyStateRange State;
# endif
{
  yyPreviousStart = yyStartState;
  yyStartState = State;
}

static void yyPrevious
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange s;

  s = yyStartState;
  yyStartState = yyPreviousStart;
  yyPreviousStart = s;
}

static void yyEcho
# ifdef __STDC__
()
# else
()
# endif
{
  INTEGER i;

  {
    LONGINT B_9 = yyChBufferIndex - Scanner_TokenLength, B_10 = yyChBufferIndex - 1;

    if (B_9 <= B_10)
      for (i = B_9;; i += 1) {
        IO_WriteC((rSystem_tFile)IO_StdOutput, yyChBufferPtr->A[i]);
        if (i >= B_10) break;
      }
  }
}

static void yyLess
# ifdef __STDC__
(INTEGER n)
# else
(n)
INTEGER n;
# endif
{
  DEC1(yyChBufferIndex, Scanner_TokenLength - n);
  Scanner_TokenLength = n;
}

static void yyTab
# ifdef __STDC__
()
# else
()
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - 2) % yyTabSpace);
}

static void yyTab1
# ifdef __STDC__
(INTEGER a)
# else
(a)
INTEGER a;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyTab2
# ifdef __STDC__
(INTEGER a, INTEGER b)
# else
(a, b)
INTEGER a, b;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyEol
# ifdef __STDC__
(INTEGER Column)
# else
(Column)
INTEGER Column;
# endif
{
  INC(yyLineCount);
  yyLineStart = yyChBufferIndex - 1 - Column;
}

static void output
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  IO_WriteC((rSystem_tFile)IO_StdOutput, c);
}

static void unput
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  DEC(yyChBufferIndex);
  yyChBufferPtr->A[yyChBufferIndex] = c;
}

static CHAR input
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    if (!yyEof) {
      DEC1(yyLineStart, yyBytesRead);
      yyChBufferIndex = 0;
      yyChBufferStart = 0;
      yyBytesRead = Source_GetLine(yySourceFile, (ADDRESS)yyChBufferPtr, (LONGCARD)General_Exp2(General_Log2(yyChBufferSize)));
      if (yyBytesRead <= 0) {
        yyBytesRead = 0;
        yyEof = TRUE;
      }
      yyChBufferPtr->A[yyBytesRead] = yyEobCh;
      yyChBufferPtr->A[yyBytesRead + 1] = '\0';
    }
  }
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    return '\0';
  } else {
    INC(yyChBufferIndex);
    return yyChBufferPtr->A[yyChBufferIndex - 1];
  }
}

void Scanner_BeginScanner
# ifdef __STDC__
()
# else
()
# endif
{
  Strings_ArrayToString((STRING)"_Epsilon", 8L, &s);
  Scanner_Epsilon = Idents_MakeIdent(&s);
  Strings_ArrayToString((STRING)"_EndOfFile", 10L, &s);
  Scanner_EndOfToken = Idents_MakeIdent(&s);
  Strings_ArrayToString((STRING)"_ErrorId", 8L, &s);
  Scanner_NoIdent = Idents_MakeIdent(&s);
  Strings_ArrayToString((STRING)"_ErrorStr", 9L, &s);
  Scanner_NoString = StringMem_PutString(&s);
}

void Scanner_CloseScanner
# ifdef __STDC__
()
# else
()
# endif
{
}

static void UnpackBaseHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyBasePtr.A[yyunpackindex] = (LONGCARD)ADR(yyComb.A[value]);
  INC(yyunpackindex);
}

static void UnpackDefaultHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyDefault.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackEobTransHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyEobTrans.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackCombHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  if (!ODD(yyunpackindex)) {
    yyComb.A[yyunpackindex / 2].Check = value;
  } else {
    yyComb.A[yyunpackindex / 2].Next = value;
  }
  INC(yyunpackindex);
}

static void yyInitTables
# ifdef __STDC__
()
# else
()
# endif
{
  Pack_UnpackCardHandler hc;

  hc = UnpackBaseHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"++V@+VM+VO+W0+W6+W?+WB+Y@\\A++J_BHbC+d-WCeN+WMhKkLnM+qN+", 55L, 36L);
  Pack_UnpackCard(hc, (STRING)"tOwPJ.++++++++++++F+M+N++++++++++++++R+V0++6DKD+RV+JLV2", 55L, 50L);
  Pack_UnpackCard(hc, (STRING)"P+V0V/V?+V?V?V4+VIVFVJ+V<V<VKV@+VDVPVE+VIVKW++y6WDWGW=+", 55L, 32L);
  Pack_UnpackCard(hc, (STRING)"WDW7+WAW?WMWOWQ+WFXDZOZM[?+[I]Q`Ma2+aJaMc,cF++++bD+++++", 55L, 34L);
  Pack_UnpackCard(hc, (STRING)"+", 1L, 1L);
  hc = UnpackDefaultHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"G,C.N0L2K4J6=8<:SS++SSSS+SSS+ESSS@SSSSS+++SS+CNLKJ=<S+S", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+S+++V-V,V,V-+R+++++O+O+OGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGOOOO+OOOOO", 47L, 47L);
  hc = UnpackEobTransHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"OOCCNNLLKKJJ==<<<=+++D+C++++++JKL+N+>?+++++++CNLKJ=<+++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++", 43L, 43L);
  hc = UnpackCombHandler;
  yyunpackindex = 0;
  Pack_UnpackCard(hc, (STRING)",O,O,O,O,O,O,O,O,O,V-,V,,O,H,H,O,O,O,O,O,O,O,O,O,O,O,O,", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"O,O,O,O,O,O,V.,O,VG,O,O,O,O,VH,VK,X?,XC,XB,O,O,XD,VI,F,", 55L, 46L);
  Pack_UnpackCard(hc, (STRING)"F,F,F,F,F,F,F,F,F,XE,O,O,XF,O,O,O@@,X8,X3BR,X-RB,WQ.V>.", 55L, 48L);
  Pack_UnpackCard(hc, (STRING)"V?V6V7V8V9,WIV:V;,WE,WA,W8VIVJ,W0,VS,VN0VA0V@2VA2V@VKVL", 55L, 33L);
  Pack_UnpackCard(hc, (STRING)"VNVO,X>,E,X=,O.V/,O.VG4VA4V@VOVPVPVQ.VHVQVR6VA6V@VSVTVT", 55L, 35L);
  Pack_UnpackCard(hc, (STRING)"W+0V0W+W,2V1W,W-2M8V-8V,0VC:V-:V,W-W.W.W/W0W44V2W1W2,VM", 55L, 33L);
  Pack_UnpackCard(hc, (STRING)",X@,O,O6V34VD6VBSTW2W3W0W1W4W5W5W6W6W78V4W8W<W9W::V5W:W;", 56L, 34L);
  Pack_UnpackCard(hc, (STRING)"W<W=W=W>W>W?8V:W?W@8V8WAWBWBWC:V6WCWDWEWFWFWGWGWHW8W9.A", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)"FFFFFFFFFFFFFFFFFFFFIIIIIIIIIIIIIIIIIIIIWJWKWKWLWLWMWNWO", 56L, 48L);
  Pack_UnpackCard(hc, (STRING)"WOWP4QWQWRWRWSWSWTWTX+.V=6P.V<<<<<<<<<<<<<<<<<<<X+X,X-X.", 56L, 40L);
  Pack_UnpackCard(hc, (STRING)"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"<<<<<<<X.X/<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"<<<<<<<<<<<<<<==================X/X0X0X1===============", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"===========================================X1X2==X3X4==", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"=======================================================", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"=======================================================", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"=======================================================", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"=ADADADADADADADADADADX4X5ADADADADADADADADADADADADADADAD", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"ADADADADADADADADADADADADADADADADADADADADADADADADADADADA", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"DADADADADADADADADADADADADADADADADADADADADADADADADADADAD", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"ADADADADADADADADADADADADADADADADADADADADADADADADADADADA", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"DADADADADADADADADADADADADADADADADADADCCCCCCCCCCCCCCCCCC", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"X5X6X6X7CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCX8", 56L, 51L);
  Pack_UnpackCard(hc, (STRING)"X9CCCCCCCCX9X:CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC", 55L, 52L);
  Pack_UnpackCard(hc, (STRING)"CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"CCCCCCCCX:X;CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"CCCCCCCCCCCCCCCCCX;X<CCX@XACCEIEIEIEIEIEIEIEIEIEIEIEIEI", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"EIEIEIEIEIEIEIEIEIEIEIEIEI++++++++EI++EIEIEIEIEIEIEIEIE", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"IEIEIEIEIEIEIEIEIEIEIEIEIEIEIEIEIEIGGGGGGGGGGGGGGGGGGGG", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"++++++++++++++GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"GGGGGGGGGGG++++++++GG++GGGGGGGGGGGGGGGGGGGGGGGGGGGGGGGG", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"GGGGGGGGGGGGGGGGGGGGJJJJJJJJJJJJJJJJJJ++++JJJJJJJJJJJJJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"JJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJ++JJJJJJJJJJJJJJJJJJJJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"JJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"JJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJ++JJJJJJJJJJJJJJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"JJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJK", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"KKKKKKKKKKKKKKKKK++++KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"KKKKKKKKKKKKKKKKKKKKKK++KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"KKKKKKKKKKKKKKKKKK++KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"KKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKLLLLLLLLLLLLLLLLLL++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL++LLLLLLL", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"LLLLLLLLLLLLNNNNNNNNNNNNNNNNNN++++NNNNNNNNNNNNNNNNNNNNN", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN++NNNNNNNNNNNNNNNNNN", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNP>P>P>P>P", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)">P>P>P>P>P>PVEP>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P", 55L, 54L);
  Pack_UnpackCard(hc, (STRING)">P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)">P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>P>", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"P>P>P>P>P>P>P>P>P>P>P>P>P>Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?QVFQ?Q?Q?", 55L, 54L);
  Pack_UnpackCard(hc, (STRING)"Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?Q?", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"Q?Q?Q?WIWN++++++++++++++++++WIWJ+++++++++++++++++++++++", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"++++++++++++++++++", 18L, 18L);
}

static void yyErrorMessage
# ifdef __STDC__
(SHORTCARD ErrorCode)
# else
(ErrorCode)
SHORTCARD ErrorCode;
# endif
{
  Positions_WritePosition((rSystem_tFile)IO_StdError, Scanner_Attribute.Position);
  switch (ErrorCode) {
  case 0:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: internal error", 25L);
    break;
  case 1:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: out of memory", 24L);
    break;
  case 3:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: too many nested include files", 40L);
    break;
  case 4:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: file stack underflow (too many calls of CloseFile)", 61L);
    break;
  case 5:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: cannot open input file", 33L);
    break;
  }
  IO_WriteNl((rSystem_tFile)IO_StdError);
  (*Scanner_Exit)();
}

static void yyExit
# ifdef __STDC__
()
# else
()
# endif
{
  IO_CloseIO();
  rExit(1L);
}

void BEGIN_Scanner()
{
  static BOOLEAN has_been_called = FALSE;
  if (has_been_called) return;
  has_been_called = TRUE;
    BEGIN_Strings();
    BEGIN_Idents();
    BEGIN_StringMem();
    BEGIN_Positions();
    BEGIN_Checks();
    BEGIN_rSystem();
    BEGIN_General();
    BEGIN_Pack();
    BEGIN_Positions();
    BEGIN_IO();
    BEGIN_DynArray();
    BEGIN_Strings();
    BEGIN_Source();
    BEGIN_Strings();
    BEGIN_Idents();
    BEGIN_StringMem();
    BEGIN_Errors();
    BEGIN_ArgCheck();

    Scanner_Exit = yyExit;
    yyIsFirstCall = TRUE;
    yyFileStackPtr = 0;
    yyInitialize();
    yySourceFile = rSystem_StdInput;
    yyStartState = STD;
    yyPreviousStart = STD;
    yyStateStackSize = yyInitBufferSize;
    DynArray_MakeArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
    yyStateStack->A[0] = yyDefaultState;
    yyInitTables();
    for (yyCh = yyFirstCh; yyCh <= yyLastCh; yyCh += 1) {
      yyToLower.A[yyCh] = yyCh;
    }
    yyToUpper = yyToLower;
    for (yyCh = 'A'; yyCh <= 'Z'; yyCh += 1) {
      yyToLower.A[yyCh] = CHR(ORD(yyCh) - ORD('A') + ORD('a'));
    }
    for (yyCh = 'a'; yyCh <= 'z'; yyCh += 1) {
      yyToUpper.A[yyCh] = CHR(ORD(yyCh) - ORD('a') + ORD('A'));
    }
}
