#define DEFINITION_Scanner

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Positions
#include "Positions.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_Lists
#include "Lists.h"
#endif

enum {Scanner_Keys, Scanner_Comment, Scanner_Number, Scanner_Action, Scanner_Symbol, Scanner_Coding, Scanner_PrioPart, Scanner_RightSide, Scanner_Empty}; 
typedef unsigned char Scanner_AttributeMode;
typedef struct Scanner_1 {
    Positions_tPosition Position;
    Scanner_AttributeMode Mode;
    union {
        struct {
            Lists_tList Comm;
        } V_1;
        struct {
            CARDINAL Value;
        } V_2;
        struct {
            Lists_tList Act;
        } V_3;
        struct {
            Idents_tIdent Ident;
        } V_4;
    } U_1;
} Scanner_tScanAttribute;
extern void Scanner_ErrorAttribute ARGS((INTEGER Token, Scanner_tScanAttribute *Attr));
#define Scanner_EofToken	0
extern INTEGER Scanner_TokenLength;
extern Scanner_tScanAttribute Scanner_Attribute;
extern PROC Scanner_Exit;
extern void Scanner_BeginScanner ARGS(());
extern void Scanner_BeginFile ARGS((CHAR FileName[], LONGCARD ));
extern INTEGER Scanner_GetToken ARGS(());
extern void Scanner_GetWord ARGS((Strings_tString *Word));
extern void Scanner_GetLower ARGS((Strings_tString *Word));
extern void Scanner_GetUpper ARGS((Strings_tString *Word));
extern void Scanner_CloseFile ARGS(());
extern void Scanner_CloseScanner ARGS(());
extern void BEGIN_Scanner();
