#include "SYSTEM_.h"

#ifndef DEFINITION_Checks
#include "Checks.h"
#endif

#ifndef DEFINITION_rSystem
#include "rSystem.h"
#endif

#ifndef DEFINITION_General
#include "General.h"
#endif

#ifndef DEFINITION_Pack
#include "Pack.h"
#endif

#ifndef DEFINITION_Positions
#include "Positions.h"
#endif

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_DynArray
#include "DynArray.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Source
#include "Source.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_StringMem
#include "StringMem.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_Errors
#include "Errors.h"
#endif

#ifndef DEFINITION_Tokens
#include "Tokens.h"
#endif

#ifndef DEFINITION_Scanner
#include "Scanner.h"
#endif

INTEGER Scanner_TokenLength;
Scanner_tScanAttribute Scanner_Attribute;
PROC Scanner_Exit;

static CARDINAL NestingLevel;
static StringMem_tStringRef DefaultString, DefaultReal;
static Strings_tString String;
static BOOLEAN UnderscoreUsed;
#define yyTabSpace	8
#define yyDNoState	0
#define yyFileStackSize	16
#define yyInitBufferSize	(1024 * 8 + 256)
#define yyFirstCh	'\0'
#define yyLastCh	((CHAR)'\377')
#define yyEolCh	'\n'
#define yyEobCh	((CHAR)'\177')
#define yyDStateCount	235
#define yyTableSize	1409
#define yyEobState	31
#define yyDefaultState	32
#define STD	1
#define Comment	3
#define Str1	5
#define Str2	7
typedef SHORTCARD yyTableElmt;
typedef yyTableElmt yyStateRange;
typedef yyTableElmt yyTableRange;
typedef struct S_1 {
    yyStateRange Check, Next;
} yyCombType;
typedef yyCombType *yyCombTypePtr;
typedef struct S_11 {
    CHAR A[1000000 + 1];
} *yytChBufferPtr;
typedef CHAR yyChRange;
static struct S_2 {
    LONGCARD A[yyDStateCount + 1];
} yyBasePtr;
static struct S_3 {
    yyStateRange A[yyDStateCount + 1];
} yyDefault;
static struct S_4 {
    yyCombType A[yyTableSize + 1];
} yyComb;
static struct S_5 {
    yyStateRange A[yyDStateCount + 1];
} yyEobTrans;
static struct S_6 {
    CHAR A[yyLastCh + 1];
} yyToLower, yyToUpper;
static struct S_7 {
    yyStateRange A[1000000 + 1];
} *yyStateStack;
static LONGINT yyStateStackSize;
static yyStateRange yyStartState;
static yyStateRange yyPreviousStart;
static CHAR yyCh;
static BOOLEAN yyIsFirstCall;
static rSystem_tFile yySourceFile;
static BOOLEAN yyEof;
static yytChBufferPtr yyChBufferPtr;
static INTEGER yyChBufferStart;
static LONGINT yyChBufferSize;
static INTEGER yyChBufferIndex;
static INTEGER yyBytesRead;
static CARDINAL yyLineCount;
static INTEGER yyLineStart;
static SHORTCARD yyFileStackPtr;
static struct S_8 {
    struct S_9 {
        rSystem_tFile SourceFile;
        BOOLEAN Eof;
        yytChBufferPtr ChBufferPtr;
        INTEGER ChBufferStart;
        LONGINT ChBufferSize;
        INTEGER ChBufferIndex;
        INTEGER BytesRead;
        CARDINAL LineCount;
        INTEGER LineStart;
    } A[yyFileStackSize - 1 + 1];
} yyFileStack;
static void yyInitialize ARGS(());
static void yyStart ARGS((yyStateRange State));
static void yyPrevious ARGS(());
static void yyEcho ARGS(());
static void yyLess ARGS((INTEGER n));
static void yyTab ARGS(());
static void yyTab1 ARGS((INTEGER a));
static void yyTab2 ARGS((INTEGER a, INTEGER b));
static void yyEol ARGS((INTEGER Column));
static void output ARGS((CHAR c));
static void unput ARGS((CHAR c));
static CHAR input ARGS(());
static CARDINAL yyunpackindex;
static void UnpackBaseHandler ARGS((LONGCARD value));
static void UnpackDefaultHandler ARGS((LONGCARD value));
static void UnpackEobTransHandler ARGS((LONGCARD value));
static void UnpackCombHandler ARGS((LONGCARD value));
static void yyInitTables ARGS(());
static void yyErrorMessage ARGS((SHORTCARD ErrorCode));
static void yyExit ARGS(());

void Scanner_ErrorAttribute
# ifdef __STDC__
(CARDINAL Token, Scanner_tScanAttribute *Attribute)
# else
(Token, Attribute)
CARDINAL Token;
Scanner_tScanAttribute *Attribute;
# endif
{
  switch (Token) {
  case Tokens_TokIdent:;
    Attribute->U_1.V_1.Ident = Idents_NoIdent;
    break;
  case Tokens_TokDecConst:;
  case Tokens_TokOctalConst:;
  case Tokens_TokHexConst:;
    Attribute->U_1.V_2.IntValue = 1;
    break;
  case Tokens_TokCharConst:;
    Attribute->U_1.V_3.CharValue = CHR(0);
    break;
  case Tokens_TokRealConst:;
    Attribute->U_1.V_4.RealValue = DefaultReal;
    break;
  case Tokens_TokStringConst:;
    Attribute->U_1.V_5.StringValue = DefaultString;
    break;
  default :
    break;
  }
}

INTEGER Scanner_GetToken
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange yyState;
  yyCombTypePtr yyTablePtr;
  BOOLEAN yyRestart;
  INTEGER yyi, yySource, yyTarget, yyChBufferFree;
  Strings_tString String, S, Word;

  for (;;) {
    yyState = yyStartState;
    Scanner_TokenLength = 0;
    for (;;) {
      for (;;) {
        yyTablePtr = (yyCombTypePtr)(yyBasePtr.A[yyState] + ORD(yyChBufferPtr->A[yyChBufferIndex]) * sizeof(yyCombType));
        if (yyTablePtr->Check != yyState) {
          yyState = yyDefault.A[yyState];
          if (yyState == yyDNoState) {
            goto EXIT_3;
          }
        } else {
          yyState = yyTablePtr->Next;
          INC(Scanner_TokenLength);
          yyStateStack->A[Scanner_TokenLength] = yyState;
          INC(yyChBufferIndex);
        }
      } EXIT_3:;
      for (;;) {
        switch (yyStateStack->A[Scanner_TokenLength]) {
        case 235:;
          NestingLevel = 1;
          yyStart(Comment);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 234:;
          INC(NestingLevel);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 232:;
          DEC(NestingLevel);
          if (NestingLevel == 0) {
            yyStart(STD);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 11:;
        case 23:;
        case 36:;
        case 231:;
        case 233:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 14:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 12:;
        case 24:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_2.IntValue = Strings_StringToNumber(&Word, 10L);
          return Tokens_TokDecConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 22:;
          DEC1(yyChBufferIndex, 2);
          DEC1(Scanner_TokenLength, 2);
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_2.IntValue = Strings_StringToNumber(&Word, 10L);
          return Tokens_TokDecConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 21:;
          DEC1(yyChBufferIndex, 2);
          DEC1(Scanner_TokenLength, 2);
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_2.IntValue = Strings_StringToNumber(&Word, 10L);
          return Tokens_TokDecConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 18:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Strings_SubString(&Word, 1, (Strings_tStringIndex)(Strings_Length(&Word) - 1), &String);
          Scanner_Attribute.U_1.V_2.IntValue = Strings_StringToNumber(&String, 8L);
          return Tokens_TokOctalConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 19:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Strings_SubString(&Word, 1, (Strings_tStringIndex)(Strings_Length(&Word) - 1), &String);
          Scanner_Attribute.U_1.V_3.CharValue = CHR(Strings_StringToNumber(&String, 8L));
          return Tokens_TokCharConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 20:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Strings_SubString(&Word, 1, (Strings_tStringIndex)(Strings_Length(&Word) - 1), &String);
          Scanner_Attribute.U_1.V_2.IntValue = Strings_StringToNumber(&String, 16L);
          return Tokens_TokHexConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 16:;
        case 25:;
        case 26:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_4.RealValue = StringMem_PutString(&Word);
          return Tokens_TokRealConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 230:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Strings_AssignEmpty(&String);
          yyStart(Str1);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 10:;
        case 37:;
          Scanner_GetWord(&S);
          Strings_Concatenate(&String, &S);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 229:;
          yyStart(STD);
          Scanner_Attribute.U_1.V_5.StringValue = StringMem_PutString(&String);
          return Tokens_TokStringConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 228:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Strings_AssignEmpty(&String);
          yyStart(Str2);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 9:;
        case 38:;
          Scanner_GetWord(&S);
          Strings_Concatenate(&String, &S);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 227:;
          yyStart(STD);
          Scanner_Attribute.U_1.V_5.StringValue = StringMem_PutString(&String);
          return Tokens_TokStringConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 226:;
          Strings_Append(&String, '\t');
          yyTab();
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 225:;
          yyEol(0L);
          yyStart(STD);
          Errors_ErrorMessageP((LONGCARD)Errors_UnclosedString, (LONGCARD)Errors_Error, Scanner_Attribute.Position);
          Scanner_Attribute.U_1.V_5.StringValue = StringMem_PutString(&String);
          return Tokens_TokStringConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 224:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokNotEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 223:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokAnd;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 222:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokLParent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 221:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokRParent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 220:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokTimes;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 219:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokPlus;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 218:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokComma;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 217:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokMinus;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 215:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokDot;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 216:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokRange;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 214:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokDivide;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 212:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokColon;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 213:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokAssign;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 211:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokSemiColon;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 208:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokLess;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 210:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokLessEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 209:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokNotEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 207:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 205:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokGreater;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 206:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokGreaterEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 204:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokLBracket;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 203:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokRBracket;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 202:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokArrow;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 201:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokLBrace;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 200:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokBar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 199:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokRBrace;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 198:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokNot;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 197:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokAnd;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 195:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokArray;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 190:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokBegin;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 186:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokBy;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 184:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokCase;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 181:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 176:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokDefinition;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 167:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokDiv;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 165:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokDo;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 163:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokElse;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 162:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokElsif;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 158:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokEnd;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 156:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokExit;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 154:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokExport;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 41:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokFor;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 148:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokFrom;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 145:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokIf;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 144:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokImplementation;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 133:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokImport;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 128:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokIn;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 126:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokLoop;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 119:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokMod;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 122:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokModule;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 116:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokNot;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 113:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokOf;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 112:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokOr;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 110:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokPointer;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 104:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokProcedure;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 95:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokQualified;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 86:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokRecord;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 82:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokRepeat;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 78:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokReturn;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 72:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokSet;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 69:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokThen;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 66:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokTo;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 65:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokType;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 61:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokUntil;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 56:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokVar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 53:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokWhile;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 49:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokWith;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 45:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return Tokens_TokForeign;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 13:;
        case 39:;
        case 40:;
        case 42:;
        case 43:;
        case 44:;
        case 46:;
        case 47:;
        case 48:;
        case 50:;
        case 51:;
        case 52:;
        case 54:;
        case 55:;
        case 57:;
        case 58:;
        case 59:;
        case 60:;
        case 62:;
        case 63:;
        case 64:;
        case 67:;
        case 68:;
        case 70:;
        case 71:;
        case 73:;
        case 74:;
        case 75:;
        case 76:;
        case 77:;
        case 79:;
        case 80:;
        case 81:;
        case 83:;
        case 84:;
        case 85:;
        case 87:;
        case 88:;
        case 89:;
        case 90:;
        case 91:;
        case 92:;
        case 93:;
        case 94:;
        case 96:;
        case 97:;
        case 98:;
        case 99:;
        case 100:;
        case 101:;
        case 102:;
        case 103:;
        case 105:;
        case 106:;
        case 107:;
        case 108:;
        case 109:;
        case 111:;
        case 114:;
        case 115:;
        case 117:;
        case 118:;
        case 120:;
        case 121:;
        case 123:;
        case 124:;
        case 125:;
        case 127:;
        case 129:;
        case 130:;
        case 131:;
        case 132:;
        case 134:;
        case 135:;
        case 136:;
        case 137:;
        case 138:;
        case 139:;
        case 140:;
        case 141:;
        case 142:;
        case 143:;
        case 146:;
        case 147:;
        case 149:;
        case 150:;
        case 151:;
        case 152:;
        case 153:;
        case 155:;
        case 157:;
        case 159:;
        case 160:;
        case 161:;
        case 164:;
        case 166:;
        case 168:;
        case 169:;
        case 170:;
        case 171:;
        case 172:;
        case 173:;
        case 174:;
        case 175:;
        case 177:;
        case 178:;
        case 179:;
        case 180:;
        case 182:;
        case 183:;
        case 185:;
        case 187:;
        case 188:;
        case 189:;
        case 191:;
        case 192:;
        case 193:;
        case 194:;
        case 196:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_1.Ident = Idents_MakeIdent(&Word);
          return Tokens_TokIdent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 15:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          UnderscoreUsed = TRUE;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_1.Ident = Idents_MakeIdent(&Word);
          return Tokens_TokIdent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 35:;
          while (yyChBufferPtr->A[yyChBufferIndex] == ' ') {
            INC(yyChBufferIndex);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 34:;
          DEC1(yyLineStart, 7 - (yyChBufferIndex - yyLineStart - 2) % 8);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 33:;
          INC(yyLineCount);
          yyLineStart = yyChBufferIndex - 1;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 1:;
        case 2:;
        case 3:;
        case 4:;
        case 5:;
        case 6:;
        case 7:;
        case 8:;
        case 17:;
        case 27:;
        case 28:;
        case 29:;
        case 30:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          break;
        case 32:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
          INC(yyChBufferIndex);
          Scanner_TokenLength = 1;
          Errors_ErrorMessageP((LONGCARD)Errors_IllegalChar, (LONGCARD)Errors_Error, Scanner_Attribute.Position);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case yyDNoState:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 31:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          if (Scanner_TokenLength == 0) {
            yyState = yyStartState;
          } else {
            yyState = yyStateStack->A[Scanner_TokenLength];
          }
          if (yyChBufferIndex != yyChBufferStart + yyBytesRead) {
            yyState = yyEobTrans.A[yyState];
            if (yyState != yyDNoState) {
              INC(yyChBufferIndex);
              INC(Scanner_TokenLength);
              yyStateStack->A[Scanner_TokenLength] = yyState;
              yyRestart = TRUE;
              goto EXIT_4;
            }
          } else {
            yySource = yyChBufferIndex - Scanner_TokenLength - 1;
            yyTarget = General_MaxAlign - Scanner_TokenLength % General_MaxAlign - 1;
            if (yySource != yyTarget) {
              {
                LONGINT B_1 = 1, B_2 = Scanner_TokenLength;

                if (B_1 <= B_2)
                  for (yyi = B_1;; yyi += 1) {
                    yyChBufferPtr->A[yyTarget + yyi] = yyChBufferPtr->A[yySource + yyi];
                    if (yyi >= B_2) break;
                  }
              }
              DEC1(yyLineStart, yySource - yyTarget);
              yyChBufferStart = yyTarget + Scanner_TokenLength + 1;
            } else {
              yyChBufferStart = yyChBufferIndex;
            }
            if (!yyEof) {
              yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
              if (yyChBufferFree < yyChBufferSize / 8) {
                DynArray_ExtendArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
                if (yyChBufferPtr == NIL) {
                  yyErrorMessage(1);
                }
                yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
                if (yyStateStackSize < yyChBufferSize) {
                  DynArray_ExtendArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
                  if (yyStateStack == NIL) {
                    yyErrorMessage(1);
                  }
                }
              }
              yyChBufferIndex = yyChBufferStart;
              yyBytesRead = Source_GetLine(yySourceFile, ADR(yyChBufferPtr->A[yyChBufferIndex]), (LONGCARD)yyChBufferFree);
              if (yyBytesRead <= 0) {
                yyBytesRead = 0;
                yyEof = TRUE;
              }
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead] = yyEobCh;
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead + 1] = '\0';
              yyRestart = TRUE;
              goto EXIT_4;
            }
            if (Scanner_TokenLength == 0) {
              Scanner_Attribute.Position.Line = yyLineCount;
              Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
              Scanner_CloseFile();
              if (yyFileStackPtr == 0) {
                if (yyStartState == Comment) {
                  Errors_ErrorMessageP((LONGCARD)Errors_UnclosedComment, (LONGCARD)Errors_Error, Scanner_Attribute.Position);
                  NestingLevel = 0;
                }
                if (yyStartState != STD) {
                  yyStart(STD);
                }
                if (UnderscoreUsed) {
                  Errors_ErrorMessageP((LONGCARD)Errors_Underscores, (LONGCARD)Errors_Warning, Scanner_Attribute.Position);
                  UnderscoreUsed = FALSE;
                }
              }
              if (yyFileStackPtr == 0) {
                return Scanner_EofToken;
              }
              yyRestart = FALSE;
              goto EXIT_4;
            }
          }
          break;
        default :
          yyErrorMessage(0);
          break;
        }
      } EXIT_4:;
      if (yyRestart) {
      } else {
        goto EXIT_2;
      }
    } EXIT_2:;
  } EXIT_1:;
}

void Scanner_BeginFile
# ifdef __STDC__
(CHAR FileName[], LONGCARD O_1)
# else
(FileName, O_1)
CHAR FileName[];
LONGCARD O_1;
# endif
{
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_1 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(FileName, O_1, CHAR)
  if (yyIsFirstCall) {
    yyFileStackPtr = 0;
    yyIsFirstCall = FALSE;
  }
  yyInitialize();
  yySourceFile = Source_BeginSource(FileName, O_1);
  if (yySourceFile < 0) {
    yyErrorMessage(5);
  }
  FREE_OPEN_ARRAYS
}

static void yyInitialize
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr >= yyFileStackSize) {
    yyErrorMessage(3);
  }
  INC(yyFileStackPtr);
  {
    register struct S_9 *W_1 = &yyFileStack.A[yyFileStackPtr - 1];

    W_1->SourceFile = yySourceFile;
    W_1->Eof = yyEof;
    W_1->ChBufferPtr = yyChBufferPtr;
    W_1->ChBufferStart = yyChBufferStart;
    W_1->ChBufferSize = yyChBufferSize;
    W_1->ChBufferIndex = yyChBufferIndex;
    W_1->BytesRead = yyBytesRead;
    W_1->LineCount = yyLineCount;
    W_1->LineStart = yyLineStart;
  }
  yyChBufferSize = yyInitBufferSize;
  DynArray_MakeArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  if (yyChBufferPtr == NIL) {
    yyErrorMessage(1);
  }
  yyChBufferStart = General_MaxAlign;
  yyChBufferPtr->A[yyChBufferStart - 1] = yyEolCh;
  yyChBufferPtr->A[yyChBufferStart] = yyEobCh;
  yyChBufferPtr->A[yyChBufferStart + 1] = '\0';
  yyChBufferIndex = yyChBufferStart;
  yyEof = FALSE;
  yyBytesRead = 0;
  yyLineCount = 1;
  yyLineStart = yyChBufferStart - 1;
}

void Scanner_CloseFile
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr == 0) {
    yyErrorMessage(4);
  }
  Source_CloseSource(yySourceFile);
  DynArray_ReleaseArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  {
    register struct S_9 *W_2 = &yyFileStack.A[yyFileStackPtr - 1];

    yySourceFile = W_2->SourceFile;
    yyEof = W_2->Eof;
    yyChBufferPtr = W_2->ChBufferPtr;
    yyChBufferStart = W_2->ChBufferStart;
    yyChBufferSize = W_2->ChBufferSize;
    yyChBufferIndex = W_2->ChBufferIndex;
    yyBytesRead = W_2->BytesRead;
    yyLineCount = W_2->LineCount;
    yyLineStart = W_2->LineStart;
  }
  DEC(yyFileStackPtr);
}

void Scanner_GetWord
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_3 = 1, B_4 = Scanner_TokenLength;

    if (B_3 <= B_4)
      for (i = B_3;; i += 1) {
        Word->Chars.A[i] = yyChBufferPtr->A[WordStart + i];
        if (i >= B_4) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetLower
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_5 = 1, B_6 = Scanner_TokenLength;

    if (B_5 <= B_6)
      for (i = B_5;; i += 1) {
        Word->Chars.A[i] = yyToLower.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_6) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetUpper
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_7 = 1, B_8 = Scanner_TokenLength;

    if (B_7 <= B_8)
      for (i = B_7;; i += 1) {
        Word->Chars.A[i] = yyToUpper.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_8) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

static void yyStart
# ifdef __STDC__
(yyStateRange State)
# else
(State)
yyStateRange State;
# endif
{
  yyPreviousStart = yyStartState;
  yyStartState = State;
}

static void yyPrevious
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange s;

  s = yyStartState;
  yyStartState = yyPreviousStart;
  yyPreviousStart = s;
}

static void yyEcho
# ifdef __STDC__
()
# else
()
# endif
{
  INTEGER i;

  {
    LONGINT B_9 = yyChBufferIndex - Scanner_TokenLength, B_10 = yyChBufferIndex - 1;

    if (B_9 <= B_10)
      for (i = B_9;; i += 1) {
        IO_WriteC((rSystem_tFile)IO_StdOutput, yyChBufferPtr->A[i]);
        if (i >= B_10) break;
      }
  }
}

static void yyLess
# ifdef __STDC__
(INTEGER n)
# else
(n)
INTEGER n;
# endif
{
  DEC1(yyChBufferIndex, Scanner_TokenLength - n);
  Scanner_TokenLength = n;
}

static void yyTab
# ifdef __STDC__
()
# else
()
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - 2) % yyTabSpace);
}

static void yyTab1
# ifdef __STDC__
(INTEGER a)
# else
(a)
INTEGER a;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyTab2
# ifdef __STDC__
(INTEGER a, INTEGER b)
# else
(a, b)
INTEGER a, b;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyEol
# ifdef __STDC__
(INTEGER Column)
# else
(Column)
INTEGER Column;
# endif
{
  INC(yyLineCount);
  yyLineStart = yyChBufferIndex - 1 - Column;
}

static void output
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  IO_WriteC((rSystem_tFile)IO_StdOutput, c);
}

static void unput
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  DEC(yyChBufferIndex);
  yyChBufferPtr->A[yyChBufferIndex] = c;
}

static CHAR input
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    if (!yyEof) {
      DEC1(yyLineStart, yyBytesRead);
      yyChBufferIndex = 0;
      yyChBufferStart = 0;
      yyBytesRead = Source_GetLine(yySourceFile, (ADDRESS)yyChBufferPtr, (LONGCARD)General_Exp2(General_Log2(yyChBufferSize)));
      if (yyBytesRead <= 0) {
        yyBytesRead = 0;
        yyEof = TRUE;
      }
      yyChBufferPtr->A[yyBytesRead] = yyEobCh;
      yyChBufferPtr->A[yyBytesRead + 1] = '\0';
    }
  }
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    return '\0';
  } else {
    INC(yyChBufferIndex);
    return yyChBufferPtr->A[yyChBufferIndex - 1];
  }
}

void Scanner_BeginScanner
# ifdef __STDC__
()
# else
()
# endif
{
  UnderscoreUsed = FALSE;
  NestingLevel = 0;
  Strings_AssignEmpty(&String);
  DefaultString = StringMem_PutString(&String);
  Strings_ArrayToString((STRING)"1.0", 3L, &String);
  DefaultReal = StringMem_PutString(&String);
}

void Scanner_CloseScanner
# ifdef __STDC__
()
# else
()
# endif
{
}

static void UnpackBaseHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyBasePtr.A[yyunpackindex] = (LONGCARD)ADR(yyComb.A[value]);
  INC(yyunpackindex);
}

static void UnpackDefaultHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyDefault.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackEobTransHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyEobTrans.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackCombHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  if (!ODD(yyunpackindex)) {
    yyComb.A[yyunpackindex / 2].Check = value;
  } else {
    yyComb.A[yyunpackindex / 2].Next = value;
  }
  INC(yyunpackindex);
}

static void yyInitTables
# ifdef __STDC__
()
# else
()
# endif
{
  Pack_UnpackCardHandler hc;

  hc = UnpackBaseHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"++VB+VP+W:+X3^7+c7cM+ePeEgG,++++i<n:<nBV6+++++++++++8<-", 55L, 41L);
  Pack_UnpackCard(hc, (STRING)"F,B+I?M+POV-+V2L+QLV/V-+n6TV6++V<V4+V>V1+VKbMV<W-Y:+\\O\\T", 56L, 39L);
  Pack_UnpackCard(hc, (STRING)"]4+_=bJc0+bJc5c,c2c6c>cCcE+c;c<cId9d;d+d/d>+e6e=e8eHe<+", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)"g<++e@e<+f2f>f.f8f@+f7g2g3+n9+g4n4g3g2+gBgLh+h@h<jPn-n9", 55L, 31L);
  Pack_UnpackCard(hc, (STRING)"n5n:++n:n=+n?nCn?n>n=+n>+nP+nBnQnR++nT+nE+o,o+nQo-nMo/o+", 56L, 33L);
  Pack_UnpackCard(hc, (STRING)"o-+o;o/o+o++o-o<+o=+o<o;o7+o9o4oGo0+oH++++++++.++oP+++oR", 56L, 38L);
  Pack_UnpackCard(hc, (STRING)"++p8++++++p=++++++++p?+p?++", 27L, 23L);
  hc = UnpackDefaultHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"8,B.5042III<I+8II<<+++I7;IE=E+++II+B5488888888888888888", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"8888888888888888888888888888888888888888888888888888888", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"8888888888888888888888888888888888888888888888888888888", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"88888888888888888888888888888888+++++++I++I+++I++I+++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+I++LM++++6+6++", 15L, 15L);
  hc = UnpackEobTransHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"++BB554445++++++++++++B++++++++++++B54+++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++", 15L, 15L);
  hc = UnpackCombHandler;
  yyunpackindex = 0;
  Pack_UnpackCard(hc, (STRING)"++++++++++++++++++,M,L++,9,9+++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++,N++,Z=,Z9++++,Z8,Z?,Z7,Z6,Z5,Z4,Z3,Z2,Z0,Z/,7", 55L, 43L);
  Pack_UnpackCard(hc, (STRING)",7,7,7,7,7,7,7,C,C,Z-,Z,,YS,YR,YPDAYPYQ,YB,Y<,Y4,XQ,XB,", 55L, 43L);
  Pack_UnpackCard(hc, (STRING)"RTV+V,V-,X,.M.L,WR,WL,WI,WF,W7,W.,VJ,VG,V?,V:,V7,V/0Z;0", 55L, 38L);
  Pack_UnpackCard(hc, (STRING)"Z:=@,YORS,YN,YMRX?FH.OFHSTV+V,V-V.V/V3V/V0V0V1.ZBV1V2.Z@", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)"2Z;2Z:V3V40PV4V5V5V6V7V8V8V9V:V;V;V<0Z>V<V=V=V>V@VAVAVB", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)",YL,YK,YJ,YIIJVDVEVEVFVGVH2QVHVI2Z<444444444444444444VJ", 55L, 41L);
  Pack_UnpackCard(hc, (STRING)"VKVLVM4444444444444444444444444444444444444444444444VMVN", 56L, 51L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444VNVO44444444444444444444444444444444", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444555555555555555555VPVQVQVR5555555555555555555555555", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555VRVS55555555555555555555", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555555555555555", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555555555555555", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"55555555555555555555555555555555555555555555VTW+5555555", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555555555555555", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555555555555555", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555555555555555", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555555555555555", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"555555555555555555555555555557DVKVT77777777777777777C7C", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"88W+W,VKVPW,W-W.W/W/W0VKVLW0W17=7>W1W2W2W38888888888888", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"8888888W3W4W4W5W5W6W7W@W8W9W9W:W7W888888888888888888888", 55L, 41L);
  Pack_UnpackCard(hc, (STRING)"88888888888888888888888888888888W:W;W;W<W<W=W=W>8:W>W?8", 55L, 45L);
  Pack_UnpackCard(hc, (STRING)"888888888888888888888888888888888888888888888888888::;;", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)";;;;;;;;;;;;;;;;;;W@WA::::::::::::::::::::;FWAWBWBWCWCWD", 56L, 48L);
  Pack_UnpackCard(hc, (STRING)"WDWEWIWJWJWK:::::::::::::::::::::::::::::::::::::::::::", 55L, 49L);
  Pack_UnpackCard(hc, (STRING)":::::::::WLWMWMWNWNWOWOWPWPWQWRWS::::::::::::::::::::::", 55L, 43L);
  Pack_UnpackCard(hc, (STRING)"::::::::::::::::::::::::::::::<<<<<<<<<<<<<<<<<<<<WSWTWF", 56L, 53L);
  Pack_UnpackCard(hc, (STRING)"WHWTX+X.X/X0X1X1X2X3X4<<<<<<<<<<<<WFWG<?BBBBBBBBBBBBBBB", 55L, 42L);
  Pack_UnpackCard(hc, (STRING)"BBBX4X5X5X6BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"BBBBBBBBBBBBBBX6X7BBX7X8BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"BBBBBBBBBBBBBBBBBBBBBBBBBBBX8X9BBBBBBBBBBBBBBBBBBBBBBBB", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"BBBBBBBBBBBBCCCCCCCCCCCCCCCCEEEEEEEEEEEEEEEEEEEECGC<V?VD", 56L, 54L);
  Pack_UnpackCard(hc, (STRING)"X,X>X/X3X9X:X:X;X/X0X;X<V?VCX,X.X,X-X<X=X?X@X@XAXBXLXCXH", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"XBXJXDXEV?V@XEXFXFXGXHXIXCXDXJXKXLXMXMXPXBXCXNXOXQY+XMXN", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"XSXTY+Y,XQXSY,Y-Y-Y.Y.Y/Y/Y0Y0Y1XQXRY1Y2Y2Y3Y4Y9Y5Y6Y6Y7", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"Y7Y8Y9Y:Y:Y;Y<Y>Y>Y?Y?Y@Y@YAYCYDYBYGYDYEYEYFY4Y5YBYCYGYH", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"YSZ+YSYTZ-Z.Z0Z1Z7ZDZ@ZAZBZC++++Y<Y=+++++++++++++++++++", 55L, 39L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"++++++++++++++++", 16L, 16L);
}

static void yyErrorMessage
# ifdef __STDC__
(SHORTCARD ErrorCode)
# else
(ErrorCode)
SHORTCARD ErrorCode;
# endif
{
  Positions_WritePosition((rSystem_tFile)IO_StdError, Scanner_Attribute.Position);
  switch (ErrorCode) {
  case 0:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: internal error", 25L);
    break;
  case 1:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: out of memory", 24L);
    break;
  case 3:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: too many nested include files", 40L);
    break;
  case 4:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: file stack underflow (too many calls of CloseFile)", 61L);
    break;
  case 5:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: cannot open input file", 33L);
    break;
  }
  IO_WriteNl((rSystem_tFile)IO_StdError);
  (*Scanner_Exit)();
}

static void yyExit
# ifdef __STDC__
()
# else
()
# endif
{
  IO_CloseIO();
  rExit(1L);
}

void BEGIN_Scanner()
{
  static BOOLEAN has_been_called = FALSE;
  if (has_been_called) return;
  has_been_called = TRUE;
    BEGIN_Strings();
    BEGIN_StringMem();
    BEGIN_Idents();
    BEGIN_Tokens();
    BEGIN_Positions();
    BEGIN_Checks();
    BEGIN_rSystem();
    BEGIN_General();
    BEGIN_Pack();
    BEGIN_Positions();
    BEGIN_IO();
    BEGIN_DynArray();
    BEGIN_Strings();
    BEGIN_Source();
    BEGIN_Strings();
    BEGIN_StringMem();
    BEGIN_Idents();
    BEGIN_Errors();
    BEGIN_Tokens();

    Scanner_Exit = yyExit;
    yyIsFirstCall = TRUE;
    yyFileStackPtr = 0;
    yyInitialize();
    yySourceFile = rSystem_StdInput;
    yyStartState = STD;
    yyPreviousStart = STD;
    yyStateStackSize = yyInitBufferSize;
    DynArray_MakeArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
    yyStateStack->A[0] = yyDefaultState;
    yyInitTables();
    {
      CHAR B_11 = yyFirstCh, B_12 = yyLastCh;

      if (B_11 <= B_12)
        for (yyCh = B_11;; yyCh += 1) {
          yyToLower.A[yyCh] = yyCh;
          if (yyCh >= B_12) break;
        }
    }
    yyToUpper = yyToLower;
    for (yyCh = 'A'; yyCh <= 'Z'; yyCh += 1) {
      yyToLower.A[yyCh] = CHR(ORD(yyCh) - ORD('A') + ORD('a'));
    }
    for (yyCh = 'a'; yyCh <= 'z'; yyCh += 1) {
      yyToUpper.A[yyCh] = CHR(ORD(yyCh) - ORD('a') + ORD('A'));
    }
}
