#include "SYSTEM_.h"

#ifndef DEFINITION_Checks
#include "Checks.h"
#endif

#ifndef DEFINITION_rSystem
#include "rSystem.h"
#endif

#ifndef DEFINITION_General
#include "General.h"
#endif

#ifndef DEFINITION_Pack
#include "Pack.h"
#endif

#ifndef DEFINITION_Positions
#include "Positions.h"
#endif

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_DynArray
#include "DynArray.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Source
#include "Source.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_Errors
#include "Errors.h"
#endif

#ifndef DEFINITION_Scanner
#include "Scanner.h"
#endif

INTEGER Scanner_TokenLength;
Scanner_tScanAttribute Scanner_Attribute;
PROC Scanner_Exit;

static CARDINAL NestingLevel;
#define TokIntConst	2
#define TokCharConst	4
#define TokRealConst	6
#define TokStringConst	7
#define TokNotEqual	8
#define TokLParent	9
#define TokRParent	10
#define TokTimes	11
#define TokPlus	12
#define TokComma	13
#define TokMinus	14
#define TokDot	15
#define TokRange	16
#define TokDivide	17
#define TokColon	18
#define TokAssign	19
#define TokSemiColon	20
#define TokLess	21
#define TokLessEqual	22
#define TokEqual	24
#define TokGreater	25
#define TokGreaterEqual	26
#define TokLBracket	27
#define TokRBracket	28
#define TokArrow	29
#define TokLBrace	30
#define TokBar	31
#define TokRBrace	32
#define TokAnd	34
#define TokArray	35
#define TokBegin	36
#define TokBy	37
#define TokCase	38
#define TokConst	39
#define TokDefinition	40
#define TokDiv	41
#define TokDo	42
#define TokElse	43
#define TokElsif	44
#define TokEnd	45
#define TokExit	46
#define TokExport	47
#define TokFor	48
#define TokFrom	49
#define TokIf	50
#define TokImplementation	51
#define TokImport	52
#define TokIn	53
#define TokLoop	54
#define TokMod	55
#define TokModule	56
#define TokNot	57
#define TokOf	58
#define TokOr	59
#define TokPointer	60
#define TokProcedure	61
#define TokQualified	62
#define TokRecord	63
#define TokRepeat	64
#define TokReturn	65
#define TokSet	66
#define TokThen	67
#define TokTo	68
#define TokType	69
#define TokUntil	70
#define TokVar	71
#define TokWhile	72
#define TokWith	73
#define TokForeign	74
#define yyTabSpace	8
#define yyDNoState	0
#define yyFileStackSize	16
#define yyInitBufferSize	(1024 * 8 + 256)
#define yyFirstCh	'\0'
#define yyLastCh	((CHAR)'\177')
#define yyEolCh	'\n'
#define yyEobCh	((CHAR)'\177')
#define yyDStateCount	233
#define yyTableSize	834
#define yyEobState	30
#define yyDefaultState	31
#define STD	1
#define Comment	3
#define Str1	5
#define Str2	7
typedef SHORTCARD yyTableElmt;
typedef yyTableElmt yyStateRange;
typedef yyTableElmt yyTableRange;
typedef struct S_1 {
    yyStateRange Check, Next;
} yyCombType;
typedef yyCombType *yyCombTypePtr;
typedef struct S_11 {
    CHAR A[1000000 + 1];
} *yytChBufferPtr;
typedef CHAR yyChRange;
static struct S_2 {
    LONGCARD A[yyDStateCount + 1];
} yyBasePtr;
static struct S_3 {
    yyStateRange A[yyDStateCount + 1];
} yyDefault;
static struct S_4 {
    yyCombType A[yyTableSize + 1];
} yyComb;
static struct S_5 {
    yyStateRange A[yyDStateCount + 1];
} yyEobTrans;
static struct S_6 {
    CHAR A[yyLastCh + 1];
} yyToLower, yyToUpper;
static struct S_7 {
    yyStateRange A[1000000 + 1];
} *yyStateStack;
static LONGINT yyStateStackSize;
static yyStateRange yyStartState;
static yyStateRange yyPreviousStart;
static CHAR yyCh;
static BOOLEAN yyIsFirstCall;
static rSystem_tFile yySourceFile;
static BOOLEAN yyEof;
static yytChBufferPtr yyChBufferPtr;
static INTEGER yyChBufferStart;
static LONGINT yyChBufferSize;
static INTEGER yyChBufferIndex;
static INTEGER yyBytesRead;
static CARDINAL yyLineCount;
static INTEGER yyLineStart;
static SHORTCARD yyFileStackPtr;
static struct S_8 {
    struct S_9 {
        rSystem_tFile SourceFile;
        BOOLEAN Eof;
        yytChBufferPtr ChBufferPtr;
        INTEGER ChBufferStart;
        LONGINT ChBufferSize;
        INTEGER ChBufferIndex;
        INTEGER BytesRead;
        CARDINAL LineCount;
        INTEGER LineStart;
    } A[yyFileStackSize - 1 + 1];
} yyFileStack;
static void yyInitialize ARGS(());
static void yyStart ARGS((yyStateRange State));
static void yyPrevious ARGS(());
static void yyEcho ARGS(());
static void yyLess ARGS((INTEGER n));
static void yyTab ARGS(());
static void yyTab1 ARGS((INTEGER a));
static void yyTab2 ARGS((INTEGER a, INTEGER b));
static void yyEol ARGS((INTEGER Column));
static void output ARGS((CHAR c));
static void unput ARGS((CHAR c));
static CHAR input ARGS(());
static CARDINAL yyunpackindex;
static void UnpackBaseHandler ARGS((LONGCARD value));
static void UnpackDefaultHandler ARGS((LONGCARD value));
static void UnpackEobTransHandler ARGS((LONGCARD value));
static void UnpackCombHandler ARGS((LONGCARD value));
static void yyInitTables ARGS(());
static void yyErrorMessage ARGS((SHORTCARD ErrorCode));
static void yyExit ARGS(());

void Scanner_ErrorAttribute
# ifdef __STDC__
(CARDINAL Token, Scanner_tScanAttribute *Attribute)
# else
(Token, Attribute)
CARDINAL Token;
Scanner_tScanAttribute *Attribute;
# endif
{
  switch (Token) {
  case Scanner_TokIdent:;
    Attribute->U_1.V_1.Ident = Idents_NoIdent;
    break;
  default :
    break;
  }
}

INTEGER Scanner_GetToken
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange yyState;
  yyCombTypePtr yyTablePtr;
  BOOLEAN yyRestart;
  INTEGER yyi, yySource, yyTarget, yyChBufferFree;
  Strings_tString Word;

  for (;;) {
    yyState = yyStartState;
    Scanner_TokenLength = 0;
    for (;;) {
      for (;;) {
        yyTablePtr = (yyCombTypePtr)(yyBasePtr.A[yyState] + ORD(yyChBufferPtr->A[yyChBufferIndex]) * sizeof(yyCombType));
        if (yyTablePtr->Check != yyState) {
          yyState = yyDefault.A[yyState];
          if (yyState == yyDNoState) {
            goto EXIT_3;
          }
        } else {
          yyState = yyTablePtr->Next;
          INC(Scanner_TokenLength);
          yyStateStack->A[Scanner_TokenLength] = yyState;
          INC(yyChBufferIndex);
        }
      } EXIT_3:;
      for (;;) {
        switch (yyStateStack->A[Scanner_TokenLength]) {
        case 232:;
          INC(NestingLevel);
          yyStart(Comment);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 231:;
          DEC(NestingLevel);
          if (NestingLevel == 0) {
            yyStart(STD);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 11:;
        case 22:;
        case 35:;
        case 230:;
        case 233:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 14:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 12:;
        case 23:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokIntConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 21:;
          DEC1(yyChBufferIndex, 2);
          DEC1(Scanner_TokenLength, 2);
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokIntConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 20:;
          DEC1(yyChBufferIndex, 2);
          DEC1(Scanner_TokenLength, 2);
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokIntConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 17:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokIntConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 19:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokIntConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 18:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokCharConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 15:;
        case 24:;
        case 25:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokRealConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 229:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          yyStart(Str1);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 10:;
        case 36:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 228:;
          yyStart(STD);
          return TokStringConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 227:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          yyStart(Str2);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 9:;
        case 37:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 226:;
          yyStart(STD);
          return TokStringConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 225:;
          yyTab();
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 224:;
          Errors_ErrorMessage((LONGCARD)Errors_UnclosedString, (LONGCARD)Errors_Error, Scanner_Attribute.Position);
          yyEol(0L);
          yyStart(STD);
          return TokStringConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 223:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokNotEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 222:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokAnd;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 221:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokLParent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 220:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokRParent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 219:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokTimes;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 218:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokPlus;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 217:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokComma;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 216:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokMinus;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 214:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokDot;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 215:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokRange;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 213:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokDivide;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 211:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokColon;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 212:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokAssign;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 210:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokSemiColon;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 207:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokLess;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 209:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokLessEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 208:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokNotEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 206:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 204:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokGreater;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 205:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokGreaterEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 203:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokLBracket;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 202:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokRBracket;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 201:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokArrow;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 200:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokLBrace;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 199:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokBar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 198:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokRBrace;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 197:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokNot;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 196:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokAnd;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 194:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokArray;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 189:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokBegin;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 185:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokBy;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 183:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokCase;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 180:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokConst;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 175:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokDefinition;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 166:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokDiv;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 164:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokDo;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 162:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokElse;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 161:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokElsif;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 157:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokEnd;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 155:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokExit;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 153:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokExport;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 40:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokFor;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 147:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokFrom;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 144:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokIf;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 143:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokImplementation;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 132:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokImport;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 127:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokIn;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 125:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokLoop;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 118:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokMod;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 121:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokModule;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 115:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokNot;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 112:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokOf;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 111:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokOr;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 109:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokPointer;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 103:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokProcedure;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 94:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokQualified;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 85:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokRecord;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 81:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokRepeat;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 77:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokReturn;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 71:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokSet;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 68:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokThen;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 65:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokTo;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 64:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokType;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 60:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokUntil;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 55:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokVar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 52:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokWhile;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 48:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokWith;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 44:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return TokForeign;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 13:;
        case 38:;
        case 39:;
        case 41:;
        case 42:;
        case 43:;
        case 45:;
        case 46:;
        case 47:;
        case 49:;
        case 50:;
        case 51:;
        case 53:;
        case 54:;
        case 56:;
        case 57:;
        case 58:;
        case 59:;
        case 61:;
        case 62:;
        case 63:;
        case 66:;
        case 67:;
        case 69:;
        case 70:;
        case 72:;
        case 73:;
        case 74:;
        case 75:;
        case 76:;
        case 78:;
        case 79:;
        case 80:;
        case 82:;
        case 83:;
        case 84:;
        case 86:;
        case 87:;
        case 88:;
        case 89:;
        case 90:;
        case 91:;
        case 92:;
        case 93:;
        case 95:;
        case 96:;
        case 97:;
        case 98:;
        case 99:;
        case 100:;
        case 101:;
        case 102:;
        case 104:;
        case 105:;
        case 106:;
        case 107:;
        case 108:;
        case 110:;
        case 113:;
        case 114:;
        case 116:;
        case 117:;
        case 119:;
        case 120:;
        case 122:;
        case 123:;
        case 124:;
        case 126:;
        case 128:;
        case 129:;
        case 130:;
        case 131:;
        case 133:;
        case 134:;
        case 135:;
        case 136:;
        case 137:;
        case 138:;
        case 139:;
        case 140:;
        case 141:;
        case 142:;
        case 145:;
        case 146:;
        case 148:;
        case 149:;
        case 150:;
        case 151:;
        case 152:;
        case 154:;
        case 156:;
        case 158:;
        case 159:;
        case 160:;
        case 163:;
        case 165:;
        case 167:;
        case 168:;
        case 169:;
        case 170:;
        case 171:;
        case 172:;
        case 173:;
        case 174:;
        case 176:;
        case 177:;
        case 178:;
        case 179:;
        case 181:;
        case 182:;
        case 184:;
        case 186:;
        case 187:;
        case 188:;
        case 190:;
        case 191:;
        case 192:;
        case 193:;
        case 195:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_1.Ident = Idents_MakeIdent(&Word);
          return Scanner_TokIdent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 34:;
          while (yyChBufferPtr->A[yyChBufferIndex] == ' ') {
            INC(yyChBufferIndex);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 33:;
          DEC1(yyLineStart, 7 - (yyChBufferIndex - yyLineStart - 2) % 8);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 32:;
          INC(yyLineCount);
          yyLineStart = yyChBufferIndex - 1;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 1:;
        case 2:;
        case 3:;
        case 4:;
        case 5:;
        case 6:;
        case 7:;
        case 8:;
        case 16:;
        case 26:;
        case 27:;
        case 28:;
        case 29:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          break;
        case 31:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
          INC(yyChBufferIndex);
          Scanner_TokenLength = 1;
          Errors_ErrorMessage((LONGCARD)Errors_IllegalChar, (LONGCARD)Errors_Error, Scanner_Attribute.Position);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case yyDNoState:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 30:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          if (Scanner_TokenLength == 0) {
            yyState = yyStartState;
          } else {
            yyState = yyStateStack->A[Scanner_TokenLength];
          }
          if (yyChBufferIndex != yyChBufferStart + yyBytesRead) {
            yyState = yyEobTrans.A[yyState];
            if (yyState != yyDNoState) {
              INC(yyChBufferIndex);
              INC(Scanner_TokenLength);
              yyStateStack->A[Scanner_TokenLength] = yyState;
              yyRestart = TRUE;
              goto EXIT_4;
            }
          } else {
            yySource = yyChBufferIndex - Scanner_TokenLength - 1;
            yyTarget = General_MaxAlign - Scanner_TokenLength % General_MaxAlign - 1;
            if (yySource != yyTarget) {
              {
                LONGINT B_1 = 1, B_2 = Scanner_TokenLength;

                if (B_1 <= B_2)
                  for (yyi = B_1;; yyi += 1) {
                    yyChBufferPtr->A[yyTarget + yyi] = yyChBufferPtr->A[yySource + yyi];
                    if (yyi >= B_2) break;
                  }
              }
              DEC1(yyLineStart, yySource - yyTarget);
              yyChBufferStart = yyTarget + Scanner_TokenLength + 1;
            } else {
              yyChBufferStart = yyChBufferIndex;
            }
            if (!yyEof) {
              yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
              if (yyChBufferFree < yyChBufferSize / 8) {
                DynArray_ExtendArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
                if (yyChBufferPtr == NIL) {
                  yyErrorMessage(1);
                }
                yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
                if (yyStateStackSize < yyChBufferSize) {
                  DynArray_ExtendArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
                  if (yyStateStack == NIL) {
                    yyErrorMessage(1);
                  }
                }
              }
              yyChBufferIndex = yyChBufferStart;
              yyBytesRead = Source_GetLine(yySourceFile, ADR(yyChBufferPtr->A[yyChBufferIndex]), (LONGCARD)yyChBufferFree);
              if (yyBytesRead <= 0) {
                yyBytesRead = 0;
                yyEof = TRUE;
              }
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead] = yyEobCh;
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead + 1] = '\0';
              yyRestart = TRUE;
              goto EXIT_4;
            }
            if (Scanner_TokenLength == 0) {
              Scanner_Attribute.Position.Line = yyLineCount;
              Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
              Scanner_CloseFile();
              if (yyFileStackPtr == 0) {
                if (yyStartState == Comment) {
                  Errors_ErrorMessage((LONGCARD)Errors_UnclosedComment, (LONGCARD)Errors_Error, Scanner_Attribute.Position);
                }
              }
              if (yyFileStackPtr == 0) {
                return Scanner_EofToken;
              }
              yyRestart = FALSE;
              goto EXIT_4;
            }
          }
          break;
        default :
          yyErrorMessage(0);
          break;
        }
      } EXIT_4:;
      if (yyRestart) {
      } else {
        goto EXIT_2;
      }
    } EXIT_2:;
  } EXIT_1:;
}

void Scanner_BeginFile
# ifdef __STDC__
(CHAR FileName[], LONGCARD O_1)
# else
(FileName, O_1)
CHAR FileName[];
LONGCARD O_1;
# endif
{
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_1 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(FileName, O_1, CHAR)
  if (yyIsFirstCall) {
    yyFileStackPtr = 0;
    yyIsFirstCall = FALSE;
  }
  yyInitialize();
  yySourceFile = Source_BeginSource(FileName, O_1);
  if (yySourceFile < 0) {
    yyErrorMessage(5);
  }
  FREE_OPEN_ARRAYS
}

static void yyInitialize
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr >= yyFileStackSize) {
    yyErrorMessage(3);
  }
  INC(yyFileStackPtr);
  {
    register struct S_9 *W_1 = &yyFileStack.A[yyFileStackPtr - 1];

    W_1->SourceFile = yySourceFile;
    W_1->Eof = yyEof;
    W_1->ChBufferPtr = yyChBufferPtr;
    W_1->ChBufferStart = yyChBufferStart;
    W_1->ChBufferSize = yyChBufferSize;
    W_1->ChBufferIndex = yyChBufferIndex;
    W_1->BytesRead = yyBytesRead;
    W_1->LineCount = yyLineCount;
    W_1->LineStart = yyLineStart;
  }
  yyChBufferSize = yyInitBufferSize;
  DynArray_MakeArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  if (yyChBufferPtr == NIL) {
    yyErrorMessage(1);
  }
  yyChBufferStart = General_MaxAlign;
  yyChBufferPtr->A[yyChBufferStart - 1] = yyEolCh;
  yyChBufferPtr->A[yyChBufferStart] = yyEobCh;
  yyChBufferPtr->A[yyChBufferStart + 1] = '\0';
  yyChBufferIndex = yyChBufferStart;
  yyEof = FALSE;
  yyBytesRead = 0;
  yyLineCount = 1;
  yyLineStart = yyChBufferStart - 1;
}

void Scanner_CloseFile
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr == 0) {
    yyErrorMessage(4);
  }
  Source_CloseSource(yySourceFile);
  DynArray_ReleaseArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  {
    register struct S_9 *W_2 = &yyFileStack.A[yyFileStackPtr - 1];

    yySourceFile = W_2->SourceFile;
    yyEof = W_2->Eof;
    yyChBufferPtr = W_2->ChBufferPtr;
    yyChBufferStart = W_2->ChBufferStart;
    yyChBufferSize = W_2->ChBufferSize;
    yyChBufferIndex = W_2->ChBufferIndex;
    yyBytesRead = W_2->BytesRead;
    yyLineCount = W_2->LineCount;
    yyLineStart = W_2->LineStart;
  }
  DEC(yyFileStackPtr);
}

void Scanner_GetWord
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_3 = 1, B_4 = Scanner_TokenLength;

    if (B_3 <= B_4)
      for (i = B_3;; i += 1) {
        Word->Chars.A[i] = yyChBufferPtr->A[WordStart + i];
        if (i >= B_4) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetLower
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_5 = 1, B_6 = Scanner_TokenLength;

    if (B_5 <= B_6)
      for (i = B_5;; i += 1) {
        Word->Chars.A[i] = yyToLower.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_6) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetUpper
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_7 = 1, B_8 = Scanner_TokenLength;

    if (B_7 <= B_8)
      for (i = B_7;; i += 1) {
        Word->Chars.A[i] = yyToUpper.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_8) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

static void yyStart
# ifdef __STDC__
(yyStateRange State)
# else
(State)
yyStateRange State;
# endif
{
  yyPreviousStart = yyStartState;
  yyStartState = State;
}

static void yyPrevious
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange s;

  s = yyStartState;
  yyStartState = yyPreviousStart;
  yyPreviousStart = s;
}

static void yyEcho
# ifdef __STDC__
()
# else
()
# endif
{
  INTEGER i;

  {
    LONGINT B_9 = yyChBufferIndex - Scanner_TokenLength, B_10 = yyChBufferIndex - 1;

    if (B_9 <= B_10)
      for (i = B_9;; i += 1) {
        IO_WriteC((rSystem_tFile)IO_StdOutput, yyChBufferPtr->A[i]);
        if (i >= B_10) break;
      }
  }
}

static void yyLess
# ifdef __STDC__
(INTEGER n)
# else
(n)
INTEGER n;
# endif
{
  DEC1(yyChBufferIndex, Scanner_TokenLength - n);
  Scanner_TokenLength = n;
}

static void yyTab
# ifdef __STDC__
()
# else
()
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - 2) % yyTabSpace);
}

static void yyTab1
# ifdef __STDC__
(INTEGER a)
# else
(a)
INTEGER a;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyTab2
# ifdef __STDC__
(INTEGER a, INTEGER b)
# else
(a, b)
INTEGER a, b;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyEol
# ifdef __STDC__
(INTEGER Column)
# else
(Column)
INTEGER Column;
# endif
{
  INC(yyLineCount);
  yyLineStart = yyChBufferIndex - 1 - Column;
}

static void output
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  IO_WriteC((rSystem_tFile)IO_StdOutput, c);
}

static void unput
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  DEC(yyChBufferIndex);
  yyChBufferPtr->A[yyChBufferIndex] = c;
}

static CHAR input
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    if (!yyEof) {
      DEC1(yyLineStart, yyBytesRead);
      yyChBufferIndex = 0;
      yyChBufferStart = 0;
      yyBytesRead = Source_GetLine(yySourceFile, (ADDRESS)yyChBufferPtr, (LONGCARD)General_Exp2(General_Log2(yyChBufferSize)));
      if (yyBytesRead <= 0) {
        yyBytesRead = 0;
        yyEof = TRUE;
      }
      yyChBufferPtr->A[yyBytesRead] = yyEobCh;
      yyChBufferPtr->A[yyBytesRead + 1] = '\0';
    }
  }
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    return '\0';
  } else {
    INC(yyChBufferIndex);
    return yyChBufferPtr->A[yyChBufferIndex - 1];
  }
}

void Scanner_BeginScanner
# ifdef __STDC__
()
# else
()
# endif
{
  NestingLevel = 0;
}

void Scanner_CloseScanner
# ifdef __STDC__
()
# else
()
# endif
{
}

static void UnpackBaseHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyBasePtr.A[yyunpackindex] = (LONGCARD)ADR(yyComb.A[value]);
  INC(yyunpackindex);
}

static void UnpackDefaultHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyDefault.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackEobTransHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyEobTrans.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackCombHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  if (!ODD(yyunpackindex)) {
    yyComb.A[yyunpackindex / 2].Check = value;
  } else {
    yyComb.A[yyunpackindex / 2].Next = value;
  }
  INC(yyunpackindex);
}

static void yyInitTables
# ifdef __STDC__
()
# else
()
# endif
{
  Pack_UnpackCardHandler hc;

  hc = UnpackBaseHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"++VB+VP+W:+X3[4+]1]G+_>_H,++++a=c8<c@V6+++++++++++8<-F,", 55L, 42L);
  Pack_UnpackCard(hc, (STRING)"B+I?M+POV-+V2L+QLV/V-+c4TV6++V<V4+V>V1+VK\\GV<W-YC+YMZD\\B", 56L, 38L);
  Pack_UnpackCard(hc, (STRING)"+\\I\\G],+\\G]4\\T]8]<]:]?]A+]S]7]D^4^6]R_0_?+_<_8_3_C_=+c7", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)"++_K_G+`@`MbSc3c;+c2c3c4+cA+c5c<c4c6+cGcCcLcDc?cScAcMcH", 55L, 31L);
  Pack_UnpackCard(hc, (STRING)"cJ++cJcM+cOcScOcMcL+cM+d4+cQd6d6++d9+cT+d;d:d6d<d2d>d:d<", 56L, 33L);
  Pack_UnpackCard(hc, (STRING)"+dJd>d:d:+d<dK+dL+dKdJdF+dHdCe,d?+e-++++++++.++e5+++e7+", 55L, 38L);
  Pack_UnpackCard(hc, (STRING)"+eG++++++eL++++++++eN++eN", 25L, 21L);
  hc = UnpackDefaultHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"8,A.5042HHH;H+HH;;+++H7:HD<D+++HH+A54888888888888888888", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"8888888888888888888888888888888888888888888888888888888", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"8888888888888888888888888888888888888888888888888888888", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"8888888888888888888888888888888+++++++H++H+++H++H++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"H++KL++++6++6", 13L, 13L);
  hc = UnpackEobTransHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"++AA554445+++++++++++A++++++++++++A54++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++", 13L, 13L);
  hc = UnpackCombHandler;
  yyunpackindex = 0;
  Pack_UnpackCard(hc, (STRING)"++++++++++++++++++,L,K++,9,9+++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++,M++,Z<,Z8++++,Z7,Z>,Z6,Z5,Z4,Z3,Z2,Z1,Z/,Z.,7", 55L, 43L);
  Pack_UnpackCard(hc, (STRING)",7,7,7,7,7,7,7,B,B,Z,,Z+,YR,YQ,YOC@YOYP,YA,Y;,Y3,XP,XA,", 55L, 43L);
  Pack_UnpackCard(hc, (STRING)"QSTV+V,,X+.L.K,WQ,WK,WH,WE,W6,W-,VI,VF,V>,V9,V6,V.0Z:0Z9", 56L, 39L);
  Pack_UnpackCard(hc, (STRING)"<?,YNQR,YM,YLQX>EG.NEGRSTV+V,V-V.V2V.V/V/V0.ZBV0V1.Z?2Z:", 56L, 38L);
  Pack_UnpackCard(hc, (STRING)"2Z9V2V30OV3V4V4V5V6V7V7V8V9V:V:V;0Z=V;V<V<V=V?V@V@VA,YK", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)",YJ,YI,YHHIVCVDVDVEVFVG2PVGVH2Z;444444444444444444VIVJVK", 56L, 41L);
  Pack_UnpackCard(hc, (STRING)"VL4444444444444444444444444444444444444444444444VLVM444", 55L, 52L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444444444444444444444444444444444444444444", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"4444444444444444555555555555555555VMVNVOVP5555555555555", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555VPVQ55555555", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555555555555555", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555555555555555", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"5555555555555555555555555555555555555555555555555555555", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"57CVJVS77777777777777777B7B88VQVRVJVOVSVTVTW+W+W,VJVKW-", 55L, 40L);
  Pack_UnpackCard(hc, (STRING)"W.7<7=W.W/W/W088888888888888888888W0W1W1W2W2W3W3W4W4W5W7", 56L, 40L);
  Pack_UnpackCard(hc, (STRING)"W8W8W98888888888888888888888888888888888888888888888888", 55L, 52L);
  Pack_UnpackCard(hc, (STRING)"888W6W?W9W:W:W;W6W788W;W<888888888888888888888888888888", 55L, 45L);
  Pack_UnpackCard(hc, (STRING)"8888888888888888888888::::::::::::::::::::;;;;;;;;;;;;;", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)";;;;;;;W<W=:EW=W>W?W@W@WAWAWBWBWC;;;;;;;;;;;;WCWD;>AAAA", 55L, 41L);
  Pack_UnpackCard(hc, (STRING)"AAAAAAAAAAAAAAWHWIWIWJAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"AAAAAAAAAAAAAAAAAAAAAAAAAWKWLAAWLWMAAAAAAAAAAAAAAAAAAAA", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAABBBBBBBBBBBBBBBBD", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"DDDDDDDDDDDDDDDDDDDBFB;V>VCWEWGWMWNWNWOWOWPWQWRWRWSV>VB", 55L, 39L);
  Pack_UnpackCard(hc, (STRING)"WSWTX-X.X/X0X+X=X.X2WEWFX0X1X.X/X2X3V>V?X+X-X+X,X3X4X4X5", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"X5X6X6X7X7X8X8X9X9X:X:X;X;X<X>X?X?X@XAXKXBXGXAXIXCXDXDXE", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"XEXFXGXHXIXJXBXCXKXLXLXOXMXNXAXBXPXTXLXMXRXSXTY+XPXRY+Y,", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"Y,Y-Y-Y.Y.Y/Y/Y0XPXQY0Y1Y1Y2Y3Y8Y4Y5Y5Y6Y6Y7Y8Y9Y9Y:Y;Y=", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"Y=Y>Y>Y?Y?Y@YBYCYAYFYCYDYDYEY3Y4YAYBYFYGYRYTYRYSZ,Z-Z/Z0", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"Z6ZAZ?Z@ZBZA++++Y;Y<+++++++++++++++++++++++++++++++++++", 55L, 47L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++", 19L, 19L);
}

static void yyErrorMessage
# ifdef __STDC__
(SHORTCARD ErrorCode)
# else
(ErrorCode)
SHORTCARD ErrorCode;
# endif
{
  Positions_WritePosition((rSystem_tFile)IO_StdError, Scanner_Attribute.Position);
  switch (ErrorCode) {
  case 0:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: internal error", 25L);
    break;
  case 1:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: out of memory", 24L);
    break;
  case 3:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: too many nested include files", 40L);
    break;
  case 4:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: file stack underflow (too many calls of CloseFile)", 61L);
    break;
  case 5:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: cannot open input file", 33L);
    break;
  }
  IO_WriteNl((rSystem_tFile)IO_StdError);
  (*Scanner_Exit)();
}

static void yyExit
# ifdef __STDC__
()
# else
()
# endif
{
  IO_CloseIO();
  rExit(1L);
}

void BEGIN_Scanner()
{
  static BOOLEAN has_been_called = FALSE;
  if (has_been_called) return;
  has_been_called = TRUE;
    BEGIN_Strings();
    BEGIN_Idents();
    BEGIN_Positions();
    BEGIN_Checks();
    BEGIN_rSystem();
    BEGIN_General();
    BEGIN_Pack();
    BEGIN_Positions();
    BEGIN_IO();
    BEGIN_DynArray();
    BEGIN_Strings();
    BEGIN_Source();
    BEGIN_Strings();
    BEGIN_Idents();
    BEGIN_Errors();

    Scanner_Exit = yyExit;
    yyIsFirstCall = TRUE;
    yyFileStackPtr = 0;
    yyInitialize();
    yySourceFile = rSystem_StdInput;
    yyStartState = STD;
    yyPreviousStart = STD;
    yyStateStackSize = yyInitBufferSize;
    DynArray_MakeArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
    yyStateStack->A[0] = yyDefaultState;
    yyInitTables();
    for (yyCh = yyFirstCh; yyCh <= yyLastCh; yyCh += 1) {
      yyToLower.A[yyCh] = yyCh;
    }
    yyToUpper = yyToLower;
    for (yyCh = 'A'; yyCh <= 'Z'; yyCh += 1) {
      yyToLower.A[yyCh] = CHR(ORD(yyCh) - ORD('A') + ORD('a'));
    }
    for (yyCh = 'a'; yyCh <= 'z'; yyCh += 1) {
      yyToUpper.A[yyCh] = CHR(ORD(yyCh) - ORD('a') + ORD('A'));
    }
}
