#include "SYSTEM_.h"

#ifndef DEFINITION_Checks
#include "Checks.h"
#endif

#ifndef DEFINITION_rSystem
#include "rSystem.h"
#endif

#ifndef DEFINITION_General
#include "General.h"
#endif

#ifndef DEFINITION_Pack
#include "Pack.h"
#endif

#ifndef DEFINITION_Positions
#include "Positions.h"
#endif

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_DynArray
#include "DynArray.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Source
#include "Source.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Texts
#include "Texts.h"
#endif

#ifndef DEFINITION_StringMem
#include "StringMem.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_Errors
#include "Errors.h"
#endif

#ifndef DEFINITION_Positions
#include "Positions.h"
#endif

#ifndef DEFINITION_Scanner
#include "Scanner.h"
#endif

INTEGER Scanner_TokenLength;
Scanner_tScanAttribute Scanner_Attribute;
PROC Scanner_Exit;

#define SymIdent	1
#define SymNumber	2
#define SymString	3
#define SymChar	4
#define SymTargetcode	5
#define SymExport	32
#define SymGlobal	6
#define SymLocal	31
#define SymBegin	7
#define SymClose	8
#define SymEof	34
#define SymDefault	36
#define SymDefine	9
#define SymStart	10
#define SymRules	11
#define SymNot	30
#define SymDot	12
#define SymComma	13
#define SymEqual	14
#define SymColon	15
#define SymColonMinus	35
#define SymNrSign	33
#define SymSlash	16
#define SymBar	17
#define SymPlus	18
#define SymMinus	19
#define SymAsterisk	20
#define SymQuestion	21
#define SymLParen	22
#define SymRParen	23
#define SymLBracket	24
#define SymRBracket	25
#define SymLBrace	26
#define SymRBrace	27
#define SymLess	28
#define SymGreater	29
#define BraceMissing	13
#define UnclosedComment	14
#define UnclosedString	16
#define Error	3
static INTEGER level;
static Strings_tString string;
static StringMem_tStringRef NoString;
static Positions_tPosition Position;
#define yyTabSpace	8
#define yyDNoState	0
#define yyFileStackSize	16
#define yyInitBufferSize	(1024 * 8 + 256)
#define yyFirstCh	'\0'
#define yyLastCh	((CHAR)'\177')
#define yyEolCh	'\n'
#define yyEobCh	((CHAR)'\177')
#define yyDStateCount	159
#define yyTableSize	2029
#define yyEobState	47
#define yyDefaultState	48
#define STD	1
#define targetcode	3
#define set	5
#define rules	7
#define comment	9
#define Str1	11
#define Str2	13
#define CStr1	15
#define CStr2	17
typedef SHORTCARD yyTableElmt;
typedef yyTableElmt yyStateRange;
typedef yyTableElmt yyTableRange;
typedef struct S_1 {
    yyStateRange Check, Next;
} yyCombType;
typedef yyCombType *yyCombTypePtr;
typedef struct S_11 {
    CHAR A[1000000 + 1];
} *yytChBufferPtr;
typedef CHAR yyChRange;
static struct S_2 {
    LONGCARD A[yyDStateCount + 1];
} yyBasePtr;
static struct S_3 {
    yyStateRange A[yyDStateCount + 1];
} yyDefault;
static struct S_4 {
    yyCombType A[yyTableSize + 1];
} yyComb;
static struct S_5 {
    yyStateRange A[yyDStateCount + 1];
} yyEobTrans;
static struct S_6 {
    CHAR A[yyLastCh + 1];
} yyToLower, yyToUpper;
static struct S_7 {
    yyStateRange A[1000000 + 1];
} *yyStateStack;
static LONGINT yyStateStackSize;
static yyStateRange yyStartState;
static yyStateRange yyPreviousStart;
static CHAR yyCh;
static BOOLEAN yyIsFirstCall;
static rSystem_tFile yySourceFile;
static BOOLEAN yyEof;
static yytChBufferPtr yyChBufferPtr;
static INTEGER yyChBufferStart;
static LONGINT yyChBufferSize;
static INTEGER yyChBufferIndex;
static INTEGER yyBytesRead;
static CARDINAL yyLineCount;
static INTEGER yyLineStart;
static SHORTCARD yyFileStackPtr;
static struct S_8 {
    struct S_9 {
        rSystem_tFile SourceFile;
        BOOLEAN Eof;
        yytChBufferPtr ChBufferPtr;
        INTEGER ChBufferStart;
        LONGINT ChBufferSize;
        INTEGER ChBufferIndex;
        INTEGER BytesRead;
        CARDINAL LineCount;
        INTEGER LineStart;
    } A[yyFileStackSize - 1 + 1];
} yyFileStack;
static void yyInitialize ARGS(());
static void yyStart ARGS((yyStateRange State));
static void yyPrevious ARGS(());
static void yyEcho ARGS(());
static void yyLess ARGS((INTEGER n));
static void yyTab ARGS(());
static void yyTab1 ARGS((INTEGER a));
static void yyTab2 ARGS((INTEGER a, INTEGER b));
static void yyEol ARGS((INTEGER Column));
static void output ARGS((CHAR c));
static void unput ARGS((CHAR c));
static CHAR input ARGS(());
static CARDINAL yyunpackindex;
static void UnpackBaseHandler ARGS((LONGCARD value));
static void UnpackDefaultHandler ARGS((LONGCARD value));
static void UnpackEobTransHandler ARGS((LONGCARD value));
static void UnpackCombHandler ARGS((LONGCARD value));
static void yyInitTables ARGS(());
static void yyErrorMessage ARGS((SHORTCARD ErrorCode));
static void yyExit ARGS(());

void Scanner_ErrorAttribute
# ifdef __STDC__
(CARDINAL Token, Scanner_tScanAttribute *Attribute)
# else
(Token, Attribute)
CARDINAL Token;
Scanner_tScanAttribute *Attribute;
# endif
{
  switch (Token) {
  case SymIdent:;
    Attribute->U_1.V_1.Ident = Idents_NoIdent;
    break;
  case SymNumber:;
    Attribute->U_1.V_2.Number = 0;
    break;
  case SymString:;
    Attribute->U_1.V_3.String = NoString;
    break;
  case SymChar:;
    Attribute->U_1.V_4.Ch = '?';
    break;
  case SymTargetcode:;
    Texts_MakeText(&Attribute->U_1.V_5.Text);
    break;
  default :
    break;
  }
}

INTEGER Scanner_GetToken
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange yyState;
  yyCombTypePtr yyTablePtr;
  BOOLEAN yyRestart;
  INTEGER yyi, yySource, yyTarget, yyChBufferFree;
  Strings_tString TargetCode, String, Word;
  SHORTCARD PrevState;

  for (;;) {
    yyState = yyStartState;
    Scanner_TokenLength = 0;
    for (;;) {
      for (;;) {
        yyTablePtr = (yyCombTypePtr)(yyBasePtr.A[yyState] + ORD(yyChBufferPtr->A[yyChBufferIndex]) * sizeof(yyCombType));
        if (yyTablePtr->Check != yyState) {
          yyState = yyDefault.A[yyState];
          if (yyState == yyDNoState) {
            goto EXIT_3;
          }
        } else {
          yyState = yyTablePtr->Next;
          INC(Scanner_TokenLength);
          yyStateStack->A[Scanner_TokenLength] = yyState;
          INC(yyChBufferIndex);
        }
      } EXIT_3:;
      for (;;) {
        switch (yyStateStack->A[Scanner_TokenLength]) {
        case 159:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          if (level == 0) {
            Texts_MakeText(&Scanner_Attribute.U_1.V_5.Text);
            Strings_AssignEmpty(&TargetCode);
            Position = Scanner_Attribute.Position;
          } else {
            Scanner_GetWord(&Word);
            Strings_Concatenate(&TargetCode, &Word);
          }
          INC(level);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 158:;
          DEC(level);
          if (level == 0) {
            yyStart(PrevState);
            Texts_Append(&Scanner_Attribute.U_1.V_5.Text, &TargetCode);
            Scanner_Attribute.Position = Position;
            return SymTargetcode;
          } else {
            Scanner_GetWord(&Word);
            Strings_Concatenate(&TargetCode, &Word);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 31:;
        case 52:;
        case 59:;
        case 66:;
          if (level > 0) {
            Scanner_GetWord(&Word);
            Strings_Concatenate(&TargetCode, &Word);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 157:;
          if (level > 0) {
            Strings_Append(&TargetCode, '\t');
          }
          yyTab();
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 156:;
          if (level > 0) {
            Texts_Append(&Scanner_Attribute.U_1.V_5.Text, &TargetCode);
            Strings_AssignEmpty(&TargetCode);
          }
          yyEol(0L);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 32:;
          if (level > 0) {
            Scanner_GetWord(&Word);
            Strings_Append(&TargetCode, Strings_Char(&Word, 2));
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 29:;
          if (level > 0) {
            Strings_Append(&TargetCode, '\\');
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 155:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&String);
          yyStart(CStr1);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 154:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&String);
          yyStart(CStr2);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 22:;
        case 54:;
        case 61:;
        case 68:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 21:;
        case 55:;
        case 62:;
        case 69:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 20:;
        case 35:;
        case 43:;
        case 56:;
        case 63:;
        case 70:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 19:;
        case 34:;
        case 42:;
        case 57:;
        case 64:;
        case 71:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 153:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyEol(0L);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 152:;
          Scanner_GetWord(&Word);
          Strings_Concatenate(&String, &Word);
          yyEol(0L);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 151:;
          Strings_Append(&String, Strings_Char(&String, 1));
          yyPrevious();
          Strings_Concatenate(&TargetCode, &String);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 150:;
          Strings_Append(&String, Strings_Char(&String, 1));
          yyPrevious();
          Strings_Concatenate(&TargetCode, &String);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 149:;
          Strings_Append(&String, '\t');
          yyTab();
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 148:;
          Errors_ErrorMessage((LONGCARD)UnclosedString, (LONGCARD)Error, Scanner_Attribute.Position);
          Strings_Append(&String, Strings_Char(&String, 1));
          yyEol(0L);
          yyPrevious();
          Strings_Concatenate(&TargetCode, &String);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 147:;
          yyStart(comment);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 23:;
        case 36:;
        case 53:;
        case 60:;
        case 67:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 145:;
          yyPrevious();
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 144:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          PrevState = STD;
          yyStart(targetcode);
          return SymExport;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 139:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          PrevState = STD;
          yyStart(targetcode);
          return SymGlobal;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 133:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          PrevState = STD;
          yyStart(targetcode);
          return SymLocal;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 128:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          PrevState = STD;
          yyStart(targetcode);
          return SymBegin;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 123:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          PrevState = STD;
          yyStart(targetcode);
          return SymClose;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 118:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          PrevState = STD;
          yyStart(targetcode);
          return SymDefault;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 114:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          PrevState = STD;
          yyStart(targetcode);
          return SymEof;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 111:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymDefine;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 105:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymStart;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 33:;
        case 41:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          yyStart(rules);
          return SymRules;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 100:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymNot;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 25:;
        case 39:;
        case 44:;
        case 45:;
        case 98:;
        case 99:;
        case 101:;
        case 102:;
        case 103:;
        case 104:;
        case 106:;
        case 107:;
        case 108:;
        case 109:;
        case 110:;
        case 112:;
        case 113:;
        case 115:;
        case 116:;
        case 117:;
        case 119:;
        case 120:;
        case 121:;
        case 122:;
        case 124:;
        case 125:;
        case 126:;
        case 127:;
        case 129:;
        case 130:;
        case 131:;
        case 132:;
        case 134:;
        case 135:;
        case 136:;
        case 137:;
        case 138:;
        case 140:;
        case 141:;
        case 142:;
        case 143:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_1.Ident = Idents_MakeIdent(&Word);
          return SymIdent;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 26:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_2.Number = Strings_StringToInt(&Word);
          return SymNumber;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 30:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Strings_SubString(&Word, 2, (Strings_tStringIndex)(Strings_Length(&Word) - 1), &TargetCode);
          Scanner_Attribute.U_1.V_3.String = StringMem_PutString(&TargetCode);
          return SymString;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 97:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymDot;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 96:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymEqual;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 95:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          yyPrevious();
          return SymRBrace;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 94:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymMinus;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 93:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymComma;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 92:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymBar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 91:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymPlus;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 90:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymAsterisk;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 89:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymQuestion;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 88:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymLParen;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 87:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymRParen;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 86:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymLBracket;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 85:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymRBracket;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 84:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          yyStart(set);
          return SymLBrace;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 83:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymNrSign;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 82:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymSlash;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 81:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymLess;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 80:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          return SymGreater;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 78:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          PrevState = rules;
          yyStart(targetcode);
          return SymColon;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 79:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          PrevState = rules;
          yyStart(targetcode);
          return SymColonMinus;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 77:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_Attribute.U_1.V_4.Ch = '\n';
          return SymChar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 76:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_Attribute.U_1.V_4.Ch = '\t';
          return SymChar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 75:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_Attribute.U_1.V_4.Ch = ((CHAR)'\13');
          return SymChar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 74:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_Attribute.U_1.V_4.Ch = '\b';
          return SymChar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 73:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_Attribute.U_1.V_4.Ch = '\r';
          return SymChar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 72:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_Attribute.U_1.V_4.Ch = '\f';
          return SymChar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 28:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Strings_SubString(&Word, 2, (Strings_tStringIndex)Strings_Length(&Word), &TargetCode);
          Scanner_Attribute.U_1.V_4.Ch = CHR((CARDINAL)Strings_StringToInt(&TargetCode));
          return SymChar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 27:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_4.Ch = Strings_Char(&Word, 2);
          return SymChar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 24:;
        case 37:;
        case 38:;
        case 146:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart - Scanner_TokenLength;
          Scanner_GetWord(&Word);
          Scanner_Attribute.U_1.V_4.Ch = Strings_Char(&Word, 1);
          return SymChar;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 65:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 58:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 51:;
          while (yyChBufferPtr->A[yyChBufferIndex] == ' ') {
            INC(yyChBufferIndex);
          }
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 50:;
          DEC1(yyLineStart, 7 - (yyChBufferIndex - yyLineStart - 2) % 8);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 49:;
          INC(yyLineCount);
          yyLineStart = yyChBufferIndex - 1;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 1:;
        case 2:;
        case 3:;
        case 4:;
        case 5:;
        case 6:;
        case 7:;
        case 8:;
        case 9:;
        case 10:;
        case 11:;
        case 12:;
        case 13:;
        case 14:;
        case 15:;
        case 16:;
        case 17:;
        case 18:;
        case 40:;
        case 46:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          break;
        case 48:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
          INC(yyChBufferIndex);
          Scanner_TokenLength = 1;
          IO_WriteC((rSystem_tFile)IO_StdOutput, yyChBufferPtr->A[yyChBufferIndex - 1]);
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case yyDNoState:;
          yyRestart = FALSE;
          goto EXIT_4;
          break;
        case 47:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          if (Scanner_TokenLength == 0) {
            yyState = yyStartState;
          } else {
            yyState = yyStateStack->A[Scanner_TokenLength];
          }
          if (yyChBufferIndex != yyChBufferStart + yyBytesRead) {
            yyState = yyEobTrans.A[yyState];
            if (yyState != yyDNoState) {
              INC(yyChBufferIndex);
              INC(Scanner_TokenLength);
              yyStateStack->A[Scanner_TokenLength] = yyState;
              yyRestart = TRUE;
              goto EXIT_4;
            }
          } else {
            yySource = yyChBufferIndex - Scanner_TokenLength - 1;
            yyTarget = General_MaxAlign - Scanner_TokenLength % General_MaxAlign - 1;
            if (yySource != yyTarget) {
              {
                LONGINT B_1 = 1, B_2 = Scanner_TokenLength;

                if (B_1 <= B_2)
                  for (yyi = B_1;; yyi += 1) {
                    yyChBufferPtr->A[yyTarget + yyi] = yyChBufferPtr->A[yySource + yyi];
                    if (yyi >= B_2) break;
                  }
              }
              DEC1(yyLineStart, yySource - yyTarget);
              yyChBufferStart = yyTarget + Scanner_TokenLength + 1;
            } else {
              yyChBufferStart = yyChBufferIndex;
            }
            if (!yyEof) {
              yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
              if (yyChBufferFree < yyChBufferSize / 8) {
                DynArray_ExtendArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
                if (yyChBufferPtr == NIL) {
                  yyErrorMessage(1);
                }
                yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
                if (yyStateStackSize < yyChBufferSize) {
                  DynArray_ExtendArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
                  if (yyStateStack == NIL) {
                    yyErrorMessage(1);
                  }
                }
              }
              yyChBufferIndex = yyChBufferStart;
              yyBytesRead = Source_GetLine(yySourceFile, ADR(yyChBufferPtr->A[yyChBufferIndex]), (LONGCARD)yyChBufferFree);
              if (yyBytesRead <= 0) {
                yyBytesRead = 0;
                yyEof = TRUE;
              }
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead] = yyEobCh;
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead + 1] = '\0';
              yyRestart = TRUE;
              goto EXIT_4;
            }
            if (Scanner_TokenLength == 0) {
              Scanner_Attribute.Position.Line = yyLineCount;
              Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
              Scanner_CloseFile();
              if (yyFileStackPtr == 0) {
                switch (yyStartState) {
                case targetcode:;
                case set:;
                  Errors_ErrorMessage((LONGCARD)BraceMissing, (LONGCARD)Error, Scanner_Attribute.Position);
                  break;
                case comment:;
                  Errors_ErrorMessage((LONGCARD)UnclosedComment, (LONGCARD)Error, Scanner_Attribute.Position);
                  break;
                case CStr1:;
                case CStr2:;
                case Str1:;
                case Str2:;
                  Errors_ErrorMessage((LONGCARD)UnclosedString, (LONGCARD)Error, Scanner_Attribute.Position);
                  break;
                default :
                  break;
                }
                yyStart(STD);
              }
              if (yyFileStackPtr == 0) {
                return Scanner_EofToken;
              }
              yyRestart = FALSE;
              goto EXIT_4;
            }
          }
          break;
        default :
          yyErrorMessage(0);
          break;
        }
      } EXIT_4:;
      if (yyRestart) {
      } else {
        goto EXIT_2;
      }
    } EXIT_2:;
  } EXIT_1:;
}

void Scanner_BeginFile
# ifdef __STDC__
(CHAR FileName[], LONGCARD O_1)
# else
(FileName, O_1)
CHAR FileName[];
LONGCARD O_1;
# endif
{
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_1 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(FileName, O_1, CHAR)
  if (yyIsFirstCall) {
    yyFileStackPtr = 0;
    yyIsFirstCall = FALSE;
  }
  yyInitialize();
  yySourceFile = Source_BeginSource(FileName, O_1);
  if (yySourceFile < 0) {
    yyErrorMessage(5);
  }
  FREE_OPEN_ARRAYS
}

static void yyInitialize
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr >= yyFileStackSize) {
    yyErrorMessage(3);
  }
  INC(yyFileStackPtr);
  {
    register struct S_9 *W_1 = &yyFileStack.A[yyFileStackPtr - 1];

    W_1->SourceFile = yySourceFile;
    W_1->Eof = yyEof;
    W_1->ChBufferPtr = yyChBufferPtr;
    W_1->ChBufferStart = yyChBufferStart;
    W_1->ChBufferSize = yyChBufferSize;
    W_1->ChBufferIndex = yyChBufferIndex;
    W_1->BytesRead = yyBytesRead;
    W_1->LineCount = yyLineCount;
    W_1->LineStart = yyLineStart;
  }
  yyChBufferSize = yyInitBufferSize;
  DynArray_MakeArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  if (yyChBufferPtr == NIL) {
    yyErrorMessage(1);
  }
  yyChBufferStart = General_MaxAlign;
  yyChBufferPtr->A[yyChBufferStart - 1] = yyEolCh;
  yyChBufferPtr->A[yyChBufferStart] = yyEobCh;
  yyChBufferPtr->A[yyChBufferStart + 1] = '\0';
  yyChBufferIndex = yyChBufferStart;
  yyEof = FALSE;
  yyBytesRead = 0;
  yyLineCount = 1;
  yyLineStart = yyChBufferStart - 1;
}

void Scanner_CloseFile
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr == 0) {
    yyErrorMessage(4);
  }
  Source_CloseSource(yySourceFile);
  DynArray_ReleaseArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  {
    register struct S_9 *W_2 = &yyFileStack.A[yyFileStackPtr - 1];

    yySourceFile = W_2->SourceFile;
    yyEof = W_2->Eof;
    yyChBufferPtr = W_2->ChBufferPtr;
    yyChBufferStart = W_2->ChBufferStart;
    yyChBufferSize = W_2->ChBufferSize;
    yyChBufferIndex = W_2->ChBufferIndex;
    yyBytesRead = W_2->BytesRead;
    yyLineCount = W_2->LineCount;
    yyLineStart = W_2->LineStart;
  }
  DEC(yyFileStackPtr);
}

void Scanner_GetWord
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_3 = 1, B_4 = Scanner_TokenLength;

    if (B_3 <= B_4)
      for (i = B_3;; i += 1) {
        Word->Chars.A[i] = yyChBufferPtr->A[WordStart + i];
        if (i >= B_4) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetLower
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_5 = 1, B_6 = Scanner_TokenLength;

    if (B_5 <= B_6)
      for (i = B_5;; i += 1) {
        Word->Chars.A[i] = yyToLower.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_6) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetUpper
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_7 = 1, B_8 = Scanner_TokenLength;

    if (B_7 <= B_8)
      for (i = B_7;; i += 1) {
        Word->Chars.A[i] = yyToUpper.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_8) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

static void yyStart
# ifdef __STDC__
(yyStateRange State)
# else
(State)
yyStateRange State;
# endif
{
  yyPreviousStart = yyStartState;
  yyStartState = State;
}

static void yyPrevious
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange s;

  s = yyStartState;
  yyStartState = yyPreviousStart;
  yyPreviousStart = s;
}

static void yyEcho
# ifdef __STDC__
()
# else
()
# endif
{
  INTEGER i;

  {
    LONGINT B_9 = yyChBufferIndex - Scanner_TokenLength, B_10 = yyChBufferIndex - 1;

    if (B_9 <= B_10)
      for (i = B_9;; i += 1) {
        IO_WriteC((rSystem_tFile)IO_StdOutput, yyChBufferPtr->A[i]);
        if (i >= B_10) break;
      }
  }
}

static void yyLess
# ifdef __STDC__
(INTEGER n)
# else
(n)
INTEGER n;
# endif
{
  DEC1(yyChBufferIndex, Scanner_TokenLength - n);
  Scanner_TokenLength = n;
}

static void yyTab
# ifdef __STDC__
()
# else
()
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - 2) % yyTabSpace);
}

static void yyTab1
# ifdef __STDC__
(INTEGER a)
# else
(a)
INTEGER a;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyTab2
# ifdef __STDC__
(INTEGER a, INTEGER b)
# else
(a, b)
INTEGER a, b;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyEol
# ifdef __STDC__
(INTEGER Column)
# else
(Column)
INTEGER Column;
# endif
{
  INC(yyLineCount);
  yyLineStart = yyChBufferIndex - 1 - Column;
}

static void output
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  IO_WriteC((rSystem_tFile)IO_StdOutput, c);
}

static void unput
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  DEC(yyChBufferIndex);
  yyChBufferPtr->A[yyChBufferIndex] = c;
}

static CHAR input
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    if (!yyEof) {
      DEC1(yyLineStart, yyBytesRead);
      yyChBufferIndex = 0;
      yyChBufferStart = 0;
      yyBytesRead = Source_GetLine(yySourceFile, (ADDRESS)yyChBufferPtr, (LONGCARD)General_Exp2(General_Log2(yyChBufferSize)));
      if (yyBytesRead <= 0) {
        yyBytesRead = 0;
        yyEof = TRUE;
      }
      yyChBufferPtr->A[yyBytesRead] = yyEobCh;
      yyChBufferPtr->A[yyBytesRead + 1] = '\0';
    }
  }
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    return '\0';
  } else {
    INC(yyChBufferIndex);
    return yyChBufferPtr->A[yyChBufferIndex - 1];
  }
}

void Scanner_BeginScanner
# ifdef __STDC__
()
# else
()
# endif
{
  level = 0;
  Strings_AssignEmpty(&string);
  NoString = StringMem_PutString(&string);
}

void Scanner_CloseScanner
# ifdef __STDC__
()
# else
()
# endif
{
}

static void UnpackBaseHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyBasePtr.A[yyunpackindex] = (LONGCARD)ADR(yyComb.A[value]);
  INC(yyunpackindex);
}

static void UnpackDefaultHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyDefault.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackEobTransHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyEobTrans.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackCombHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  if (!ODD(yyunpackindex)) {
    yyComb.A[yyunpackindex / 2].Check = value;
  } else {
    yyComb.A[yyunpackindex / 2].Next = value;
  }
  INC(yyunpackindex);
}

static void yyInitTables
# ifdef __STDC__
()
# else
()
# endif
{
  Pack_UnpackCardHandler hc;

  hc = UnpackBaseHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"++VB+YB+\\C+VL+W7+W=+]S+^2+++`;c<=f=,W0+W:i>+l?+n:q7t8w9", 55L, 36L);
  Pack_UnpackCard(hc, (STRING)"++,z:1};VV<.VX7-+++++++++++++++++++++++++++++++F+++J+++", 55L, 49L);
  Pack_UnpackCard(hc, (STRING)"++++++++++++,1+9;=<+LLV.NV0+V+V2+NV/V0+V9V7VLW1+W2W1W0W,", 56L, 42L);
  Pack_UnpackCard(hc, (STRING)"+W,W9W<W2+W3W1W?WAW7+W4W6W4W3++X4+++++++++++++", 46L, 32L);
  hc = UnpackDefaultHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"D,J.@0L2O4A6@8N:M<++FFFGLF+FF+F+EFFFSFL@V.V/V/V.V/+++V/", 55L, 49L);
  Pack_UnpackCard(hc, (STRING)"V/+JOA@NM+JOA@NM+JOA@NMFFFFFFQ+QQQQQQQQQQQQQQQQQQV.V.V.", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.+Q+V2V3++++++V2V3++", 51L, 31L);
  hc = UnpackEobTransHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"QQJJQQQQOOAA@@NNMM++@A+F++++K+J++MNOS++S+>?++++++++JOA@", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NM+JOA@NM+JOA@NM+++++++++++++++++++++++++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++++++++++++++++++++++++++++++++++", 49L, 49L);
  hc = UnpackCombHandler;
  yyunpackindex = 0;
  Pack_UnpackCard(hc, (STRING)",Q,Q,Q,Q,Q,Q,Q,Q,Q,V3,V2,Q,VB,V;,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"Q,Q,Q,Q,Q,Q,Q,V4,Q,P,Q,Q,Q,Q,Q,W/,W.,W1,W2,W4,W5,W8,X?,", 55L, 46L);
  Pack_UnpackCard(hc, (STRING)"E,E,E,E,E,E,E,E,E,E,Q,Q,Q,W7,Q,W0,QBX>,WS,WN,WA,WGDT,X3", 55L, 47L);
  Pack_UnpackCard(hc, (STRING)"VOVPVSX@.XJ.XI,X..VC.V<V-DW9W:W=W>,R,W<4V34V2RV-4VD4V=T", 55L, 35L);
  Pack_UnpackCard(hc, (STRING)"LW:W;,W-,C,W,,Q,Q,Q.V5W<W=.XGW>W?W?W@WAWBWBWC.XH6XB6XA4", 55L, 36L);
  Pack_UnpackCard(hc, (STRING)"V66VE6V>WCWJ8XB8XAWDWE8VF8V?WEWF4BWCWDWHWIWJWKWGWHWKWL,", 55L, 32L);
  Pack_UnpackCard(hc, (STRING)"W+,W3,W6,QFV06V7V/V0WGX9WLWMWNWOWOWP8V86XD8XCEEEEEEEEEE", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"EEEEEEEEEEGGGGGGGGGGGGGGGGGGGG.HWPWQWQWRWSWTWTX+X+X,X,X-", 56L, 44L);
  Pack_UnpackCard(hc, (STRING)"X.X/X/X0X0X1X1X2X3X4X4X5X5X6X6X7X7X8X9X:X:X;X;X<X<X=X?X@", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"++++++++++++++++++++.XL++.XK0Q0Q0Q0Q0Q0Q0Q0Q0Q0V30V20Q0", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"VB0V;0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0V40Q0Q0Q0Q0Q0", 55L, 52L);
  Pack_UnpackCard(hc, (STRING)"Q0Q0Q0Q0Q0Q0Q0W50Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0", 55L, 54L);
  Pack_UnpackCard(hc, (STRING)"Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0C", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0Q0", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"Q0Q0Q0Q0Q0W60Q2Q2Q2Q2Q2Q2Q2Q2Q2Q2V32V22Q2VB2V;2Q2Q2Q2Q2", 55L, 50L);
  Pack_UnpackCard(hc, (STRING)"Q2Q2Q2Q2Q2Q2Q2Q2Q2Q2Q2Q2Q2Q2V42Q2P2VT2Q2Q2Q2Q2W/2W.2W12", 55L, 50L);
  Pack_UnpackCard(hc, (STRING)"W22W42W52Q2VS2E2E2E2E2E2E2E2E2E2E2VO2Q2VR2Q2VQ2W02Q++++", 55L, 47L);
  Pack_UnpackCard(hc, (STRING)":XB:XA++:VG:V@++++++++<XB<XA2W9<VH<VA++++++++++++++++++", 55L, 46L);
  Pack_UnpackCard(hc, (STRING)":V92W-2C2W,2Q2Q2Q:XD++<V:++<XC+++++++++++++++++++++++++", 55L, 49L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++++++2W+2W32Q2Q++++++++++++++++++++++++++++", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"++++++++++++++++++:V,++++++++++++++++<V+@@@@@@@@@@@@@@@", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"@@@++++@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"@@@@@@@@@@@@@@@@@@@AAAAAAAAAAAAAAAAAA++++AAAAAAAAAAAAAA", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA++AAAAAAAAAAA", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACF", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"CFCFCFCFCFCFCFCFCF++CFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFC", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"FCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCF++++++++++++++++", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"++++CFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFCFC", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"FCFCFCFCFCFCFCFCFCFCFCFCFCFCFCVKCFCFCFCVICFCFCFCFCFCFCF", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)"CVNCFCFCFCVJCFCVMCFCVLCFCFCFCFCFCFCFCFHKHKHKHKHKHKHKHKH", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"KHK++HKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHK", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"HKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKH", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"KHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHK", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"HKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKHKH", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"KHKHKHKHKHKHKHKHKJJJJJJJJJJJJJJJJJJ++++JJJJJJJJJJJJJJJJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"JJJJJJJJJJJJJJJJJJJJJJJJJJJJJJ++JJJJJJJJ++JJJJJJJJJJJJJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"JJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"JJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJ++JJJJJJJJJJJJJJJJJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"JJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJ++JJ++JJLV.L", 55L, 54L);
  Pack_UnpackCard(hc, (STRING)"V.LV.LV.LV.LV.LV.LV.LV.LV.++++++++++++++LV.LV.LV.LV.LV.", 55L, 41L);
  Pack_UnpackCard(hc, (STRING)"LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.L", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"V.LV.LV.++++++++LV.++LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.L", 55L, 40L);
  Pack_UnpackCard(hc, (STRING)"V.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.LV.MMMMMMMMMMM", 55L, 40L);
  Pack_UnpackCard(hc, (STRING)"MMMMMMM++++MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"MM++MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"MMMMMMMM++MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"MMMMMMMMMMMMMMMMMMMMMMMNNNNNNNNNNNNNNNNNN++++NNNNNNNNNN", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN++NNNNNNN", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN++NNNNNNNNNNN", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"NNOOOOOOOOOOOOOOOOOO++++OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO++OOOOOOOOOOOOOOOOOOOOOO", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOSSSSSSSSSSSSSSSSSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"S++SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSISSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"SSSSSSSSSSSSSSSV+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+XEV+>V+>", 55L, 41L);
  Pack_UnpackCard(hc, (STRING)"V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)">V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)">V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)">V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>V+>", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"V+>V+>V+>V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,XFV,?V,?V,?V,?", 55L, 36L);
  Pack_UnpackCard(hc, (STRING)"V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)"?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)"?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)"?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?V,?", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"V,?V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.++++++++++++", 55L, 34L);
  Pack_UnpackCard(hc, (STRING)"++V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.", 56L, 29L);
  Pack_UnpackCard(hc, (STRING)"V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.+++++", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)"+++V.V.++V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)"V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.V.", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V.++++++++++", 12L, 11L);
}

static void yyErrorMessage
# ifdef __STDC__
(SHORTCARD ErrorCode)
# else
(ErrorCode)
SHORTCARD ErrorCode;
# endif
{
  Positions_WritePosition((rSystem_tFile)IO_StdError, Scanner_Attribute.Position);
  switch (ErrorCode) {
  case 0:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: internal error", 25L);
    break;
  case 1:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: out of memory", 24L);
    break;
  case 3:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: too many nested include files", 40L);
    break;
  case 4:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: file stack underflow (too many calls of CloseFile)", 61L);
    break;
  case 5:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: cannot open input file", 33L);
    break;
  }
  IO_WriteNl((rSystem_tFile)IO_StdError);
  (*Scanner_Exit)();
}

static void yyExit
# ifdef __STDC__
()
# else
()
# endif
{
  IO_CloseIO();
  rExit(1L);
}

void BEGIN_Scanner()
{
  static BOOLEAN has_been_called = FALSE;
  if (has_been_called) return;
  has_been_called = TRUE;
    BEGIN_Strings();
    BEGIN_Idents();
    BEGIN_StringMem();
    BEGIN_Texts();
    BEGIN_Positions();
    BEGIN_Checks();
    BEGIN_rSystem();
    BEGIN_General();
    BEGIN_Pack();
    BEGIN_Positions();
    BEGIN_IO();
    BEGIN_DynArray();
    BEGIN_Strings();
    BEGIN_Source();
    BEGIN_Strings();
    BEGIN_Texts();
    BEGIN_StringMem();
    BEGIN_Idents();
    BEGIN_Errors();
    BEGIN_Positions();

    Scanner_Exit = yyExit;
    yyIsFirstCall = TRUE;
    yyFileStackPtr = 0;
    yyInitialize();
    yySourceFile = rSystem_StdInput;
    yyStartState = STD;
    yyPreviousStart = STD;
    yyStateStackSize = yyInitBufferSize;
    DynArray_MakeArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
    yyStateStack->A[0] = yyDefaultState;
    yyInitTables();
    for (yyCh = yyFirstCh; yyCh <= yyLastCh; yyCh += 1) {
      yyToLower.A[yyCh] = yyCh;
    }
    yyToUpper = yyToLower;
    for (yyCh = 'A'; yyCh <= 'Z'; yyCh += 1) {
      yyToLower.A[yyCh] = CHR(ORD(yyCh) - ORD('A') + ORD('a'));
    }
    for (yyCh = 'a'; yyCh <= 'z'; yyCh += 1) {
      yyToUpper.A[yyCh] = CHR(ORD(yyCh) - ORD('a') + ORD('A'));
    }
}
