#include "SYSTEM_.h"

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_Sets
#include "Sets.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_Positions
#include "Positions.h"
#endif

#ifndef DEFINITION_Errors
#include "Errors.h"
#endif

#ifndef DEFINITION_Errors
#include "Errors.h"
#endif

static INTEGER Integer;
static SHORTCARD Short;
static LONGINT Long;
static REAL Real;
static BOOLEAN Boolean;
static CHAR Character;
static struct S_1 {
    CHAR A[9 + 1];
} Array;
static Sets_tSet Set;
static Idents_tIdent Ident;
static Strings_tString String;
static void errors ARGS(());


static void errors
# ifdef __STDC__
()
# else
()
# endif
{
  Errors_MessageI((STRING)"Integer	", 8L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_Integer, ADR(Integer));
  Errors_MessageI((STRING)"Short	", 6L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_Short, ADR(Short));
  Errors_MessageI((STRING)"Long	", 5L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_Long, ADR(Long));
  Errors_MessageI((STRING)"Real	", 5L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_Real, ADR(Real));
  Errors_MessageI((STRING)"Boolean	", 8L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_Boolean, ADR(Boolean));
  Errors_MessageI((STRING)"Character	", 10L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_Character, ADR(Character));
  Errors_MessageI((STRING)"Array	", 6L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_Array, ADR(Array));
  Errors_MessageI((STRING)"String	", 7L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_String, ADR(String));
  Errors_MessageI((STRING)"Set	", 4L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_Set, ADR(Set));
  Errors_MessageI((STRING)"Ident	", 6L, (LONGCARD)Errors_Error, Positions_NoPosition, (LONGCARD)Errors_Ident, ADR(Ident));
}

void BEGIN_MODULE()
{
  BEGIN_IO();
  BEGIN_Sets();
  BEGIN_Strings();
  BEGIN_Idents();
  BEGIN_Positions();
  BEGIN_Errors();
  BEGIN_Errors();

  Integer = 1;
  Short = 2;
  Long = 3;
  Real = 4.0;
  Boolean = FALSE;
  Character = 'a';
  (void)strncpy((char *)Array.A, "abc", sizeof(Array.A));
  Sets_MakeSet(&Set, 10L);
  Sets_Include(&Set, 5L);
  Sets_Include(&Set, 6L);
  Strings_ArrayToString((STRING)"def", 3L, &String);
  Ident = Idents_MakeIdent(&String);
  errors();
  IO_WriteNl((rSystem_tFile)IO_StdError);
  Errors_StoreMessages(TRUE);
  errors();
  Errors_WriteMessages((rSystem_tFile)IO_StdError);
  IO_WriteNl((rSystem_tFile)IO_StdError);
  Errors_WriteMessages((rSystem_tFile)IO_StdOutput);
  IO_WriteNl((rSystem_tFile)IO_StdError);
  Errors_StoreMessages(TRUE);
  Errors_WriteMessages((rSystem_tFile)IO_StdOutput);
}
