#include "SYSTEM_.h"

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_rMemory
#include "rMemory.h"
#endif

#ifndef DEFINITION_Pack
#include "Pack.h"
#endif


#define Sign	'!'
#define FirstChar	'+'
#define LastChar	'~'
#define Factor	((ORD(LastChar) - ORD(FirstChar) + 1) / 2)
typedef struct S_1 *PackHandle;
typedef void (*BeginLineProc) ARGS((Pack_PackHandle));
typedef struct S_1 {
    CARDINAL pos;
    CARDINAL count;
    IO_tFile file;
    BeginLineProc beginLine;
} PackRecord;
static void BeginCardLine ARGS((Pack_PackHandle packer));
static void BeginIntLine ARGS((Pack_PackHandle packer));
static void EndLine ARGS((Pack_PackHandle packer));
struct S_5 {
    CHAR A[10 + 1];
};

static void BeginCardLine
# ifdef __STDC__
(Pack_PackHandle packer)
# else
(packer)
Pack_PackHandle packer;
# endif
{
  {
    register PackRecord *W_1 = (PackHandle)packer;

    IO_WriteS(W_1->file, (STRING)"Pack.UnpackCard(hc, \"", 21L);
    W_1->pos = 0;
    W_1->count = 0;
  }
}

static void BeginIntLine
# ifdef __STDC__
(Pack_PackHandle packer)
# else
(packer)
Pack_PackHandle packer;
# endif
{
  {
    register PackRecord *W_2 = (PackHandle)packer;

    IO_WriteS(W_2->file, (STRING)"Pack.UnpackInt(hi, \"", 20L);
    W_2->pos = 0;
    W_2->count = 0;
  }
}

static void EndLine
# ifdef __STDC__
(Pack_PackHandle packer)
# else
(packer)
Pack_PackHandle packer;
# endif
{
  {
    register PackRecord *W_3 = (PackHandle)packer;

    IO_WriteS(W_3->file, (STRING)"\", ", 3L);
    IO_WriteI(W_3->file, (LONGINT)W_3->count, 1L);
    IO_WriteS(W_3->file, (STRING)");", 2L);
    IO_WriteNl(W_3->file);
    W_3->pos = 0;
    W_3->count = 0;
  }
}

void Pack_BeginPackCard
# ifdef __STDC__
(Pack_PackHandle *packer, IO_tFile file)
# else
(packer, file)
Pack_PackHandle *packer;
IO_tFile file;
# endif
{
  *packer = (Pack_PackHandle)rMemory_Alloc((LONGINT)sizeof(PackRecord));
  ((PackHandle)(*packer))->pos = 0;
  ((PackHandle)(*packer))->count = 0;
  ((PackHandle)(*packer))->file = file;
  ((PackHandle)(*packer))->beginLine = BeginCardLine;
  (*((PackHandle)(*packer))->beginLine)(*packer);
}

void Pack_BeginPackInt
# ifdef __STDC__
(Pack_PackHandle *packer, IO_tFile file)
# else
(packer, file)
Pack_PackHandle *packer;
IO_tFile file;
# endif
{
  *packer = (Pack_PackHandle)rMemory_Alloc((LONGINT)sizeof(PackRecord));
  ((PackHandle)(*packer))->pos = 0;
  ((PackHandle)(*packer))->count = 0;
  ((PackHandle)(*packer))->file = file;
  ((PackHandle)(*packer))->beginLine = BeginIntLine;
  (*((PackHandle)(*packer))->beginLine)(*packer);
}

void Pack_PackCard
# ifdef __STDC__
(Pack_PackHandle packer, LONGCARD value)
# else
(packer, value)
Pack_PackHandle packer;
LONGCARD value;
# endif
{
  LONGCARD i;
  struct S_5 buf;

  {
    register PackRecord *W_4 = (PackHandle)packer;

    i = 0;
    do {
      buf.A[i] = CHR(value % Factor + ORD(FirstChar) + Factor);
      i = i + 1;
      value = value / Factor;
    } while (!(value == 0));
    buf.A[0] = CHR(ORD(buf.A[0]) - Factor);
    W_4->pos = W_4->pos + i;
    do {
      i = i - 1;
      IO_WriteC(W_4->file, buf.A[i]);
    } while (!(i == 0));
    W_4->count = W_4->count + 1;
    if (W_4->pos > 54) {
      EndLine(packer);
      (*W_4->beginLine)(packer);
    }
  }
}

void Pack_PackInt
# ifdef __STDC__
(Pack_PackHandle packer, LONGINT value)
# else
(packer, value)
Pack_PackHandle packer;
LONGINT value;
# endif
{
  {
    register PackRecord *W_5 = (PackHandle)packer;

    if (value < 0) {
      IO_WriteC(W_5->file, Sign);
      W_5->pos = W_5->pos + 1;
      Pack_PackCard(packer, (LONGCARD)(-value));
    } else {
      Pack_PackCard(packer, (LONGCARD)value);
    }
  }
}

void Pack_EndPack
# ifdef __STDC__
(Pack_PackHandle *packer)
# else
(packer)
Pack_PackHandle *packer;
# endif
{
  EndLine(*packer);
  rMemory_Free((LONGINT)sizeof(PackRecord), (ADDRESS)(*packer));
  *packer = (Pack_PackHandle)NIL;
}

void Pack_Unpack
# ifdef __STDC__
(Pack_UnpackCardHandler handler, CHAR string[], LONGCARD O_1, CARDINAL count)
# else
(handler, string, O_1, count)
Pack_UnpackCardHandler handler;
CHAR string[];
LONGCARD O_1;
CARDINAL count;
# endif
{
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_1 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(string, O_1, CHAR)
  Pack_UnpackCard(handler, string, O_1, count);
  FREE_OPEN_ARRAYS
}

void Pack_UnpackCard
# ifdef __STDC__
(Pack_UnpackCardHandler handler, CHAR string[], LONGCARD O_2, CARDINAL count)
# else
(handler, string, O_2, count)
Pack_UnpackCardHandler handler;
CHAR string[];
LONGCARD O_2;
CARDINAL count;
# endif
{
  CARDINAL i, j, tmp;
  LONGCARD value;
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_2 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(string, O_2, CHAR)
  i = 0;
  {
    LONGCARD B_1 = 1, B_2 = count;

    if (B_1 <= B_2)
      for (j = B_1;; j += 1) {
        value = 0;
        do {
          tmp = ORD(string[i]) - ORD(FirstChar);
          value = value * Factor + tmp % Factor;
          INC(i);
        } while (!(tmp < Factor));
        (*handler)(value);
        if (j >= B_2) break;
      }
  }
  FREE_OPEN_ARRAYS
}

void Pack_UnpackInt
# ifdef __STDC__
(Pack_UnpackIntHandler handler, CHAR string[], LONGCARD O_3, CARDINAL count)
# else
(handler, string, O_3, count)
Pack_UnpackIntHandler handler;
CHAR string[];
LONGCARD O_3;
CARDINAL count;
# endif
{
  BOOLEAN issigned;
  CARDINAL i, j, tmp;
  LONGCARD value;
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_3 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(string, O_3, CHAR)
  i = 0;
  {
    LONGCARD B_3 = 1, B_4 = count;

    if (B_3 <= B_4)
      for (j = B_3;; j += 1) {
        value = 0;
        issigned = string[i] == Sign;
        if (issigned) {
          INC(i);
        }
        do {
          tmp = ORD(string[i]) - ORD(FirstChar);
          value = value * Factor + tmp % Factor;
          INC(i);
        } while (!(tmp < Factor));
        if (issigned) {
          (*handler)(-(LONGINT)value);
        } else {
          (*handler)((LONGINT)value);
        }
        if (j >= B_4) break;
      }
  }
  FREE_OPEN_ARRAYS
}

void BEGIN_Pack()
{
  static BOOLEAN has_been_called = FALSE;
  if (has_been_called) return;
  has_been_called = TRUE;
    BEGIN_IO();
    BEGIN_IO();
    BEGIN_rMemory();

}
