#define DEFINITION_RelatsC

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_SetsC
#include "SetsC.h"
#endif

#ifndef DEFINITION_Relations
#include "Relations.h"
#endif

typedef Relations_ArrayOfSet RelatsC_ArrayOfSet;
typedef Relations_ProcOfIntInt RelatsC_ProcOfIntInt;
typedef Relations_ProcOfIntIntToBool RelatsC_ProcOfIntIntToBool;
typedef Relations_tRelation RelatsC_tRelation;
extern void RelatsC_MakeRelation ARGS((RelatsC_tRelation *Rel, INTEGER Size1, INTEGER Size2));
extern void RelatsC_ReleaseRelation ARGS((RelatsC_tRelation *Rel));
extern void RelatsC_Include ARGS((RelatsC_tRelation *Rel, INTEGER e1, INTEGER e2));
extern void RelatsC_Exclude ARGS((RelatsC_tRelation *Rel, INTEGER e1, INTEGER e2));
extern BOOLEAN RelatsC_IsElement ARGS((INTEGER e1, INTEGER e2, RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_IsRelated ARGS((INTEGER e1, INTEGER e2, RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_IsReflexive1 ARGS((INTEGER e1, RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_IsSymmetric1 ARGS((INTEGER e1, INTEGER e2, RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_IsTransitive1 ARGS((INTEGER e1, INTEGER e2, INTEGER e3, RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_IsReflexive ARGS((RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_IsSymmetric ARGS((RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_IsTransitive ARGS((RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_IsEquivalence ARGS((RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_HasReflexive ARGS((RelatsC_tRelation Rel));
extern BOOLEAN RelatsC_IsCyclic ARGS((RelatsC_tRelation Rel));
extern void RelatsC_GetCyclics ARGS((RelatsC_tRelation Rel, SetsC_tSet *Set));
extern void RelatsC_Closure ARGS((RelatsC_tRelation *Rel));
extern void RelatsC_AssignEmpty ARGS((RelatsC_tRelation *Rel));
extern void RelatsC_AssignElmt ARGS((RelatsC_tRelation *Rel, INTEGER e1, INTEGER e2));
extern void RelatsC_Assign ARGS((RelatsC_tRelation *Rel1, RelatsC_tRelation Rel2));
extern void RelatsC_Union ARGS((RelatsC_tRelation *Rel1, RelatsC_tRelation Rel2));
extern void RelatsC_Difference ARGS((RelatsC_tRelation *Rel1, RelatsC_tRelation Rel2));
extern void RelatsC_Intersection ARGS((RelatsC_tRelation *Rel1, RelatsC_tRelation Rel2));
extern void RelatsC_SymDiff ARGS((RelatsC_tRelation *Rel1, RelatsC_tRelation Rel2));
extern void RelatsC_Complement ARGS((RelatsC_tRelation *Rel));
extern BOOLEAN RelatsC_IsSubset ARGS((RelatsC_tRelation Rel1, RelatsC_tRelation Rel2));
extern BOOLEAN RelatsC_IsStrictSubset ARGS((RelatsC_tRelation Rel1, RelatsC_tRelation Rel2));
extern BOOLEAN RelatsC_IsEqual ARGS((RelatsC_tRelation *Rel1, RelatsC_tRelation *Rel2));
extern BOOLEAN RelatsC_IsNotEqual ARGS((RelatsC_tRelation Rel1, RelatsC_tRelation Rel2));
extern BOOLEAN RelatsC_IsEmpty ARGS((RelatsC_tRelation Rel));
extern INTEGER RelatsC_Card ARGS((RelatsC_tRelation *Rel));
extern void RelatsC_Select ARGS((RelatsC_tRelation *Rel, INTEGER *e1, INTEGER *e2));
extern void RelatsC_Extract ARGS((RelatsC_tRelation *Rel, INTEGER *e1, INTEGER *e2));
extern BOOLEAN RelatsC_Forall ARGS((RelatsC_tRelation Rel, RelatsC_ProcOfIntIntToBool Proc));
extern BOOLEAN RelatsC_Exists ARGS((RelatsC_tRelation Rel, RelatsC_ProcOfIntIntToBool Proc));
extern BOOLEAN RelatsC_Exists1 ARGS((RelatsC_tRelation Rel, RelatsC_ProcOfIntIntToBool Proc));
extern void RelatsC_ForallDo ARGS((RelatsC_tRelation Rel, RelatsC_ProcOfIntInt Proc));
extern void RelatsC_ReadRelation ARGS((IO_tFile f, RelatsC_tRelation *Rel));
extern void RelatsC_WriteRelation ARGS((IO_tFile f, RelatsC_tRelation Rel));
extern void RelatsC_Project1 ARGS((RelatsC_tRelation Rel, INTEGER e1, SetsC_tSet *Set));
extern void RelatsC_Project2 ARGS((RelatsC_tRelation Rel, INTEGER e1, SetsC_tSet *Set));
extern void BEGIN_RelatsC();
