#include "SYSTEM_.h"

#ifndef DEFINITION_Checks
#include "Checks.h"
#endif

#ifndef DEFINITION_General
#include "General.h"
#endif

#ifndef DEFINITION_rMemory
#include "rMemory.h"
#endif

#ifndef DEFINITION_DynArray
#include "DynArray.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_Sets
#include "Sets.h"
#endif

#ifndef DEFINITION_rSystem
#include "rSystem.h"
#endif

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_Layout
#include "Layout.h"
#endif

#ifndef DEFINITION_Dfa
#include "Dfa.h"
#endif

#ifndef DEFINITION_GenTabs
#include "GenTabs.h"
#endif

#ifndef DEFINITION_Classes
#include "Classes.h"
#endif

#ifndef DEFINITION_ScanGen
#include "ScanGen.h"
#endif

#ifndef DEFINITION_Pack
#include "Pack.h"
#endif

#ifndef DEFINITION_ScanTabs
#include "ScanTabs.h"
#endif

ScanTabs_RuleBase *ScanTabs_RuleBasePtr;
LONGINT ScanTabs_RuleBaseSize;
ScanTabs_Rule *ScanTabs_RulePtr;
LONGINT ScanTabs_RuleSize;
ScanTabs_Base *ScanTabs_BasePtr;
LONGINT ScanTabs_BaseSize;
ScanTabs_Default *ScanTabs_DefaultPtr;
LONGINT ScanTabs_DefaultSize;
ScanTabs_Control *ScanTabs_ControlPtr;
LONGINT ScanTabs_ControlSize;
ScanTabs_EobTrans *ScanTabs_EobTransPtr;
LONGINT ScanTabs_EobTransSize;
ScanTabs_Context *ScanTabs_ContextPtr;
LONGINT ScanTabs_ContextSize;
ScanTabs_Action *ScanTabs_ActionPtr;
LONGINT ScanTabs_ActionSize;
ScanTabs_ActionType ScanTabs_ActionNr;
ScanTabs_TableRange ScanTabs_TableSize;
ScanTabs_TableRange ScanTabs_TableEntries;

static rSystem_tFile Tables;
static ScanTabs_TableElmt ElmtSize;
static void PutComb ARGS((rSystem_tFile File));
static void PutBase ARGS((rSystem_tFile File));
static void PutDefault ARGS((rSystem_tFile File));
static void PutEobTrans ARGS((rSystem_tFile File));
static void PutAction ARGS((rSystem_tFile File));
struct S_7 {
    CHAR A[127 + 1];
};
typedef struct S_1 *DiffsInfoPtr;
typedef struct S_1 {
    struct S_6 {
        CHAR A[256 - 1 + 1];
    } *DiffsPtr;
    DiffsInfoPtr Next;
    ScanTabs_TableRange Base;
    SHORTCARD Count;
} DiffsInfo;
struct S_2 {
    struct S_3 {
        CHAR First, Last;
    } A[128 + 1];
};
struct S_4 {
    CHAR A[256 + 1];
};
struct S_5 {
    DiffsInfoPtr A[100000 + 1];
};
static void WriteState ARGS((Dfa_DStateRange State));

void ScanTabs_PutComb
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  ScanTabs_TableRange i;
  Pack_PackHandle p;

  switch (ScanGen_Language) {
  case ScanGen_Modula:;
    Pack_BeginPackCard(&p, File);
    {
      LONGCARD B_1 = 0, B_2 = ScanTabs_TableSize;

      if (B_1 <= B_2)
        for (i = B_1;; i += 1) {
          Pack_PackCard(p, (LONGCARD)ScanTabs_ControlPtr->A[i].Check);
          Pack_PackCard(p, (LONGCARD)ScanTabs_ControlPtr->A[i].Next);
          if (i >= B_2) break;
        }
    }
    Pack_EndPack(&p);
    break;
  case ScanGen_C:;
    {
      LONGCARD B_3 = 1, B_4 = ScanTabs_TableSize;

      if (B_3 <= B_4)
        for (i = B_3;; i += 1) {
          IO_WriteC(File, '{');
          IO_WriteI(File, (LONGINT)ScanTabs_ControlPtr->A[i].Check, 0L);
          IO_WriteS(File, (STRING)", ", 2L);
          IO_WriteI(File, (LONGINT)ScanTabs_ControlPtr->A[i].Next, 0L);
          IO_WriteS(File, (STRING)"},", 2L);
          IO_WriteNl(File);
          if (i >= B_4) break;
        }
    }
    break;
  }
}

void ScanTabs_PutBase
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  INTEGER i;
  Pack_PackHandle p;

  switch (ScanGen_Language) {
  case ScanGen_Modula:;
    Pack_BeginPackCard(&p, File);
    {
      LONGINT B_5 = 0, B_6 = Dfa_DStateCount;

      if (B_5 <= B_6)
        for (i = B_5;; i += 1) {
          Pack_PackCard(p, (LONGCARD)ScanTabs_BasePtr->A[i]);
          if (i >= B_6) break;
        }
    }
    Pack_EndPack(&p);
    break;
  case ScanGen_C:;
    {
      LONGINT B_7 = 1, B_8 = Dfa_DStateCount;

      if (B_7 <= B_8)
        for (i = B_7;; i += 1) {
          IO_WriteS(File, (STRING)"& yyComb [", 10L);
          IO_WriteI(File, (LONGINT)ScanTabs_BasePtr->A[i], 0L);
          IO_WriteS(File, (STRING)"],", 2L);
          IO_WriteNl(File);
          if (i >= B_8) break;
        }
    }
    break;
  }
}

void ScanTabs_PutDefault
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  INTEGER i;
  Pack_PackHandle p;

  switch (ScanGen_Language) {
  case ScanGen_Modula:;
    Pack_BeginPackCard(&p, File);
    {
      LONGINT B_9 = 0, B_10 = Dfa_DStateCount;

      if (B_9 <= B_10)
        for (i = B_9;; i += 1) {
          Pack_PackCard(p, (LONGCARD)ScanTabs_DefaultPtr->A[i]);
          if (i >= B_10) break;
        }
    }
    Pack_EndPack(&p);
    break;
  case ScanGen_C:;
    {
      LONGINT B_11 = 1, B_12 = Dfa_DStateCount;

      if (B_11 <= B_12)
        for (i = B_11;; i += 1) {
          IO_WriteI(File, (LONGINT)ScanTabs_DefaultPtr->A[i], 0L);
          IO_WriteC(File, ',');
          IO_WriteNl(File);
          if (i >= B_12) break;
        }
    }
    break;
  }
}

void ScanTabs_PutEobTrans
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  INTEGER i;
  Pack_PackHandle p;

  switch (ScanGen_Language) {
  case ScanGen_Modula:;
    Pack_BeginPackCard(&p, File);
    {
      LONGINT B_13 = 0, B_14 = Dfa_DStateCount;

      if (B_13 <= B_14)
        for (i = B_13;; i += 1) {
          Pack_PackCard(p, (LONGCARD)ScanTabs_EobTransPtr->A[i]);
          if (i >= B_14) break;
        }
    }
    Pack_EndPack(&p);
    break;
  case ScanGen_C:;
    {
      LONGINT B_15 = 1, B_16 = Dfa_DStateCount;

      if (B_15 <= B_16)
        for (i = B_15;; i += 1) {
          IO_WriteI(File, (LONGINT)ScanTabs_EobTransPtr->A[i], 0L);
          IO_WriteC(File, ',');
          IO_WriteNl(File);
          if (i >= B_16) break;
        }
    }
    break;
  }
}

void ScanTabs_PutAction
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  INTEGER i;
  Pack_PackHandle p;

  switch (ScanGen_Language) {
  case ScanGen_Modula:;
    Pack_BeginPackCard(&p, File);
    {
      LONGINT B_17 = 0, B_18 = Dfa_DStateCount;

      if (B_17 <= B_18)
        for (i = B_17;; i += 1) {
          Pack_PackCard(p, (LONGCARD)ScanTabs_ActionPtr->A[i]);
          if (i >= B_18) break;
        }
    }
    Pack_EndPack(&p);
    break;
  case ScanGen_C:;
    {
      LONGINT B_19 = 1, B_20 = Dfa_DStateCount;

      if (B_19 <= B_20)
        for (i = B_19;; i += 1) {
          IO_WriteI(File, (LONGINT)ScanTabs_ActionPtr->A[i], 0L);
          IO_WriteC(File, ',');
          IO_WriteNl(File);
          if (i >= B_20) break;
        }
    }
    break;
  }
}

static void PutComb
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  ScanTabs_TableRange i;

  IO_WriteI(File, (LONGINT)(2 * (ScanTabs_TableSize + 1)), 0L);
  IO_WriteS(File, (STRING)" = Tablelength of Comb", 22L);
  IO_WriteNl(File);
  {
    LONGCARD B_21 = 0, B_22 = ScanTabs_TableSize;

    if (B_21 <= B_22)
      for (i = B_21;; i += 1) {
        IO_WriteI(File, (LONGINT)ScanTabs_ControlPtr->A[i].Check, 0L);
        IO_WriteC(File, ' ');
        IO_WriteI(File, (LONGINT)ScanTabs_ControlPtr->A[i].Next, 0L);
        IO_WriteNl(File);
        if (i >= B_22) break;
      }
  }
}

static void PutBase
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  INTEGER i;

  IO_WriteI(File, (LONGINT)(Dfa_DStateCount + 1), 0L);
  IO_WriteS(File, (STRING)" = Tablelength of ScanBase", 26L);
  IO_WriteNl(File);
  {
    LONGINT B_23 = 0, B_24 = Dfa_DStateCount;

    if (B_23 <= B_24)
      for (i = B_23;; i += 1) {
        IO_WriteI(File, (LONGINT)ScanTabs_BasePtr->A[i], 0L);
        IO_WriteNl(File);
        if (i >= B_24) break;
      }
  }
}

static void PutDefault
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  INTEGER i;

  IO_WriteI(File, (LONGINT)(Dfa_DStateCount + 1), 0L);
  IO_WriteS(File, (STRING)" = Tablelength of Default", 25L);
  IO_WriteNl(File);
  {
    LONGINT B_25 = 0, B_26 = Dfa_DStateCount;

    if (B_25 <= B_26)
      for (i = B_25;; i += 1) {
        IO_WriteI(File, (LONGINT)ScanTabs_DefaultPtr->A[i], 0L);
        IO_WriteNl(File);
        if (i >= B_26) break;
      }
  }
}

static void PutEobTrans
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  INTEGER i;

  IO_WriteI(File, (LONGINT)(Dfa_DStateCount + 1), 0L);
  IO_WriteS(File, (STRING)" = Tablelength of EobTrans", 26L);
  IO_WriteNl(File);
  {
    LONGINT B_27 = 0, B_28 = Dfa_DStateCount;

    if (B_27 <= B_28)
      for (i = B_27;; i += 1) {
        IO_WriteI(File, (LONGINT)ScanTabs_EobTransPtr->A[i], 0L);
        IO_WriteNl(File);
        if (i >= B_28) break;
      }
  }
}

static void PutAction
# ifdef __STDC__
(rSystem_tFile File)
# else
(File)
rSystem_tFile File;
# endif
{
  INTEGER i;

  IO_WriteI(File, (LONGINT)(Dfa_DStateCount + 1), 0L);
  IO_WriteS(File, (STRING)" = Tablelength of Action", 24L);
  IO_WriteNl(File);
  {
    LONGINT B_29 = 0, B_30 = Dfa_DStateCount;

    if (B_29 <= B_30)
      for (i = B_29;; i += 1) {
        IO_WriteI(File, (LONGINT)ScanTabs_ActionPtr->A[i], 0L);
        IO_WriteNl(File);
        if (i >= B_30) break;
      }
  }
}

void ScanTabs_PutEiffelTables
# ifdef __STDC__
(BOOLEAN ReduceCaseSize)
# else
(ReduceCaseSize)
BOOLEAN ReduceCaseSize;
# endif
{
  Strings_tString FileNameS, PathS;
  struct S_7 PathA;

  if (ScanGen_ScannerName == Idents_NoIdent) {
    Strings_ArrayToString((STRING)"scanner", 7L, &PathS);
  } else {
    Idents_GetString(ScanGen_ScannerName, &PathS);
  }
  Strings_ArrayToString((STRING)".txt", 4L, &FileNameS);
  Strings_Concatenate(&PathS, &FileNameS);
  Strings_Append(&PathS, '\0');
  Strings_StringToArray(&PathS, PathA.A, 128L);
  Tables = IO_WriteOpen(PathA.A, 128L);
  Checks_ErrorCheck((STRING)"PutEiffelTables.OpenOutput", 26L, Tables);
  PutBase(Tables);
  PutDefault(Tables);
  PutEobTrans(Tables);
  if (ReduceCaseSize) {
    PutAction(Tables);
  }
  PutComb(Tables);
  IO_WriteClose(Tables);
}

void ScanTabs_MakeTables
# ifdef __STDC__
(BOOLEAN ReduceCaseSize)
# else
(ReduceCaseSize)
BOOLEAN ReduceCaseSize;
# endif
{
  Dfa_DStateRange State;
  CARDINAL cState;
  SHORTCARD Pattern;

  ScanTabs_DefaultSize = Dfa_DStateCount + 1;
  DynArray_MakeArray((ADDRESS *)&ScanTabs_DefaultPtr, &ScanTabs_DefaultSize, (LONGINT)sizeof(ScanTabs_StateRange));
  DynArray_MakeArray((ADDRESS *)&ScanTabs_EobTransPtr, &ScanTabs_DefaultSize, (LONGINT)sizeof(ScanTabs_StateRange));
  ScanTabs_DefaultPtr->A[Dfa_DNoState] = Dfa_DNoState;
  ScanTabs_EobTransPtr->A[Dfa_DNoState] = Dfa_DNoState;
  {
    SHORTINT B_31 = 1, B_32 = Dfa_DStateCount;

    if (B_31 <= B_32)
      for (State = B_31;; State += 1) {
        ScanTabs_DefaultPtr->A[State] = Dfa_GetDefault(State);
        ScanTabs_EobTransPtr->A[State] = Dfa_GetEobTrans(State);
        if (State >= B_32) break;
      }
  }
  if (ReduceCaseSize) {
    DynArray_MakeArray((ADDRESS *)&ScanTabs_ActionPtr, &ScanTabs_DefaultSize, (LONGINT)sizeof(ScanTabs_TableElmt));
    ScanTabs_ActionPtr->A[Dfa_DNoState] = Dfa_DNoState;
    {
      SHORTINT B_33 = 1, B_34 = Dfa_DStateCount;

      if (B_33 <= B_34)
        for (State = B_33;; State += 1) {
          ScanTabs_ActionPtr->A[State] = GenTabs_PatternCount + 1;
          if (State >= B_34) break;
        }
    }
    {
      SHORTCARD B_35 = 1, B_36 = GenTabs_PatternCount;

      if (B_35 <= B_36)
        for (Pattern = B_35;; Pattern += 1) {
          {
            LONGCARD B_37 = Sets_Minimum(&GenTabs_PatternTablePtr->A[Pattern].Finals), B_38 = Sets_Maximum(&GenTabs_PatternTablePtr->A[Pattern].Finals);

            if (B_37 <= B_38)
              for (cState = B_37;; cState += 1) {
                if (Sets_IsElement(cState, &GenTabs_PatternTablePtr->A[Pattern].Finals)) {
                  ScanTabs_ActionPtr->A[cState] = Pattern;
                }
                if (cState >= B_38) break;
              }
          }
          if (Pattern >= B_36) break;
        }
    }
  }
}

void ScanTabs_CompressTables
# ifdef __STDC__
(SHORTINT Optimize)
# else
(Optimize)
SHORTINT Optimize;
# endif
{
  ScanTabs_TableRange base;
  LONGINT lbase;
  Dfa_DStateRange State;
  BOOLEAN Success;
  CHAR Ch, LastElmt;
  LONGINT OldControlSize;
  INTEGER i;
  CARDINAL j;
  SHORTINT Hash;
  struct S_2 Group;
  CARDINAL GroupCount;
  struct S_4 Diffs;
  CHAR StartCh, StopCh;
  struct S_5 *HashTablePtr;
  LONGINT HashTableSize;
  DiffsInfoPtr Current;
  Sets_tSet Domain;

  ScanTabs_BaseSize = Dfa_DStateCount + 1;
  DynArray_MakeArray((ADDRESS *)&ScanTabs_BasePtr, &ScanTabs_BaseSize, (LONGINT)sizeof(ScanTabs_TableRange));
  {
    SHORTINT B_39 = 0, B_40 = Dfa_DStateCount;

    if (B_39 <= B_40)
      for (State = B_39;; State += 1) {
        ScanTabs_BasePtr->A[State] = 0;
        if (State >= B_40) break;
      }
  }
  if (Optimize == 0) {
    ScanTabs_ControlSize = GenTabs_LeafCount * 60;
  } else if (Optimize >= 10000) {
    ScanTabs_ControlSize = Dfa_DStateCount * 5;
  } else {
    ScanTabs_ControlSize = GenTabs_LeafCount * 12;
  }
  ScanTabs_ControlSize = General_Max(ScanTabs_ControlSize, (LONGINT)ORD(Dfa_OldLastCh) + 1);
  DynArray_MakeArray((ADDRESS *)&ScanTabs_ControlPtr, &ScanTabs_ControlSize, (LONGINT)sizeof(ScanTabs_ControlType));
  {
    LONGINT B_41 = 0, B_42 = ScanTabs_ControlSize - 1;

    if (B_41 <= B_42)
      for (i = B_41;; i += 1) {
        ScanTabs_ControlPtr->A[i].Check = Dfa_DNoState;
        ScanTabs_ControlPtr->A[i].Next = Dfa_DNoState;
        if (i >= B_42) break;
      }
  }
  HashTableSize = Dfa_DStateCount;
  DynArray_MakeArray((ADDRESS *)&HashTablePtr, &HashTableSize, (LONGINT)sizeof(DiffsInfoPtr));
  {
    LONGINT B_43 = 0, B_44 = HashTableSize - 1;

    if (B_43 <= B_44)
      for (i = B_43;; i += 1) {
        HashTablePtr->A[i] = NIL;
        if (i >= B_44) break;
      }
  }
  Sets_MakeSet(&Domain, ORD(Dfa_OldLastCh));
  ScanTabs_TableSize = 0;
  ScanTabs_TableEntries = 0;
  Group.A[0].Last = '\0';
  {
    SHORTINT B_45 = 1, B_46 = Dfa_DStateCount;

    if (B_45 <= B_46)
      for (State = B_45;; State += 1) {
        Sets_AssignEmpty(&Domain);
        Ch = Dfa_GetFirst(State);
        LastElmt = Dfa_GetLast(State);
        if (Ch <= LastElmt) {
          for (;;) {
            if (Dfa_GetTableNoDef(State, Ch) != Dfa_DNoState) {
              if (Ch <= Classes_ClassCount) {
                Sets_Union(&Domain, Classes_ClassMemPtr->A[Ch]);
              } else {
                Sets_Include(&Domain, ORD(Classes_ToChar.A[Ch]));
              }
            }
            if (Ch == LastElmt) {
              goto EXIT_1;
            }
            INC(Ch);
          } EXIT_1:;
        }
        GroupCount = 0;
        if (!Sets_IsEmpty(Domain)) {
          Ch = CHR(Sets_Minimum(&Domain));
          LastElmt = CHR(Sets_Maximum(&Domain));
          if (Ch <= LastElmt) {
            for (;;) {
              for (;;) {
                if (Ch == LastElmt) {
                  goto EXIT_3;
                }
                if (!Sets_IsElement(ORD(Ch), &Domain)) {
                  INC(Ch);
                } else {
                  goto EXIT_3;
                }
              } EXIT_3:;
              if (Sets_IsElement(ORD(Ch), &Domain)) {
                INC(GroupCount);
                Group.A[GroupCount].First = Ch;
                for (;;) {
                  if (Ch == LastElmt) {
                    goto EXIT_4;
                  }
                  if (Sets_IsElement(ORD(Ch), &Domain)) {
                    INC(Ch);
                  } else {
                    goto EXIT_4;
                  }
                } EXIT_4:;
                if (Sets_IsElement(ORD(Ch), &Domain)) {
                  Group.A[GroupCount].Last = Ch;
                } else {
                  Group.A[GroupCount].Last = CHR(ORD(Ch) - 1);
                }
              }
              if (Ch == LastElmt) {
                goto EXIT_2;
              }
            } EXIT_2:;
          }
        }
        base = 0;
        if (GroupCount > 0) {
          Hash = 0;
          {
            LONGCARD B_47 = 1, B_48 = GroupCount;

            if (B_47 <= B_48)
              for (j = B_47;; j += 1) {
                Diffs.A[j + j - 1] = CHR(ORD(Group.A[j].First) - ORD(Group.A[j - 1].Last));
                Diffs.A[j + j] = CHR(ORD(Group.A[j].Last) - ORD(Group.A[j].First));
                INC1(Hash, (ORD(Diffs.A[j + j - 1]) + ORD(Diffs.A[j + j])) * j);
                if (j >= B_48) break;
              }
          }
          Hash = Hash % Dfa_DStateCount;
          Success = FALSE;
          Current = HashTablePtr->A[Hash];
          for (;;) {
            if (Current == NIL) {
              goto EXIT_5;
            }
            if (Current->Count == GroupCount * 2) {
              Success = TRUE;
              j = 0;
              for (;;) {
                INC(j);
                if (Current->DiffsPtr->A[j - 1] != Diffs.A[j]) {
                  Success = FALSE;
                  goto EXIT_6;
                }
                if (j == Current->Count) {
                  goto EXIT_6;
                }
              } EXIT_6:;
              if (Success) {
                goto EXIT_5;
              }
            }
            Current = Current->Next;
          } EXIT_5:;
          if (Success) {
            base = Current->Base + ORD(Current->DiffsPtr->A[2 - 1]) + 1;
          } else {
            Current = (DiffsInfoPtr)rMemory_Alloc((LONGINT)sizeof(DiffsInfo));
            {
              register DiffsInfo *W_1 = Current;

              W_1->Base = 0;
              W_1->Next = HashTablePtr->A[Hash];
              W_1->Count = GroupCount * 2;
              W_1->DiffsPtr = (struct S_6 *)rMemory_Alloc((LONGINT)W_1->Count);
              {
                LONGCARD B_49 = 1, B_50 = W_1->Count;

                if (B_49 <= B_50)
                  for (j = B_49;; j += 1) {
                    W_1->DiffsPtr->A[j - 1] = Diffs.A[j];
                    if (j >= B_50) break;
                  }
              }
            }
            HashTablePtr->A[Hash] = Current;
          }
          for (;;) {
            lbase = base;
            if (lbase >= ScanTabs_ControlSize - (LONGINT)ORD(Dfa_OldLastCh)) {
              OldControlSize = ScanTabs_ControlSize;
              DynArray_ExtendArray((ADDRESS *)&ScanTabs_ControlPtr, &ScanTabs_ControlSize, (LONGINT)sizeof(ScanTabs_ControlType));
              {
                LONGINT B_51 = OldControlSize, B_52 = ScanTabs_ControlSize - 1;

                if (B_51 <= B_52)
                  for (i = B_51;; i += 1) {
                    ScanTabs_ControlPtr->A[i].Check = Dfa_DNoState;
                    ScanTabs_ControlPtr->A[i].Next = Dfa_DNoState;
                    if (i >= B_52) break;
                  }
              }
            }
            Success = TRUE;
            j = 0;
            for (;;) {
              INC(j);
              StartCh = Group.A[j].First;
              StopCh = Group.A[j].Last;
              Ch = StartCh;
              for (;;) {
                if (ScanTabs_ControlPtr->A[base + ORD(Ch)].Check != Dfa_DNoState) {
                  Success = FALSE;
                  goto EXIT_9;
                }
                if (Ch == StopCh) {
                  goto EXIT_9;
                }
                INC(Ch);
              } EXIT_9:;
              if (!Success || j == GroupCount) {
                goto EXIT_8;
              }
            } EXIT_8:;
            if (Success) {
              goto EXIT_7;
            }
            INC(base);
          } EXIT_7:;
          j = 0;
          for (;;) {
            INC(j);
            Ch = Group.A[j].First;
            StopCh = Group.A[j].Last;
            for (;;) {
              {
                register ScanTabs_ControlType *W_2 = &ScanTabs_ControlPtr->A[base + ORD(Ch)];

                W_2->Check = State;
                W_2->Next = Dfa_GetTableNoDef(State, Classes_ToClass.A[Ch]);
              }
              INC(ScanTabs_TableEntries);
              if (Ch == StopCh) {
                goto EXIT_11;
              }
              INC(Ch);
            } EXIT_11:;
            if (j == GroupCount) {
              goto EXIT_10;
            }
          } EXIT_10:;
          Current->Base = base;
        }
        ScanTabs_BasePtr->A[State] = base;
        ScanTabs_TableSize = General_Max((LONGINT)ScanTabs_TableSize, (LONGINT)base);
        if (State >= B_46) break;
      }
  }
  INC1(ScanTabs_TableSize, ORD(Dfa_OldLastCh));
  DynArray_ReleaseArray((ADDRESS *)&HashTablePtr, &HashTableSize, (LONGINT)sizeof(DiffsInfoPtr));
}

void ScanTabs_WriteTables
# ifdef __STDC__
()
# else
()
# endif
{
  Dfa_DStateRange State;

  IO_WriteS((rSystem_tFile)IO_StdOutput, (STRING)"Tables :", 8L);
  IO_WriteNl((rSystem_tFile)IO_StdOutput);
  IO_WriteNl((rSystem_tFile)IO_StdOutput);
  {
    SHORTINT B_53 = 1, B_54 = Dfa_DStateCount;

    if (B_53 <= B_54)
      for (State = B_53;; State += 1) {
        WriteState(State);
        IO_WriteNl((rSystem_tFile)IO_StdOutput);
        if (State >= B_54) break;
      }
  }
}

void ScanTabs_QueryTables
# ifdef __STDC__
()
# else
()
# endif
{
  Dfa_DStateRange State;

  for (;;) {
    IO_WriteS((rSystem_tFile)IO_StdOutput, (STRING)"State ? ", 8L);
    if (IO_EndOfLine((rSystem_tFile)IO_StdInput)) {
      IO_ReadNl((rSystem_tFile)IO_StdInput);
    }
    State = IO_ReadI((rSystem_tFile)IO_StdInput);
    if (State == 0) {
      goto EXIT_12;
    }
    WriteState(State);
  } EXIT_12:;
}

static void WriteState
# ifdef __STDC__
(Dfa_DStateRange State)
# else
(State)
Dfa_DStateRange State;
# endif
{
  ScanTabs_TableElmt NextState;
  CHAR Ch;
  ScanTabs_ControlType ControlRecord;
  INTEGER Count;

  Count = 0;
  IO_WriteS((rSystem_tFile)IO_StdOutput, (STRING)"State, Default =", 16L);
  IO_WriteI((rSystem_tFile)IO_StdOutput, (LONGINT)State, 5L);
  IO_WriteI((rSystem_tFile)IO_StdOutput, (LONGINT)ScanTabs_DefaultPtr->A[State], 5L);
  IO_WriteNl((rSystem_tFile)IO_StdOutput);
  {
    CHAR B_55 = Dfa_FirstCh, B_56 = Dfa_OldLastCh;

    if (B_55 <= B_56)
      for (Ch = B_55;; Ch += 1) {
        NextState = State;
        for (;;) {
          ControlRecord = ScanTabs_ControlPtr->A[ScanTabs_BasePtr->A[NextState] + ORD(Ch)];
          if (ControlRecord.Check == NextState) {
            NextState = ControlRecord.Next;
            goto EXIT_13;
          }
          NextState = ScanTabs_DefaultPtr->A[NextState];
          NextState = Dfa_DNoState;
          if (NextState == Dfa_DNoState) {
            goto EXIT_13;
          }
        } EXIT_13:;
        if (NextState != Dfa_DNoState) {
          if (Count == 10) {
            IO_WriteNl((rSystem_tFile)IO_StdOutput);
            Count = 0;
          }
          INC(Count);
          Layout_WriteChar((rSystem_tFile)IO_StdOutput, Ch);
          Layout_WriteSpace((rSystem_tFile)IO_StdOutput);
          IO_WriteI((rSystem_tFile)IO_StdOutput, (LONGINT)NextState, 1L);
          IO_WriteC((rSystem_tFile)IO_StdOutput, ',');
          Layout_WriteSpace((rSystem_tFile)IO_StdOutput);
        }
        if (Ch >= B_56) break;
      }
  }
  IO_WriteNl((rSystem_tFile)IO_StdOutput);
}

void BEGIN_ScanTabs()
{
  static BOOLEAN has_been_called = FALSE;
  if (has_been_called) return;
  has_been_called = TRUE;
    BEGIN_IO();
    BEGIN_Checks();
    BEGIN_General();
    BEGIN_rMemory();
    BEGIN_DynArray();
    BEGIN_Strings();
    BEGIN_Idents();
    BEGIN_Sets();
    BEGIN_rSystem();
    BEGIN_IO();
    BEGIN_Layout();
    BEGIN_Dfa();
    BEGIN_GenTabs();
    BEGIN_Classes();
    BEGIN_ScanGen();
    BEGIN_Pack();

    ElmtSize = sizeof(ScanTabs_TableElmt);
}
