#include "SYSTEM_.h"

#ifndef DEFINITION_Checks
#include "Checks.h"
#endif

#ifndef DEFINITION_rSystem
#include "rSystem.h"
#endif

#ifndef DEFINITION_General
#include "General.h"
#endif

#ifndef DEFINITION_Pack
#include "Pack.h"
#endif

#ifndef DEFINITION_Positions
#include "Positions.h"
#endif

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_DynArray
#include "DynArray.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_Source
#include "Source.h"
#endif

#ifndef DEFINITION_rSystem
#include "rSystem.h"
#endif

#ifndef DEFINITION_Strings
#include "Strings.h"
#endif

#ifndef DEFINITION_StringMem
#include "StringMem.h"
#endif

#ifndef DEFINITION_Idents
#include "Idents.h"
#endif

#ifndef DEFINITION_IO
#include "IO.h"
#endif

#ifndef DEFINITION_Scanner
#include "Scanner.h"
#endif

struct Scanner_2 Scanner_InfoFileName;
INTEGER Scanner_TokenLength;
Scanner_tScanAttribute Scanner_Attribute;
PROC Scanner_Exit;

static CHAR MissingInfo [] = "rpp: cannot access file <Scanner>.rpp";
static CARDINAL Level, l;
static Strings_tString StartString;
static Strings_tString TheWord;
static BOOLEAN IsCollecting;
static BOOLEAN BothFlag;
static BOOLEAN Returning;
static Strings_tString InsText;
static IO_tFile InfoFile;
static Idents_tIdent LastIdent;
static struct S_2 {
    SHORTCARD A[1023 + 1];
} TokenCode;
static struct S_3 {
    StringMem_tStringRef A[1023 + 1];
} TokenSelector;
static Strings_tString Not1;
static Strings_tString Any1;
static struct S_4 {
    CHAR A[127 + 1];
} Argument;
static SHORTCARD i;
enum {Modula, C}; 
static unsigned char Language;
static void Skip ARGS(());
static void DoText ARGS(());
static void DoIdent ARGS(());
static void CopyText ARGS(());
static void GenPosition ARGS(());
static void GenScanAttr ARGS(());
static void GenErrorAttr ARGS(());
static void ReadIdents ARGS(());
struct S_17 {
    CHAR A[255 + 1];
};
static void InsertRules ARGS(());
struct S_15 {
    CHAR A[255 + 1];
};
static void WriteIdent ARGS((Strings_tString *TheWord));
struct S_16 {
    CHAR A[255 + 1];
};
#define yyTabSpace	8
#define yyDNoState	0
#define yyFileStackSize	16
#define yyInitBufferSize	(1024 * 8 + 256)
#define yyFirstCh	'\0'
#define yyLastCh	((CHAR)'\177')
#define yyEolCh	'\n'
#define yyEobCh	((CHAR)'\177')
#define yyDStateCount	154
#define yyTableSize	1254
#define yyEobState	132
#define yyDefaultState	133
#define STD	1
#define Return	3
#define Start	5
#define Action	7
#define Rules	9
#define Set	11
typedef SHORTCARD yyTableElmt;
typedef yyTableElmt yyStateRange;
typedef yyTableElmt yyTableRange;
typedef struct S_1 {
    yyStateRange Check, Next;
} yyCombType;
typedef yyCombType *yyCombTypePtr;
typedef struct S_14 {
    CHAR A[1000000 + 1];
} *yytChBufferPtr;
typedef CHAR yyChRange;
static struct S_5 {
    LONGCARD A[yyDStateCount + 1];
} yyBasePtr;
static struct S_6 {
    yyStateRange A[yyDStateCount + 1];
} yyDefault;
static struct S_7 {
    yyCombType A[yyTableSize + 1];
} yyComb;
static struct S_8 {
    yyStateRange A[yyDStateCount + 1];
} yyEobTrans;
static struct S_9 {
    CHAR A[yyLastCh + 1];
} yyToLower, yyToUpper;
static struct S_10 {
    yyStateRange A[1000000 + 1];
} *yyStateStack;
static LONGINT yyStateStackSize;
static yyStateRange yyStartState;
static yyStateRange yyPreviousStart;
static CHAR yyCh;
static BOOLEAN yyIsFirstCall;
static rSystem_tFile yySourceFile;
static BOOLEAN yyEof;
static yytChBufferPtr yyChBufferPtr;
static INTEGER yyChBufferStart;
static LONGINT yyChBufferSize;
static INTEGER yyChBufferIndex;
static INTEGER yyBytesRead;
static CARDINAL yyLineCount;
static INTEGER yyLineStart;
static SHORTCARD yyFileStackPtr;
static struct S_11 {
    struct S_12 {
        rSystem_tFile SourceFile;
        BOOLEAN Eof;
        yytChBufferPtr ChBufferPtr;
        INTEGER ChBufferStart;
        LONGINT ChBufferSize;
        INTEGER ChBufferIndex;
        INTEGER BytesRead;
        CARDINAL LineCount;
        INTEGER LineStart;
    } A[yyFileStackSize - 1 + 1];
} yyFileStack;
static void yyInitialize ARGS(());
static void yyStart ARGS((yyStateRange State));
static void yyPrevious ARGS(());
static void yyEcho ARGS(());
static void yyLess ARGS((INTEGER n));
static void yyTab ARGS(());
static void yyTab1 ARGS((INTEGER a));
static void yyTab2 ARGS((INTEGER a, INTEGER b));
static void yyEol ARGS((INTEGER Column));
static void output ARGS((CHAR c));
static void unput ARGS((CHAR c));
static CHAR input ARGS(());
static CARDINAL yyunpackindex;
static void UnpackBaseHandler ARGS((LONGCARD value));
static void UnpackDefaultHandler ARGS((LONGCARD value));
static void UnpackEobTransHandler ARGS((LONGCARD value));
static void UnpackCombHandler ARGS((LONGCARD value));
static void yyInitTables ARGS(());
static void yyErrorMessage ARGS((SHORTCARD ErrorCode));
static void yyExit ARGS(());

static void Skip
# ifdef __STDC__
()
# else
()
# endif
{
  do {
    Strings_ReadL(InfoFile, &TheWord);
    l = Strings_Length(&TheWord);
  } while (!((l == 2 || l == 3) && Strings_Char(&TheWord, 1) == '%' && Strings_Char(&TheWord, 2) == '%'));
}

static void DoText
# ifdef __STDC__
()
# else
()
# endif
{
  if (!IsCollecting) {
    yyEcho();
  } else if (Level > 0) {
    Scanner_GetWord(&TheWord);
    Strings_Concatenate(&InsText, &TheWord);
  }
}

static void DoIdent
# ifdef __STDC__
()
# else
()
# endif
{
  Idents_tIdent i;

  Scanner_GetWord(&TheWord);
  i = Idents_MakeIdent(&TheWord);
  if (i <= LastIdent) {
    if (Returning) {
      Strings_IntToString((LONGINT)TokenCode.A[i], &TheWord);
    } else {
      StringMem_GetString(TokenSelector.A[i], &TheWord);
    }
    if (IsCollecting) {
      Strings_Concatenate(&InsText, &TheWord);
    } else {
      Strings_WriteS((rSystem_tFile)IO_StdOutput, &TheWord);
    }
  } else {
    if (IsCollecting) {
      Strings_Concatenate(&InsText, &TheWord);
    } else {
      yyEcho();
    }
  }
}

static void CopyText
# ifdef __STDC__
()
# else
()
# endif
{
  for (;;) {
    Strings_ReadL(InfoFile, &TheWord);
    l = Strings_Length(&TheWord);
    if ((l == 2 || l == 3) && Strings_Char(&TheWord, 1) == '%' && Strings_Char(&TheWord, 2) == '%') {
      goto EXIT_1;
    }
    Strings_WriteL((rSystem_tFile)IO_StdOutput, &TheWord);
  } EXIT_1:;
}

static void GenPosition
# ifdef __STDC__
()
# else
()
# endif
{
  switch (Language) {
  case Modula:;
    IO_WriteS((rSystem_tFile)IO_StdOutput, (STRING)"FROM Positions IMPORT tPosition;", 32L);
    break;
  case C:;
    IO_WriteS((rSystem_tFile)IO_StdOutput, (STRING)"# include \"Positions.h\"", 23L);
    break;
  default :
    break;
  }
  IO_WriteNl((rSystem_tFile)IO_StdOutput);
}

static void GenScanAttr
# ifdef __STDC__
()
# else
()
# endif
{
  InfoFile = IO_ReadOpen(Scanner_InfoFileName.A, 256L);
  Strings_ReadL(InfoFile, &TheWord);
  CopyText();
  IO_ReadClose(InfoFile);
}

static void GenErrorAttr
# ifdef __STDC__
()
# else
()
# endif
{
  InfoFile = IO_ReadOpen(Scanner_InfoFileName.A, 256L);
  Skip();
  CopyText();
  IO_ReadClose(InfoFile);
}

static void ReadIdents
# ifdef __STDC__
()
# else
()
# endif
{
  INTEGER t, i;
  CHAR c;
  Idents_tIdent Ident;
  struct S_17 Selector;
  Strings_tString String;

  InfoFile = IO_ReadOpen(Scanner_InfoFileName.A, 256L);
  if (InfoFile < 0) {
    IO_WriteS((rSystem_tFile)IO_StdError, MissingInfo, 37L);
    IO_WriteNl((rSystem_tFile)IO_StdError);
    IO_CloseIO();
    exit(1);
  }
  Strings_ReadL(InfoFile, &TheWord);
  switch (Strings_Char(&TheWord, 1)) {
  case 'm':;
    Language = Modula;
    break;
  case 'c':;
    Language = C;
    break;
  default :
    break;
  }
  Skip();
  Skip();
  while (!IO_EndOfFile(InfoFile)) {
    t = IO_ReadI(InfoFile);
    c = IO_ReadC(InfoFile);
    c = IO_ReadC(InfoFile);
    c = IO_ReadC(InfoFile);
    i = 0;
    do {
      Selector.A[i] = IO_ReadC(InfoFile);
      INC(i);
    } while (!(Selector.A[i - 1] == ' '));
    Selector.A[i - 1] = '\0';
    Strings_ArrayToString(Selector.A, 256L, &String);
    Strings_ReadL(InfoFile, &TheWord);
    Ident = Idents_MakeIdent(&TheWord);
    TokenCode.A[Ident] = t;
    TokenSelector.A[Ident] = StringMem_PutString(&String);
  }
  IO_ReadClose(InfoFile);
  LastIdent = Idents_MaxIdent();
}

static void WriteIdent
# ifdef __STDC__
(Strings_tString *TheWord)
# else
(TheWord)
Strings_tString *TheWord;
# endif
{
  struct S_16 s;
  CARDINAL j;
  BOOLEAN special;

  Strings_StringToArray(TheWord, s.A, 256L);
  s.A[Strings_Length(TheWord)] = '\'';
  if (!BothFlag && (Strings_IsEqual(TheWord, &Not1) || Strings_IsEqual(TheWord, &Any1))) {
    IO_WriteC((rSystem_tFile)IO_StdOutput, '\\');
  }
  special = s.A[0] == '\'' || s.A[0] == '"';
  if (special) {
    j = 1;
  } else {
    j = 0;
  }
  do {
    if (BothFlag) {
      switch (s.A[j]) {
      case 'a':;
      case 'b':;
      case 'c':;
      case 'd':;
      case 'e':;
      case 'f':;
      case 'g':;
      case 'h':;
      case 'i':;
      case 'j':;
      case 'k':;
      case 'l':;
      case 'm':;
      case 'n':;
      case 'o':;
      case 'p':;
      case 'q':;
      case 'r':;
      case 's':;
      case 't':;
      case 'u':;
      case 'v':;
      case 'w':;
      case 'x':;
      case 'y':;
      case 'z':;
        IO_WriteC((rSystem_tFile)IO_StdOutput, '{');
        IO_WriteC((rSystem_tFile)IO_StdOutput, s.A[j]);
        IO_WriteC((rSystem_tFile)IO_StdOutput, CAP(s.A[j]));
        IO_WriteC((rSystem_tFile)IO_StdOutput, '}');
        break;
      case 'A':;
      case 'B':;
      case 'C':;
      case 'D':;
      case 'E':;
      case 'F':;
      case 'G':;
      case 'H':;
      case 'I':;
      case 'J':;
      case 'K':;
      case 'L':;
      case 'M':;
      case 'N':;
      case 'O':;
      case 'P':;
      case 'Q':;
      case 'R':;
      case 'S':;
      case 'T':;
      case 'U':;
      case 'V':;
      case 'W':;
      case 'X':;
      case 'Y':;
      case 'Z':;
        IO_WriteC((rSystem_tFile)IO_StdOutput, '{');
        IO_WriteC((rSystem_tFile)IO_StdOutput, CHR(ORD(s.A[j]) - ORD('A') + ORD('a')));
        IO_WriteC((rSystem_tFile)IO_StdOutput, s.A[j]);
        IO_WriteC((rSystem_tFile)IO_StdOutput, '}');
        break;
      case '0':;
      case '1':;
      case '2':;
      case '3':;
      case '4':;
      case '5':;
      case '6':;
      case '7':;
      case '8':;
      case '9':;
      case '_':;
        IO_WriteC((rSystem_tFile)IO_StdOutput, s.A[j]);
        break;
      default :
        IO_WriteC((rSystem_tFile)IO_StdOutput, '\\');
        IO_WriteC((rSystem_tFile)IO_StdOutput, s.A[j]);
        break;
      }
    } else {
      if (special) {
        switch (s.A[j]) {
        case '0':;
        case '1':;
        case '2':;
        case '3':;
        case '4':;
        case '5':;
        case '6':;
        case '7':;
        case '8':;
        case '9':;
        case 'n':;
        case 't':;
        case 'v':;
        case 'b':;
        case 'r':;
        case 'f':;
          IO_WriteC((rSystem_tFile)IO_StdOutput, '"');
          IO_WriteC((rSystem_tFile)IO_StdOutput, s.A[j]);
          IO_WriteC((rSystem_tFile)IO_StdOutput, '"');
          break;
        default :
          IO_WriteC((rSystem_tFile)IO_StdOutput, '\\');
          IO_WriteC((rSystem_tFile)IO_StdOutput, s.A[j]);
          break;
        }
      } else {
        switch (s.A[j]) {
        case '0':;
        case '1':;
        case '2':;
        case '3':;
        case '4':;
        case '5':;
        case '6':;
        case '7':;
        case '8':;
        case '9':;
        case 'A':;
        case 'B':;
        case 'C':;
        case 'D':;
        case 'E':;
        case 'F':;
        case 'G':;
        case 'H':;
        case 'I':;
        case 'J':;
        case 'K':;
        case 'L':;
        case 'M':;
        case 'N':;
        case 'O':;
        case 'P':;
        case 'Q':;
        case 'R':;
        case 'S':;
        case 'T':;
        case 'U':;
        case 'V':;
        case 'W':;
        case 'X':;
        case 'Y':;
        case 'Z':;
        case 'a':;
        case 'b':;
        case 'c':;
        case 'd':;
        case 'e':;
        case 'f':;
        case 'g':;
        case 'h':;
        case 'i':;
        case 'j':;
        case 'k':;
        case 'l':;
        case 'm':;
        case 'n':;
        case 'o':;
        case 'p':;
        case 'q':;
        case 'r':;
        case 's':;
        case 't':;
        case 'u':;
        case 'v':;
        case 'w':;
        case 'x':;
        case 'y':;
        case 'z':;
        case '_':;
          IO_WriteC((rSystem_tFile)IO_StdOutput, s.A[j]);
          break;
        default :
          IO_WriteC((rSystem_tFile)IO_StdOutput, '\\');
          IO_WriteC((rSystem_tFile)IO_StdOutput, s.A[j]);
          break;
        }
      }
    }
    INC(j);
  } while (!(s.A[j] == '"' || s.A[j] == '\''));
}

static void InsertRules
# ifdef __STDC__
()
# else
()
# endif
{
  CARDINAL Code;
  CHAR c, Ch;
  struct S_15 Selector;
  CARDINAL i;

  InfoFile = IO_ReadOpen(Scanner_InfoFileName.A, 256L);
  Skip();
  Skip();
  while (!IO_EndOfFile(InfoFile)) {
    Code = IO_ReadI(InfoFile);
    c = IO_ReadC(InfoFile);
    Ch = IO_ReadC(InfoFile);
    c = IO_ReadC(InfoFile);
    i = 0;
    do {
      Selector.A[i] = IO_ReadC(InfoFile);
      INC(i);
    } while (!(Selector.A[i - 1] == ' '));
    Selector.A[i - 1] = '\0';
    Strings_ReadL(InfoFile, &TheWord);
    if (Ch != 'S') {
      Strings_WriteS((rSystem_tFile)IO_StdOutput, &StartString);
      WriteIdent(&TheWord);
      IO_WriteC((rSystem_tFile)IO_StdOutput, '\t');
      IO_WriteS((rSystem_tFile)IO_StdOutput, (STRING)": { ", 4L);
      Strings_WriteS((rSystem_tFile)IO_StdOutput, &InsText);
      switch (Language) {
      case Modula:;
        IO_WriteS((rSystem_tFile)IO_StdOutput, (STRING)"RETURN ", 7L);
        break;
      case C:;
        IO_WriteS((rSystem_tFile)IO_StdOutput, (STRING)"return ", 7L);
        break;
      }
      IO_WriteI((rSystem_tFile)IO_StdOutput, (LONGINT)Code, 0L);
      IO_WriteS((rSystem_tFile)IO_StdOutput, (STRING)"; }", 3L);
      IO_WriteNl((rSystem_tFile)IO_StdOutput);
    }
  }
  IO_ReadClose(InfoFile);
}

INTEGER Scanner_GetToken
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange yyState;
  yyCombTypePtr yyTablePtr;
  BOOLEAN yyRestart;
  INTEGER yyi, yySource, yyTarget, yyChBufferFree;

  for (;;) {
    yyState = yyStartState;
    Scanner_TokenLength = 0;
    for (;;) {
      for (;;) {
        yyTablePtr = (yyCombTypePtr)(yyBasePtr.A[yyState] + ORD(yyChBufferPtr->A[yyChBufferIndex]) * sizeof(yyCombType));
        if (yyTablePtr->Check != yyState) {
          yyState = yyDefault.A[yyState];
          if (yyState == yyDNoState) {
            goto EXIT_4;
          }
        } else {
          yyState = yyTablePtr->Next;
          INC(Scanner_TokenLength);
          yyStateStack->A[Scanner_TokenLength] = yyState;
          INC(yyChBufferIndex);
        }
      } EXIT_4:;
      for (;;) {
        switch (yyStateStack->A[Scanner_TokenLength]) {
        case 154:;
          yyStart(Action);
          yyEcho();
          Level = 1;
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 29:;
          yyStart(Rules);
          yyEcho();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 19:;
          DoText();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 17:;
          yyStart(Start);
          BothFlag = FALSE;
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 18:;
          yyStart(Start);
          BothFlag = TRUE;
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 15:;
        case 39:;
          yyStart(Action);
          yyEcho();
          Level = 0;
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 153:;
          yyStart(Set);
          yyEcho();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 152:;
          yyPrevious();
          yyEcho();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 151:;
          yyPrevious();
          InsertRules();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 24:;
          yyPrevious();
          Scanner_GetWord(&StartString);
          InsertRules();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 25:;
          while (yyStateStack->A[Scanner_TokenLength] != 24) {
            DEC(yyChBufferIndex);
            DEC(Scanner_TokenLength);
          }
          Scanner_GetWord(&StartString);
          yyStartState = Action;
          Level = 0;
          IsCollecting = TRUE;
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 26:;
          DEC1(yyChBufferIndex, 1);
          DEC1(Scanner_TokenLength, 1);
          yyStartState = Action;
          Level = 0;
          IsCollecting = TRUE;
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 22:;
          GenPosition();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 21:;
          GenScanAttr();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 23:;
          GenErrorAttr();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 150:;
          DoText();
          INC(Level);
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 149:;
          DEC(Level);
          if (Level > 0) {
            DoText();
          } else {
            yyPrevious();
            if (IsCollecting) {
              InsertRules();
              IsCollecting = FALSE;
            } else {
              yyEcho();
            }
          }
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 148:;
          yyStartState = Return;
          DoText();
          Returning = FALSE;
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 20:;
          yyStartState = Return;
          DoText();
          Returning = TRUE;
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 27:;
          yyStartState = Action;
          DoIdent();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 28:;
          yyStartState = Action;
          DoIdent();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 13:;
        case 30:;
        case 31:;
        case 32:;
        case 33:;
        case 34:;
        case 35:;
        case 36:;
        case 37:;
        case 48:;
        case 49:;
        case 65:;
        case 116:;
        case 117:;
        case 130:;
        case 135:;
        case 136:;
        case 137:;
        case 138:;
        case 139:;
          DoText();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 14:;
        case 38:;
          DoText();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 134:;
          DoText();
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 1:;
        case 2:;
        case 3:;
        case 4:;
        case 5:;
        case 6:;
        case 7:;
        case 8:;
        case 9:;
        case 10:;
        case 11:;
        case 12:;
        case 16:;
        case 40:;
        case 41:;
        case 42:;
        case 43:;
        case 44:;
        case 45:;
        case 46:;
        case 47:;
        case 50:;
        case 51:;
        case 52:;
        case 53:;
        case 54:;
        case 55:;
        case 56:;
        case 57:;
        case 58:;
        case 59:;
        case 60:;
        case 61:;
        case 62:;
        case 63:;
        case 64:;
        case 66:;
        case 67:;
        case 68:;
        case 69:;
        case 70:;
        case 71:;
        case 72:;
        case 73:;
        case 74:;
        case 75:;
        case 76:;
        case 77:;
        case 78:;
        case 79:;
        case 80:;
        case 81:;
        case 82:;
        case 83:;
        case 84:;
        case 85:;
        case 86:;
        case 87:;
        case 88:;
        case 89:;
        case 90:;
        case 91:;
        case 92:;
        case 93:;
        case 94:;
        case 95:;
        case 96:;
        case 97:;
        case 98:;
        case 99:;
        case 100:;
        case 101:;
        case 102:;
        case 103:;
        case 104:;
        case 105:;
        case 106:;
        case 107:;
        case 108:;
        case 109:;
        case 110:;
        case 111:;
        case 112:;
        case 113:;
        case 114:;
        case 115:;
        case 118:;
        case 119:;
        case 120:;
        case 121:;
        case 122:;
        case 123:;
        case 124:;
        case 125:;
        case 126:;
        case 127:;
        case 128:;
        case 129:;
        case 131:;
        case 140:;
        case 141:;
        case 142:;
        case 143:;
        case 144:;
        case 145:;
        case 146:;
        case 147:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          break;
        case 133:;
          Scanner_Attribute.Position.Line = yyLineCount;
          Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
          INC(yyChBufferIndex);
          Scanner_TokenLength = 1;
          IO_WriteC((rSystem_tFile)IO_StdOutput, yyChBufferPtr->A[yyChBufferIndex - 1]);
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case yyDNoState:;
          yyRestart = FALSE;
          goto EXIT_5;
          break;
        case 132:;
          DEC(yyChBufferIndex);
          DEC(Scanner_TokenLength);
          if (Scanner_TokenLength == 0) {
            yyState = yyStartState;
          } else {
            yyState = yyStateStack->A[Scanner_TokenLength];
          }
          if (yyChBufferIndex != yyChBufferStart + yyBytesRead) {
            yyState = yyEobTrans.A[yyState];
            if (yyState != yyDNoState) {
              INC(yyChBufferIndex);
              INC(Scanner_TokenLength);
              yyStateStack->A[Scanner_TokenLength] = yyState;
              yyRestart = TRUE;
              goto EXIT_5;
            }
          } else {
            yySource = yyChBufferIndex - Scanner_TokenLength - 1;
            yyTarget = General_MaxAlign - Scanner_TokenLength % General_MaxAlign - 1;
            if (yySource != yyTarget) {
              {
                LONGINT B_1 = 1, B_2 = Scanner_TokenLength;

                if (B_1 <= B_2)
                  for (yyi = B_1;; yyi += 1) {
                    yyChBufferPtr->A[yyTarget + yyi] = yyChBufferPtr->A[yySource + yyi];
                    if (yyi >= B_2) break;
                  }
              }
              DEC1(yyLineStart, yySource - yyTarget);
              yyChBufferStart = yyTarget + Scanner_TokenLength + 1;
            } else {
              yyChBufferStart = yyChBufferIndex;
            }
            if (!yyEof) {
              yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
              if (yyChBufferFree < yyChBufferSize / 8) {
                DynArray_ExtendArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
                if (yyChBufferPtr == NIL) {
                  yyErrorMessage(1);
                }
                yyChBufferFree = General_Exp2(General_Log2(yyChBufferSize - 4 - General_MaxAlign - Scanner_TokenLength));
                if (yyStateStackSize < yyChBufferSize) {
                  DynArray_ExtendArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
                  if (yyStateStack == NIL) {
                    yyErrorMessage(1);
                  }
                }
              }
              yyChBufferIndex = yyChBufferStart;
              yyBytesRead = Source_GetLine(yySourceFile, ADR(yyChBufferPtr->A[yyChBufferIndex]), (LONGCARD)yyChBufferFree);
              if (yyBytesRead <= 0) {
                yyBytesRead = 0;
                yyEof = TRUE;
              }
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead] = yyEobCh;
              yyChBufferPtr->A[yyChBufferStart + yyBytesRead + 1] = '\0';
              yyRestart = TRUE;
              goto EXIT_5;
            }
            if (Scanner_TokenLength == 0) {
              Scanner_Attribute.Position.Line = yyLineCount;
              Scanner_Attribute.Position.Column = yyChBufferIndex - yyLineStart;
              Scanner_CloseFile();
              if (yyFileStackPtr == 0) {
              }
              if (yyFileStackPtr == 0) {
                return Scanner_EofToken;
              }
              yyRestart = FALSE;
              goto EXIT_5;
            }
          }
          break;
        default :
          yyErrorMessage(0);
          break;
        }
      } EXIT_5:;
      if (yyRestart) {
      } else {
        goto EXIT_3;
      }
    } EXIT_3:;
  } EXIT_2:;
}

void Scanner_BeginFile
# ifdef __STDC__
(CHAR FileName[], LONGCARD O_1)
# else
(FileName, O_1)
CHAR FileName[];
LONGCARD O_1;
# endif
{
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_1 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(FileName, O_1, CHAR)
  if (yyIsFirstCall) {
    yyFileStackPtr = 0;
    yyIsFirstCall = FALSE;
  }
  yyInitialize();
  yySourceFile = Source_BeginSource(FileName, O_1);
  if (yySourceFile < 0) {
    yyErrorMessage(5);
  }
  FREE_OPEN_ARRAYS
}

static void yyInitialize
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr >= yyFileStackSize) {
    yyErrorMessage(3);
  }
  INC(yyFileStackPtr);
  {
    register struct S_12 *W_1 = &yyFileStack.A[yyFileStackPtr - 1];

    W_1->SourceFile = yySourceFile;
    W_1->Eof = yyEof;
    W_1->ChBufferPtr = yyChBufferPtr;
    W_1->ChBufferStart = yyChBufferStart;
    W_1->ChBufferSize = yyChBufferSize;
    W_1->ChBufferIndex = yyChBufferIndex;
    W_1->BytesRead = yyBytesRead;
    W_1->LineCount = yyLineCount;
    W_1->LineStart = yyLineStart;
  }
  yyChBufferSize = yyInitBufferSize;
  DynArray_MakeArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  if (yyChBufferPtr == NIL) {
    yyErrorMessage(1);
  }
  yyChBufferStart = General_MaxAlign;
  yyChBufferPtr->A[yyChBufferStart - 1] = yyEolCh;
  yyChBufferPtr->A[yyChBufferStart] = yyEobCh;
  yyChBufferPtr->A[yyChBufferStart + 1] = '\0';
  yyChBufferIndex = yyChBufferStart;
  yyEof = FALSE;
  yyBytesRead = 0;
  yyLineCount = 1;
  yyLineStart = yyChBufferStart - 1;
}

void Scanner_CloseFile
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyFileStackPtr == 0) {
    yyErrorMessage(4);
  }
  Source_CloseSource(yySourceFile);
  DynArray_ReleaseArray((ADDRESS *)&yyChBufferPtr, &yyChBufferSize, (LONGINT)sizeof(CHAR));
  {
    register struct S_12 *W_2 = &yyFileStack.A[yyFileStackPtr - 1];

    yySourceFile = W_2->SourceFile;
    yyEof = W_2->Eof;
    yyChBufferPtr = W_2->ChBufferPtr;
    yyChBufferStart = W_2->ChBufferStart;
    yyChBufferSize = W_2->ChBufferSize;
    yyChBufferIndex = W_2->ChBufferIndex;
    yyBytesRead = W_2->BytesRead;
    yyLineCount = W_2->LineCount;
    yyLineStart = W_2->LineStart;
  }
  DEC(yyFileStackPtr);
}

void Scanner_GetWord
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_3 = 1, B_4 = Scanner_TokenLength;

    if (B_3 <= B_4)
      for (i = B_3;; i += 1) {
        Word->Chars.A[i] = yyChBufferPtr->A[WordStart + i];
        if (i >= B_4) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetLower
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_5 = 1, B_6 = Scanner_TokenLength;

    if (B_5 <= B_6)
      for (i = B_5;; i += 1) {
        Word->Chars.A[i] = yyToLower.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_6) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

void Scanner_GetUpper
# ifdef __STDC__
(Strings_tString *Word)
# else
(Word)
Strings_tString *Word;
# endif
{
  INTEGER i, WordStart;

  WordStart = yyChBufferIndex - Scanner_TokenLength - 1;
  {
    LONGINT B_7 = 1, B_8 = Scanner_TokenLength;

    if (B_7 <= B_8)
      for (i = B_7;; i += 1) {
        Word->Chars.A[i] = yyToUpper.A[yyChBufferPtr->A[WordStart + i]];
        if (i >= B_8) break;
      }
  }
  Word->Length = Scanner_TokenLength;
}

static void yyStart
# ifdef __STDC__
(yyStateRange State)
# else
(State)
yyStateRange State;
# endif
{
  yyPreviousStart = yyStartState;
  yyStartState = State;
}

static void yyPrevious
# ifdef __STDC__
()
# else
()
# endif
{
  yyStateRange s;

  s = yyStartState;
  yyStartState = yyPreviousStart;
  yyPreviousStart = s;
}

static void yyEcho
# ifdef __STDC__
()
# else
()
# endif
{
  INTEGER i;

  {
    LONGINT B_9 = yyChBufferIndex - Scanner_TokenLength, B_10 = yyChBufferIndex - 1;

    if (B_9 <= B_10)
      for (i = B_9;; i += 1) {
        IO_WriteC((rSystem_tFile)IO_StdOutput, yyChBufferPtr->A[i]);
        if (i >= B_10) break;
      }
  }
}

static void yyLess
# ifdef __STDC__
(INTEGER n)
# else
(n)
INTEGER n;
# endif
{
  DEC1(yyChBufferIndex, Scanner_TokenLength - n);
  Scanner_TokenLength = n;
}

static void yyTab
# ifdef __STDC__
()
# else
()
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - 2) % yyTabSpace);
}

static void yyTab1
# ifdef __STDC__
(INTEGER a)
# else
(a)
INTEGER a;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyTab2
# ifdef __STDC__
(INTEGER a, INTEGER b)
# else
(a, b)
INTEGER a, b;
# endif
{
  DEC1(yyLineStart, yyTabSpace - 1 - (yyChBufferIndex - yyLineStart - Scanner_TokenLength + a - 1) % yyTabSpace);
}

static void yyEol
# ifdef __STDC__
(INTEGER Column)
# else
(Column)
INTEGER Column;
# endif
{
  INC(yyLineCount);
  yyLineStart = yyChBufferIndex - 1 - Column;
}

static void output
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  IO_WriteC((rSystem_tFile)IO_StdOutput, c);
}

static void unput
# ifdef __STDC__
(CHAR c)
# else
(c)
CHAR c;
# endif
{
  DEC(yyChBufferIndex);
  yyChBufferPtr->A[yyChBufferIndex] = c;
}

static CHAR input
# ifdef __STDC__
()
# else
()
# endif
{
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    if (!yyEof) {
      DEC1(yyLineStart, yyBytesRead);
      yyChBufferIndex = 0;
      yyChBufferStart = 0;
      yyBytesRead = Source_GetLine(yySourceFile, (ADDRESS)yyChBufferPtr, (LONGCARD)General_Exp2(General_Log2(yyChBufferSize)));
      if (yyBytesRead <= 0) {
        yyBytesRead = 0;
        yyEof = TRUE;
      }
      yyChBufferPtr->A[yyBytesRead] = yyEobCh;
      yyChBufferPtr->A[yyBytesRead + 1] = '\0';
    }
  }
  if (yyChBufferIndex == yyChBufferStart + yyBytesRead) {
    return '\0';
  } else {
    INC(yyChBufferIndex);
    return yyChBufferPtr->A[yyChBufferIndex - 1];
  }
}

void Scanner_BeginScanner
# ifdef __STDC__
()
# else
()
# endif
{
  (void)strncpy((char *)Scanner_InfoFileName.A, "Scanner.rpp", sizeof(Scanner_InfoFileName.A));
  Language = Modula;
  if (GetArgCount() > 1) {
    GetArgument(1L, Scanner_InfoFileName.A, 256L);
  }
  IsCollecting = FALSE;
  Idents_InitIdents();
  ReadIdents();
  Strings_AssignEmpty(&InsText);
  Strings_AssignEmpty(&StartString);
  Strings_ArrayToString((STRING)"NOT", 3L, &Not1);
  Strings_ArrayToString((STRING)"ANY", 3L, &Any1);
}

void Scanner_CloseScanner
# ifdef __STDC__
()
# else
()
# endif
{
}

static void UnpackBaseHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyBasePtr.A[yyunpackindex] = (LONGCARD)ADR(yyComb.A[value]);
  INC(yyunpackindex);
}

static void UnpackDefaultHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyDefault.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackEobTransHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  yyEobTrans.A[yyunpackindex] = value;
  INC(yyunpackindex);
}

static void UnpackCombHandler
# ifdef __STDC__
(LONGCARD value)
# else
(value)
LONGCARD value;
# endif
{
  if (!ODD(yyunpackindex)) {
    yyComb.A[yyunpackindex / 2].Check = value;
  } else {
    yyComb.A[yyunpackindex / 2].Next = value;
  }
  INC(yyunpackindex);
}

static void yyInitTables
# ifdef __STDC__
()
# else
()
# endif
{
  Pack_UnpackCardHandler hc;

  hc = UnpackBaseHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"++WS+-+XP+XS+W-++V4++/++++++V9++ZK++]H`I+,+++V31+cJV:V7", 55L, 42L);
  Pack_UnpackCard(hc, (STRING)"WSWHWT-.fKVB+iL34/-5X+WLX,,WE.41lM++7<=?WJ6X.:>@AGWIX/B", 55L, 40L);
  Pack_UnpackCard(hc, (STRING)"CDW;WNWKWCWFWBW34W=1XB-.W:.W9,-.0WAW@01WBWIX+XBX=X>X@oN", 55L, 34L);
  Pack_UnpackCard(hc, (STRING)"YQYRYFYSY:Y+XOXGXFXG-YMYAYGXD+++++++XPXQY+Y5Y=Y+Y.YJ+++", 55L, 33L);
  Pack_UnpackCard(hc, (STRING)"+++++", 5L, 5L);
  hc = UnpackDefaultHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"J,F.J0J2J4J6PQ+PP++++++P++P++PP9PPPP+PPPV2++++V.V.V2+V1", 55L, 50L);
  Pack_UnpackCard(hc, (STRING)"V2V2V2VEV9V2+++V<+V-V-V.TVBVBV2V;V;V>+VI+V>V>V>V>V-++VR", 55L, 32L);
  Pack_UnpackCard(hc, (STRING)"VRVR+++++++W,+W4+W6W6+W9+W;W;W;W;++W2W2W2W2W4W9WAWAW2VR", 55L, 34L);
  Pack_UnpackCard(hc, (STRING)"++WL+X0X0X0X0X0X0X0X0X0X0+++X0V2KV2KPX0X0X0X0X0X0X0X0+P", 55L, 33L);
  Pack_UnpackCard(hc, (STRING)"PX3PPP", 6L, 5L);
  hc = UnpackEobTransHandler;
  yyunpackindex = 1;
  Pack_UnpackCard(hc, (STRING)"PPPPPPPPPPPP+++++++++++++++++V4P++++++++S+++++++V3+V3V4", 55L, 51L);
  Pack_UnpackCard(hc, (STRING)"+++++++++++++VCVCVC++++++++++++++++++++++++++++++++++++", 55L, 52L);
  Pack_UnpackCard(hc, (STRING)"++++++++++++S++++++++++++++++++++++++++++++++++++++", 51L, 51L);
  hc = UnpackCombHandler;
  yyunpackindex = 0;
  Pack_UnpackCard(hc, (STRING)"++++++++++++++++++,X4,X30X50XD<V6++QQ++V5V5V6V6V9V8++VE", 55L, 43L);
  Pack_UnpackCard(hc, (STRING)"V7++++++++++++++++++++,X6++0X7VCC<V60VBQQV3GV5V5V6V6V9V8", 56L, 43L);
  Pack_UnpackCard(hc, (STRING)"V5VDVEV7R:X@XA++++++++++++++++++++++++++99++++++++CTTTX,", 56L, 49L);
  Pack_UnpackCard(hc, (STRING)"WJ,WL;HLVSV/=V0V+V7W>V2QVAVPV6WMV=;MV>NVK0NV??,O99V8VQO", 55L, 36L);
  Pack_UnpackCard(hc, (STRING)"V=9VDV@VNCTTTVFW.VGV-,JVJV?0J6X46X3V2QVL<V+V;VHWG8WCVMV0", 56L, 35L);
  Pack_UnpackCard(hc, (STRING)"VHW1VNVAVOWOVPVOVSW-VTVFW+V9W3@W5W:W7V,W8?W:W6W<X,W=W9W>", 56L, 29L);
  Pack_UnpackCard(hc, (STRING)"W=6X6W?W8V7VHWBW;WCWA,XG.P.P.P.P.P.P.P.P.P.X4.X3.P.P.P.", 55L, 42L);
  Pack_UnpackCard(hc, (STRING)"P.P.P.P.P.P.P.P.P.P.P.P.P.P.P.P.P.P.X6.P.I.P.P.P.P.V1.P", 55L, 53L);
  Pack_UnpackCard(hc, (STRING)".P.P.P.P.P.P.P2X42X39E4X44X3PX16JCDTDV+X1.P.P.P.P.P.P.P", 55L, 48L);
  Pack_UnpackCard(hc, (STRING)"V,X+V;V@V-;V2X1V>X-V.VI2X6V:VGVIW+4X6VQV<4WKW,BW.V/V<WN", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)"W-VJW/W7W1W/W4WQW2W,W0WHW9W<6XEW;WRVKV5VRVE.P.J.P.PW2X1", 55L, 32L);
  Pack_UnpackCard(hc, (STRING)".PW@WFWAW?WDW54RW;X1W9X1W,X12X8W4X1WEW3WFWDWAX1W@X1W1X1", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)"W/X12MV>X1W0X14X/V-X1VQX1VIX1W.X1V;X12LW-X1.P.P.P.PV,X1", 55L, 34L);
  Pack_UnpackCard(hc, (STRING)"V.X1V:X1V<X12JVKX1VRX14JW6AWGW@WHWEWIW2WJWTWNVLWPVRWQWI", 55L, 30L);
  Pack_UnpackCard(hc, (STRING)"WRW0WSW4WTWSX+WBX-WPWMVMX.V.X/X.WLV:W6X128X0X1X8X9X9X:WO", 56L, 29L);
  Pack_UnpackCard(hc, (STRING)"VTX:X;X;X<X<X=X=X>2XCX>X?2XB4XFFFFFFFFFFFFFFFFFFFFFX?X@", 55L, 39L);
  Pack_UnpackCard(hc, (STRING)"++++++++++++FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"FFFFFFFFFWLX1WMX1WOX1++FF++FFFFFFFFFFFFFFFFFFFFFFFFFFFF", 55L, 49L);
  Pack_UnpackCard(hc, (STRING)"FFFFFFFFFFFFFFFFFFFFFFFFIV4IV4IV4IV4IV4IV4IV4IV4IV4IV4+", 55L, 45L);
  Pack_UnpackCard(hc, (STRING)"+IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"IV4IV4IV4IV4IV4++IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4", 56L, 38L);
  Pack_UnpackCard(hc, (STRING)"IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4I", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"V4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)"IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4I", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"V4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4IV4", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)"IV4IV4IV4IV4IV4JPJPJPJPJPJPJPJPJPJP++JPJPJPJPJPJPJPJPJP", 55L, 50L);
  Pack_UnpackCard(hc, (STRING)"JPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"PJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJP", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"JPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJ", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"PJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPJPSSSSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"SSSSSSSSSSSSSS++SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"SSSSSSSS>SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS", 55L, 55L);
  Pack_UnpackCard(hc, (STRING)"SSSSSSSSSSSSSSSSSSSSSSSSSSSSV1V3V1V3V1V3V1V3V1V3V1V3V1V3", 56L, 42L);
  Pack_UnpackCard(hc, (STRING)"V1V3V1V3V1V3++V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1", 56L, 29L);
  Pack_UnpackCard(hc, (STRING)"V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V3V1V3V1V3V1V3++V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3", 56L, 29L);
  Pack_UnpackCard(hc, (STRING)"V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3V1V3", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V1V3V1V3V1V3V1V3V1V3V1V3V1V3V4V4V4V4V4V4V4V4V4V4V4V4V4V4", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V4V4V4V4V4V4++V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4", 56L, 29L);
  Pack_UnpackCard(hc, (STRING)"V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4GV4", 55L, 28L);
  Pack_UnpackCard(hc, (STRING)"V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"V4V4V4V4V4V4V4V4V4V4V4V4V4V4V4VBVCVBVCVBVCVBVCVBVCVBVCVB", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"VCVBVCVBVCVBVC++VBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVC", 56L, 29L);
  Pack_UnpackCard(hc, (STRING)"VBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVC", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"++VBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVB", 56L, 29L);
  Pack_UnpackCard(hc, (STRING)"VCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVB", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"VCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVB", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"VCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVB", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"VCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVB", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"VCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVBVCVB", 56L, 28L);
  Pack_UnpackCard(hc, (STRING)"VCVBVCVBVCVBVCVBVCVBVCVBVCVBVCWKSWKSWKSWKSWKSWKSWKSWKSWK", 56L, 32L);
  Pack_UnpackCard(hc, (STRING)"SWKS++WKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWK", 56L, 38L);
  Pack_UnpackCard(hc, (STRING)"SWKSWKSWKSWKSWKSWKS++WKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWK", 56L, 38L);
  Pack_UnpackCard(hc, (STRING)"SWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKS", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"WKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWK", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)"SWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKS", 55L, 37L);
  Pack_UnpackCard(hc, (STRING)"WKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWKSWK", 56L, 37L);
  Pack_UnpackCard(hc, (STRING)"SWKSWKSWKSWKSWKSWKS++", 21L, 15L);
}

static void yyErrorMessage
# ifdef __STDC__
(SHORTCARD ErrorCode)
# else
(ErrorCode)
SHORTCARD ErrorCode;
# endif
{
  Positions_WritePosition((rSystem_tFile)IO_StdError, Scanner_Attribute.Position);
  switch (ErrorCode) {
  case 0:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: internal error", 25L);
    break;
  case 1:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: out of memory", 24L);
    break;
  case 3:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: too many nested include files", 40L);
    break;
  case 4:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: file stack underflow (too many calls of CloseFile)", 61L);
    break;
  case 5:;
    IO_WriteS((rSystem_tFile)IO_StdError, (STRING)": Scanner: cannot open input file", 33L);
    break;
  }
  IO_WriteNl((rSystem_tFile)IO_StdError);
  (*Scanner_Exit)();
}

static void yyExit
# ifdef __STDC__
()
# else
()
# endif
{
  IO_CloseIO();
  rExit(1L);
}

void BEGIN_Scanner()
{
  static BOOLEAN has_been_called = FALSE;
  if (has_been_called) return;
  has_been_called = TRUE;
    BEGIN_Strings();
    BEGIN_Positions();
    BEGIN_Checks();
    BEGIN_rSystem();
    BEGIN_General();
    BEGIN_Pack();
    BEGIN_Positions();
    BEGIN_IO();
    BEGIN_DynArray();
    BEGIN_Strings();
    BEGIN_Source();
    BEGIN_rSystem();
    BEGIN_Strings();
    BEGIN_StringMem();
    BEGIN_Idents();
    BEGIN_IO();

    Scanner_Exit = yyExit;
    yyIsFirstCall = TRUE;
    yyFileStackPtr = 0;
    yyInitialize();
    yySourceFile = rSystem_StdInput;
    yyStartState = STD;
    yyPreviousStart = STD;
    yyStateStackSize = yyInitBufferSize;
    DynArray_MakeArray((ADDRESS *)&yyStateStack, &yyStateStackSize, (LONGINT)sizeof(yyStateRange));
    yyStateStack->A[0] = yyDefaultState;
    yyInitTables();
    for (yyCh = yyFirstCh; yyCh <= yyLastCh; yyCh += 1) {
      yyToLower.A[yyCh] = yyCh;
    }
    yyToUpper = yyToLower;
    for (yyCh = 'A'; yyCh <= 'Z'; yyCh += 1) {
      yyToLower.A[yyCh] = CHR(ORD(yyCh) - ORD('A') + ORD('a'));
    }
    for (yyCh = 'a'; yyCh <= 'z'; yyCh += 1) {
      yyToUpper.A[yyCh] = CHR(ORD(yyCh) - ORD('a') + ORD('A'));
    }
}
